var plugin = {},
    plugins = require('../../pluginManager.js'),
	countlyConfig = require('../../../frontend/express/config', 'dont-enclose');

(function (plugin) {
	plugin.init = function(app, countlyDb){
		app.get(countlyConfig.path+'/at/*', function(req, res) {
			var parts = req.path.split("/");
			var code = parts[parts.length-1];
            var link = "/i/campaign/click/"+code;
            var url = req.query.url;
            if(req.query && req.query.url){
                delete req.query.url;
            }
            var segments = {};
            for(var i in req.query){
                segments[i] = req.query[i];
            }
            if(url || Object.keys(segments).length){
                link += "?";
                if(url)
                    link = link+"url="+url+"&";
                if(Object.keys(segments).length)
                    link = link+"segments="+JSON.stringify(segments);
            }
			res.redirect(link);
		});
		app.get(countlyConfig.path+'/campaign/ios/*', function(req, res) {
			res.render('../../../plugins/attribution/frontend/public/templates/ios', {path:countlyConfig.path || "", cdn:countlyConfig.cdn || "", url:req.query.url, scheme:req.query.scheme});
		});
		app.get(countlyConfig.path+'/campaign/android/*', function(req, res) {
			res.render('../../../plugins/attribution/frontend/public/templates/android', {path:countlyConfig.path || "", cdn:countlyConfig.cdn || "", url:req.query.url, scheme:req.query.scheme});
		});
	};
    
    plugin.renderDashboard = function(ob){
        ob.res.expose({custom_links: plugins.getConfig("attribution").custom_links}, 'countlyAttributionConfig');
    };
}(plugin));

module.exports = plugin;