(function (countlyAttribution, $, undefined) {

    //Private Properties
    var _data = {},
		_datas = {},
        _list = {},
		_campaignData = {},
		_period = {},
		_periodObj = {},
		_metas = {},
        _id = null,
        _appId = "",
        _selected = {},
        _selectCount = 0,
        _forceDataReload = false,
        _hasAdwordsCampaign = false;
        
    countlyAttribution.loadList = function (id) {
        $.ajax({
            type:"GET",
            url:countlyCommon.API_PARTS.data.r+"/campaign",
            data:{
                "api_key":countlyGlobal.member.api_key,
                "app_id":id,
                "list":1
            },
            dataType:"json",
            success:function (json) {
                for(var i = 0; i < json.length; i++){
                    _list[json[i]._id] = json[i].name;
                }
            }
        });
    };
    if(countlyGlobal.member && countlyGlobal.member.api_key){
        countlyAttribution.loadList(countlyCommon.ACTIVE_APP_ID);
    }

    //Public Methods
    countlyAttribution.initialize = function (id, filter) {
        _id = id;
        if(_appId != countlyCommon.ACTIVE_APP_ID){
            _appId = countlyCommon.ACTIVE_APP_ID;
            countlyAttribution.reset(true);
        }
        else{
            countlyAttribution.reset();
        }
		_period = countlyCommon.getPeriodForAjax();
		if(id){
			return $.ajax({
				type:"GET",
				url:countlyCommon.API_PARTS.data.r+"/campaign",
				data:{
					"api_key":countlyGlobal.member.api_key,
					"period":_period,
					"app_id":countlyCommon.ACTIVE_APP_ID,
					"camp_id":id
				},
				success:function (json) {
					_data = json;
                    _list[_data._id] = _data.name;
					_campaignData = _data.data;
					setMeta();
				}, 
                error:function(){
                    CountlyHelpers.alert(jQuery.i18n.map["attribution.not-found"], "red");
                    app.navigate("/attribution", true);
                }
			});
		}
		else{
			return $.ajax({
				type:"GET",
				url:countlyCommon.API_PARTS.data.r+"/campaign",
				data:{
					"api_key":countlyGlobal.member.api_key,
					"period":_period,
                    "filter": filter,
					"app_id":countlyCommon.ACTIVE_APP_ID
				},
				success:function (json) {
					_data = json;
                    var anyAdwords = false;
					for(var i = 0; i < _data.length; i++){
                        if(_data[i].type == "adwords")
                            anyAdwords = true;
                        _list[_data[i]._id] = _data[i].name;
                        if(_selectCount < countlyCommon.GRAPH_COLORS.length && typeof _selected[_data[i]._id] === "undefined"){
                            _selected[_data[i]._id] = true;
                            _selectCount++;
                        }
					}
                    _hasAdwordsCampaign = anyAdwords;
				}
			});
		}
    };
	
	countlyAttribution.refresh = function (id, filter) {
        _id = id;
		_period = countlyCommon.getPeriodForAjax();
		if(id){
			return $.ajax({
				type:"GET",
				url:countlyCommon.API_PARTS.data.r+"/campaign",
				data:{
					"api_key":countlyGlobal.member.api_key,
					"action":"refresh",
					"app_id":countlyCommon.ACTIVE_APP_ID,
					"camp_id":id
				},
				success:function (json) {
					_data = json;
                    _list[_data._id] = _data.name;
					countlyCommon.extendDbObj(_campaignData, _data.data);
					extendMeta();
				}, 
                error:function(){
                    CountlyHelpers.alert(jQuery.i18n.map["attribution.not-found"], "red");
                    app.navigate("/attribution", true);
                }
			});
		}
		else{
			return $.ajax({
				type:"GET",
				url:countlyCommon.API_PARTS.data.r+"/campaign",
				data:{
					"api_key":countlyGlobal.member.api_key,
					"period":_period,
                    "filter": filter,
					"app_id":countlyCommon.ACTIVE_APP_ID,
                    "display_loader": false
                },
				success:function (json) {
					_data = json;
                    var anyAdwords = false;
					for(var i = 0; i < _data.length; i++){
                        if(_data[i].type == "adwords")
                            anyAdwords = true;
                        _list[_data[i]._id] = _data[i].name;
                        if(_selectCount < countlyCommon.GRAPH_COLORS.length && typeof _selected[_data[i]._id] === "undefined"){
                            _forceDataReload = true;
                            _selected[_data[i]._id] = true;
                            _selectCount++;
                        }
					}
                    _hasAdwordsCampaign = anyAdwords;
				}
			});
		}
    };
    
    countlyAttribution.loadData = function (force) {
        force = _forceDataReload || force;
        _forceDataReload = false;
        var ids = [];
        for(var i in _selected){
            if(_selected[i])
                ids.push(i);
        }
        var data ={
			"api_key":countlyGlobal.member.api_key,
            "data": JSON.stringify(ids),
			"app_id":countlyCommon.ACTIVE_APP_ID
		}
        if(force)
            data.period = countlyCommon.getPeriodForAjax();
        else
            data.action = "refresh";
		return $.ajax({
			type:"GET",
			url:countlyCommon.API_PARTS.data.r+"/campaign",
			data:data,
			success:function (json) {
				for(var i = 0; i < json.length; i++){
                    if(!_datas[json[i]._id])
                        _datas[json[i]._id] = json[i].data;
                    else
                        countlyCommon.extendDbObj(_datas[json[i]._id], json[i].data);
				}
			}
		});
    };
    
    countlyAttribution.reset = function (force) {
        _data = {},
		_datas = {},
		_campaignData = {},
		_period = {},
		_periodObj = {},
		_metas = {};
        _selected = {};
        _selectCount = 0;
        if(force)
            _hasAdwordsCampaign = false;
    };
    
    countlyAttribution.select = function (id) {
        if(!_selected[id]){
            if(typeof _selected[id] === "undefined")
                _forceDataReload = true;
            _selected[id] = true;
            _selectCount++;
        }
        return _forceDataReload;
    };
    
    countlyAttribution.unselect = function (id) {
        if(_selected[id]){
            _selected[id] = false;
            _selectCount--;
        }
    };
    
    countlyAttribution.deselect = function () {
        _selected = {};
        _selectCount = 0;
    };
    
    countlyAttribution.getSelected = function (id) {
        return _selected[id];
    };
    
    countlyAttribution.anySelected = function () {
        for(var i in _selected){
            if(_selected[i]){
                return true;
            }
        }
        return false
    };
    
    countlyAttribution.getId = function () {
        return _id;
    };
    
    countlyAttribution.getCampaignName = function(id){
        if(_list[id])
            return _list[id];
        return id;
    };
    
    countlyAttribution.getMeta = function(){
        return _metas;
    };
	
    countlyAttribution.hasAdwordsCampaign = function(){
        return _hasAdwordsCampaign;
    };
    
    countlyAttribution.common = function (id, path, callback) {
		$.ajax({
			type:"GET",
            url:countlyCommon.API_PARTS.data.w + '/campaign/'+path,
            data:{
                args:JSON.stringify({
                    campaign_id:id
                }),
                app_id: countlyCommon.ACTIVE_APP_ID,
                api_key:countlyGlobal['member'].api_key
            },
            dataType:"json",
			success:function (json) {
                if(callback)
                    callback(json);
			},
			error:function(){
                if(callback)
                    callback(false);
			}
		});
    };
    
    countlyAttribution.hide = function (id, callback) {
        countlyAttribution.common(id, "hide", callback);
    };
    
    countlyAttribution.show = function (id, callback) {
        countlyAttribution.common(id, "show", callback);
    };
    
	countlyAttribution.getChartData = function(metric, name){
		var chartData = [
                { data:[], label:name, color:'#DDDDDD', mode:"ghost" },
                { data:[], label:name, color:'#333933' }
            ],
            dataProps = [
                {
                    name:"p"+metric,
                    func:function (dataObj) {
                        return dataObj[metric]
                    },
                    period:"previous"
                },
                { name:metric }
            ];

        return countlyCommon.extractChartData(_campaignData, countlyAttribution.clearObject, chartData, dataProps);
	};
    
    countlyAttribution.getAllChartData = function(metric){
        var charts = [];
        for(var i in _datas){
            if(_selected[i]){
                var color = $("#"+i+" .color").css("background-color");
                var chartData = [
                        { data:[], label:_list[i], color:color}
                    ],
                    dataProps = [
                        { name:metric }
                    ];
        
                charts.push(countlyCommon.extractChartData(_datas[i], countlyAttribution.clearObject, chartData, dataProps).chartDP[0]);
            }
        }
        return charts;
	};
	
	countlyAttribution.getDashboardData = function () {

        //Update the current period object in case selected date is changed
        _periodObj = countlyCommon.periodObj;

        var dataArr = {},
            tmp_x,
            tmp_y,
            currentTotal = 0,
            previousTotal = 0,
            currentUnique = 0,
            previousUnique = 0,
            currentInstall = 0,
            previousInstall = 0,
            currentPayments = 0,
            previousPayments = 0,
			currentSessions = 0,
            previousSessions = 0,
            isEstimate = false;

        if (_periodObj.isSpecialPeriod) {
            
            for (var i = 0; i < (_periodObj.uniquePeriodArr.length); i++) {
                tmp_x = countlyCommon.getDescendantProp(_campaignData, _periodObj.uniquePeriodArr[i]);
                tmp_x = countlyAttribution.clearObject(tmp_x);
                currentUnique += tmp_x["clk"];
            }

            var tmpUniqObj,
                tmpCurrentUniq = 0;

            for (var i = 0; i < (_periodObj.uniquePeriodCheckArr.length); i++) {
                tmpUniqObj = countlyCommon.getDescendantProp(_campaignData, _periodObj.uniquePeriodCheckArr[i]);
                tmpUniqObj = countlyAttribution.clearObject(tmpUniqObj);
                tmpCurrentUniq += tmpUniqObj["clk"];
            }

            if (currentUnique > tmpCurrentUniq) {
                currentUnique = tmpCurrentUniq;
            }

            for (var i = 0; i < (_periodObj.previousUniquePeriodArr.length); i++) {
                tmp_y = countlyCommon.getDescendantProp(_campaignData, _periodObj.previousUniquePeriodArr[i]);
                tmp_y = countlyAttribution.clearObject(tmp_y);
                previousUnique += tmp_y["clk"];
            }

            var tmpUniqObj2,
                tmpPreviousUniq = 0;

            for (var i = 0; i < (_periodObj.previousUniquePeriodCheckArr.length); i++) {
                tmpUniqObj2 = countlyCommon.getDescendantProp(_campaignData, _periodObj.previousUniquePeriodCheckArr[i]);
                tmpUniqObj2 = countlyAttribution.clearObject(tmpUniqObj2);
                tmpPreviousUniq += tmpUniqObj2["clk"];
            }

            if (previousUnique > tmpPreviousUniq) {
                previousUnique = tmpPreviousUniq;
            }

            for (var i = 0; i < (_periodObj.currentPeriodArr.length); i++) {
                tmp_x = countlyCommon.getDescendantProp(_campaignData, _periodObj.currentPeriodArr[i]);
                tmp_x = countlyAttribution.clearObject(tmp_x);
                currentTotal += tmp_x["aclk"];
                currentInstall += tmp_x["ins"];
                currentPayments += tmp_x["rev"];
                currentSessions += tmp_x["ses"];
            }

            for (var i = 0; i < (_periodObj.previousPeriodArr.length); i++) {
                tmp_y = countlyCommon.getDescendantProp(_campaignData, _periodObj.previousPeriodArr[i]);
                tmp_y = countlyAttribution.clearObject(tmp_y);
                previousTotal += tmp_y["aclk"];
                previousInstall += tmp_y["ins"];
                previousPayments += tmp_y["rev"];
                previousSessions += tmp_y["ses"];
            }
        } else {
            tmp_x = countlyCommon.getDescendantProp(_campaignData, _periodObj.activePeriod);
            tmp_y = countlyCommon.getDescendantProp(_campaignData, _periodObj.previousPeriod);
            tmp_x = countlyAttribution.clearObject(tmp_x);
            tmp_y = countlyAttribution.clearObject(tmp_y);

            currentTotal = tmp_x["aclk"];
            previousTotal = tmp_y["aclk"];
            currentInstall = tmp_x["ins"];
            previousInstall = tmp_y["ins"];
            currentUnique = tmp_x["clk"];
            previousUnique = tmp_y["clk"];
            currentPayments = tmp_x["rev"];
            previousPayments = tmp_y["rev"];
            currentSessions = tmp_x["ses"];
            previousSessions = tmp_y["ses"];
        }

        var changeTotal = countlyCommon.getPercentChange(previousTotal, currentTotal),
            changeInstall = countlyCommon.getPercentChange(previousInstall, currentInstall),
            changeUnique = countlyCommon.getPercentChange(previousUnique, currentUnique),
            changePayments = countlyCommon.getPercentChange(previousPayments, currentPayments),
            changeSessions = countlyCommon.getPercentChange(previousSessions, currentSessions);

        dataArr =
        {
            usage:{
                "click":{
                    "total":currentTotal,
                    "change":changeTotal.percent,
                    "trend":changeTotal.trend,
                    "isEstimate":isEstimate
                },
                "unique":{
                    "total":currentUnique,
                    "prev-total":previousUnique,
                    "change":changeUnique.percent,
                    "trend":changeUnique.trend,
                    "isEstimate":isEstimate
                },
                "install":{
                    "total":currentInstall,
                    "prev-total":previousInstall,
                    "change":changeInstall.percent,
                    "trend":changeInstall.trend,
                    "isEstimate":isEstimate
                },
                "payment":{
                    "total":parseFloat(parseFloat(currentPayments).toFixed(2)),
                    "prev-total":previousPayments,
                    "change":changePayments.percent,
                    "trend":changePayments.trend,
                    "isEstimate":isEstimate
                },
                "session":{
                    "total":currentSessions,
                    "prev-total":previousSessions,
                    "change":changeSessions.percent,
                    "trend":changeSessions.trend,
                    "isEstimate":isEstimate
                }
            }
        };

        return dataArr;
    };
	
	countlyAttribution.create = function (args) {
		args.app_id = countlyCommon.ACTIVE_APP_ID;
		return $.ajax({
            type:"GET",
            url:countlyCommon.API_PARTS.data.w+"/campaign/create",
            data:{
				"api_key":countlyGlobal.member.api_key,
				args:JSON.stringify(args)
            }
        });
    };
	
	countlyAttribution.update = function (args) {
		args.app_id = countlyCommon.ACTIVE_APP_ID;
		return $.ajax({
            type:"GET",
            url:countlyCommon.API_PARTS.data.w+"/campaign/update",
            data:{
				"api_key":countlyGlobal.member.api_key,
				args:JSON.stringify(args)
            }
        });
    };
	
	countlyAttribution.del = function (id) {
		return $.ajax({
            type:"GET",
            url:countlyCommon.API_PARTS.data.w+"/campaign/delete",
            data:{
				"api_key":countlyGlobal.member.api_key,
				args:JSON.stringify({
                    "_id":id,
					app_id: countlyCommon.ACTIVE_APP_ID
                })
            }
        });
    };
	
	countlyAttribution.getData = function () {
		return _data;
    };
	
	countlyAttribution.getMetricData = function (metric) {
		var props = [
            {
                name:metric,
                func:function (rangeArr, dataObj) {
                    return rangeArr.replace("["+metric.toLowerCase()+"]_", "");
                }
            },
            { "name":"aclk" },
            { "name":"clk" },
            { "name":"ins" },
            { "name":"ses" },
            { "name":"rev" }
        ];
		if(metric == "cty"){
			props.push({
                name:"cnty",
                func:function (rangeArr, dataObj) {
                    return rangeArr;
                }
            });
		}
        var chartData = countlyAttribution.extractTwoLevelAttributionData(_campaignData, _metas[metric], countlyAttribution.clearObject, props);
		
		if(chartData.chartData){
            chartData.chartData = countlyCommon.mergeMetricsByName(chartData.chartData, metric);
			if(metric == "cnty"){
				for(var i = 0; i < chartData.chartData.length; i++){
					chartData.chartData[i].cnty = "<div class='flag' style='background-image:url("+countlyGlobal["path"]+"/images/flags/" + chartData.chartData[i].cnty + ".png);'></div>" + countlyLocation.getCountryName(chartData.chartData[i].cnty);
				}
			}
			else if(metric == "cty"){
				for(var i = 0; i < chartData.chartData.length; i++){
					chartData.chartData[i].cty = "<div class='flag' style='background-image:url("+countlyGlobal["path"]+"/images/flags/" + chartData.chartData[i].cnty + ".png);'></div>" + chartData.chartData[i].cty + (countlyLocation.getCountryName(chartData.chartData[i].cnty));
				}
			}
			else if(metric == "l"){
				for(var i = 0; i < chartData.chartData.length; i++){
					var parts = chartData.chartData[i].l.split("-");
					var code = parts[1] || parts[0];
					chartData.chartData[i].l = "<div class='flag' style='background-image:url("+countlyGlobal["path"]+"/images/flags/" + code + ".png);'></div>" + chartData.chartData[i].l;
				}
			}
			else if(metric == "pl"){
				/*
				    Add logic to process platforms if needed
				 */
			}
			var metricNames = _.pluck(chartData.chartData, metric),
				metrics = {};
				metrics["click"] = _.pluck(chartData.chartData, 'aclk');
				metrics["unique"] = _.pluck(chartData.chartData, 'clk');
				metrics["install"] = _.pluck(chartData.chartData, 'ins');
				metrics["session"] = _.pluck(chartData.chartData, 'ses');
				metrics["payment"] = _.pluck(chartData.chartData, 'rev');
			chartData2 = [];
			chartData.chartDP = {};
				
			for(var m in metrics){
				var sum = _.reduce(metrics[m], function (memo, num) {
					return memo + num;
				}, 0);
		
				for (var i = 0; i < metricNames.length; i++) {
					var percent = (metrics[m][i] / sum) * 100;
					chartData2[i] = {data:[
						[0, metrics[m][i]]
					], label:metricNames[i]};
				}
				
				chartData.chartDP[m] = {};
				chartData.chartDP[m].dp = chartData2;
			}
		}

        return chartData;
    };
	
	countlyAttribution.clearObject = function (obj) {
        if (obj) {
            if (!obj["aclk"]) obj["aclk"] = 0;
            if (!obj["clk"]) obj["clk"] = 0;
            if (!obj["ins"]) obj["ins"] = 0;
            if (!obj["ses"]) obj["ses"] = 0;
            if (!obj["rev"]) obj["rev"] = 0;
            if (!obj["ccon"]) obj["ccon"] = 0;
            if (!obj["ucon"]) obj["ucon"] = 0;
            if (!obj["cost"]) obj["cost"] = 0;
        }
        else {
            obj = {"aclk":0, "clk":0, "ins":0, "ses":0, "rev":0, "ccon":0, "ucon":0, "cost":0};
        }

        return obj;
    };
    
    countlyAttribution.extractTwoLevelAttributionData = function (db, rangeArray, clearFunction, dataProperties) {

        countlyCommon.periodObj = countlyCommon.getPeriodObj();

        if (!rangeArray) {
            return {"chartData":tableData};
        }
        var periodMin = 0,
            periodMax = 0,
            dataObj = {},
            formattedDate = "",
            tableData = [],
            chartData = [],
            propertyNames = _.pluck(dataProperties, "name"),
            propertyFunctions = _.pluck(dataProperties, "func"),
            propertyValue = 0;

        if (!countlyCommon.periodObj.isSpecialPeriod) {
            periodMin = countlyCommon.periodObj.periodMin;
            periodMax = (countlyCommon.periodObj.periodMax + 1);
        } else {
            periodMin = 0;
            periodMax = countlyCommon.periodObj.currentPeriodArr.length;
        }

        var tableCounter = 0;

        if (!countlyCommon.periodObj.isSpecialPeriod) {
            for (var j = 0; j < rangeArray.length; j++) {
                dataObj = countlyCommon.getDescendantProp(db, countlyCommon.periodObj.activePeriod + "." + rangeArray[j]);

                if (!dataObj) {
                    continue;
                }

                dataObj = clearFunction(dataObj);

                var propertySum = 0,
                    tmpPropertyObj = {};

                for (var k = 0; k < propertyNames.length; k++) {

                    if (propertyFunctions[k]) {
                        propertyValue = propertyFunctions[k](rangeArray[j], dataObj);
                    } else {
                        propertyValue = dataObj[propertyNames[k]];
                    }

                    if (typeof propertyValue !== 'string') {
                        propertySum += propertyValue;
                    }

                    tmpPropertyObj[propertyNames[k]] = propertyValue;
                }

                if (propertySum > 0) {
                    tableData[tableCounter] = {};
                    tableData[tableCounter] = tmpPropertyObj;
                    tableCounter++;
                }
            }
        } else {

            for (var j = 0; j < rangeArray.length; j++) {

                var propertySum = 0,
                    tmpPropertyObj = {},
                    tmp_x = {};

                for (var i = periodMin; i < periodMax; i++) {
                    dataObj = countlyCommon.getDescendantProp(db, countlyCommon.periodObj.currentPeriodArr[i] + "." + rangeArray[j]);

                    if (!dataObj) {
                        continue;
                    }

                    dataObj = clearFunction(dataObj);

                    for (var k = 0; k < propertyNames.length; k++) {

                        if (propertyNames[k] == "clk") {
                            propertyValue = 0;
                        } else if (propertyFunctions[k]) {
                            propertyValue = propertyFunctions[k](rangeArray[j], dataObj);
                        } else {
                            propertyValue = dataObj[propertyNames[k]];
                        }

                        if (!tmpPropertyObj[propertyNames[k]]) {
                            tmpPropertyObj[propertyNames[k]] = 0;
                        }

                        if (typeof propertyValue === 'string') {
                            tmpPropertyObj[propertyNames[k]] = propertyValue;
                        } else {
                            propertySum += propertyValue;
                            tmpPropertyObj[propertyNames[k]] += propertyValue;
                        }
                    }
                }

                if (propertyNames.indexOf("clk") !== -1 && Object.keys(tmpPropertyObj).length) {
                    var tmpUniqVal = 0,
                        tmpUniqValCheck = 0,
                        tmpCheckVal = 0;

                    for (var l = 0; l < (countlyCommon.periodObj.uniquePeriodArr.length); l++) {
                        tmp_x = countlyCommon.getDescendantProp(db, countlyCommon.periodObj.uniquePeriodArr[l] + "." + rangeArray[j]);
                        if (!tmp_x) {
                            continue;
                        }
                        tmp_x = clearFunction(tmp_x);
                        propertyValue = tmp_x["clk"];

                        if (typeof propertyValue === 'string') {
                            tmpPropertyObj["clk"] = propertyValue;
                        } else {
                            propertySum += propertyValue;
                            tmpUniqVal += propertyValue;
                            tmpPropertyObj["clk"] += propertyValue;
                        }
                    }

                    for (var l = 0; l < (countlyCommon.periodObj.uniquePeriodCheckArr.length); l++) {
                        tmp_x = countlyCommon.getDescendantProp(db, countlyCommon.periodObj.uniquePeriodCheckArr[l] + "." + rangeArray[j]);
                        if (!tmp_x) {
                            continue;
                        }
                        tmp_x = clearFunction(tmp_x);
                        tmpCheckVal = tmp_x["clk"];

                        if (typeof tmpCheckVal !== 'string') {
                            propertySum += tmpCheckVal;
                            tmpUniqValCheck += tmpCheckVal;
                        }
                    }

                    if (tmpUniqVal > tmpUniqValCheck) {
                        tmpPropertyObj["clk"] = tmpUniqValCheck;
                    }
                }

                //if (propertySum > 0)
                {
                    tableData[tableCounter] = {};
                    tableData[tableCounter] = tmpPropertyObj;
                    tableCounter++;
                }
            }
        }

        if (propertyNames.indexOf("clk") !== -1) {
            tableData = _.sortBy(tableData, function (obj) {
                return -obj["clk"];
            });
        } else if (propertyNames.indexOf("aclk") !== -1) {
            tableData = _.sortBy(tableData, function (obj) {
                return -obj["aclk"];
            });
        } else if (propertyNames.indexOf("ins") !== -1) {
            tableData = _.sortBy(tableData, function (obj) {
                return -obj["ins"];
            });
        }

        for (var i = 0; i < tableData.length; i++) {
            if (_.isEmpty(tableData[i])) {
                tableData[i] = null;
            }
        }

        return {"chartData":_.compact(tableData)};
    };
	
	function setMeta() {
        if (_campaignData['meta']) {
			for(var i in _campaignData['meta']){
				_metas[i] = (_campaignData['meta'][i]) ? _campaignData['meta'][i] : [];
			}
        }
    }

    function extendMeta() {
        if (_campaignData['meta']) {
			for(var i in _campaignData['meta']){
				_metas[i] = countlyCommon.union(_metas[i] , _campaignData['meta'][i]);
			}
        }
    }
	
}(window.countlyAttribution = window.countlyAttribution || {}, jQuery));