var platformlinks = {
	android:false,
	"android-custom-scheme":"attribution.custom-scheme-help",
	kindle:false,
	ios:false,
	"ios-custom-scheme":"attribution.custom-scheme-help",
	"windows-phone":false, 
	blackberry: false,
	linux: false,
	mac: false, 
	windows:false
};
window.AttributionView = countlyView.extend({
	initialize:function () {
        this.filter = (store.get("countly_campaignfilter")) ? store.get("countly_campaignfilter") : "campaign-all";
		this.curMetric = "aclk";
		this.curTitle = jQuery.i18n.map["attribution.total-clicks"];
        this.graphType = "time";
        this.curColor = 0;
        this.colors = {};
		this.metrics = {
			aclk:jQuery.i18n.map["attribution.total-clicks"],
			clk:jQuery.i18n.map["attribution.unique-clicks"],
			ins:jQuery.i18n.map["attribution.installs"],
			ccon:jQuery.i18n.map["attribution.click-conversion"],
			ucon:jQuery.i18n.map["attribution.user-conversion"],
			cost:jQuery.i18n.map["attribution.total"]+" "+jQuery.i18n.map["attribution.cost"],
			rev:jQuery.i18n.map["attribution.revenue"],
			ses:jQuery.i18n.map["attribution.sessions"]
		};
	},
    resetColor: function(){
        this.dtable.find(".color").css("background-color", "transparent");
        this.curColor = 0;
        this.colors = {};
    },
    getColor: function(id){
        if(this.colors[id]){
            return this.colors[id];
        }
        else if(countlyCommon.GRAPH_COLORS.length == this.curColor){
            this.curColor = 0;
        }
        this.colors[id] = countlyCommon.GRAPH_COLORS[this.curColor];
        this.curColor++;
        $("#"+id+" .color").css("background-color", this.colors[id]);
        $("#"+id+" .check").removeClass("fa-unchecked").addClass("fa-check");
        return this.colors[id];
    },
    beforeRender: function() {
		if(this.template)
			return $.when(countlyAttribution.initialize(null, this.filter)).then(function () {});
		else{
			var self = this;
			return $.when($.get(countlyGlobal["path"]+'/attribution/templates/all.html', function(src){
				self.template = Handlebars.compile(src);
			}), countlyAttribution.initialize(null, this.filter)).then(function () {});
		}
    },
    renderGraph: function(){
        var data = countlyAttribution.getData();
		var aData;
        this.dp = {};
        this.pie = {};
		
		for(var i in this.metrics){
			this.dp[i] = {dp:[], ticks:[[-1,""]]};
			this.pie[i] = {dp:[]};
		}
        //very hacky way of drawing multiple bars with different colors, separating them by serieas and using null data points for expanding
        var template = [[-1,null]];
        for(var i = 0; i < data.length; i++){
            template.push([i, null]);
        }
        template.push([data.length, null]);
        this.resetColor();
		for(var i = 0; i < data.length; i++){
            if(countlyAttribution.getSelected(data[i]._id)){
                aData = data[i];
                var arr = template.slice();
                arr[i+1] = [i, aData.clk];
                this.pie.clk.dp.push({data:[[0, aData.clk]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.clk.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.clk.ticks.push([i, aData.name]);
                
                var arr = template.slice();
                arr[i+1] = [i, aData.aclk];
                this.pie.aclk.dp.push({data:[[0, aData.aclk]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.aclk.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.aclk.ticks.push([i, aData.name]);
                
                var arr = template.slice();
                arr[i+1] = [i, aData.ins];
                this.pie.ins.dp.push({data:[[0, aData.ins]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.ins.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.ins.ticks.push([i, aData.name]);
                
                var arr = template.slice();
                arr[i+1] = [i, aData.rev];
                this.pie.rev.dp.push({data:[[0, aData.rev]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.rev.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.rev.ticks.push([i, aData.name]);
                
                var arr = template.slice();
                arr[i+1] = [i, aData.ses];
                this.pie.ses.dp.push({data:[[0, aData.ses]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.ses.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.ses.ticks.push([i, aData.name]);
                
                var con = (aData.aclk > 0) ? (aData.ins/aData.aclk)*100 : 0;
                var arr = template.slice();
                arr[i+1] = [i, con];
                this.pie.ccon.dp.push({data:[[0, con]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.ccon.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.ccon.ticks.push([i, aData.name]);
                
                var con = (aData.clk > 0) ? (aData.ins/aData.clk)*100 : 0;
                var arr = template.slice();
                arr[i+1] = [i, con];
                this.pie.ucon.dp.push({data:[[0, con]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.ucon.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.ucon.ticks.push([i, aData.name]);
                
                var cost = 0;
                if(aData.cost > 0){
                    if(aData.costtype == "click"){
                        cost = aData.aclk*aData.cost;
                    }
                    else if(aData.costtype == "install"){
                        cost = aData.ins*aData.cost;
                    }
                    else if(aData.costtype == "campaign"){
                        cost = aData.cost;
                    }
                }
                var arr = template.slice();
                arr[i+1] = [i, cost];
                this.pie.cost.dp.push({data:[[0, cost]], label:aData.name, color:this.getColor(aData._id)});
                this.dp.cost.dp.push({data:arr, label:aData.name, color:this.getColor(aData._id)});
                this.dp.cost.ticks.push([i, aData.name]);
            }
		}
        if(this.graphType == "time"){
            countlyCommon.drawTimeGraph(countlyAttribution.getAllChartData(this.curMetric), "#dashboard-graph");
        }
        else if(this.graphType == "pie"){
            countlyCommon.drawGraph(this.pie[this.curMetric], "#dashboard-graph", "pie");
        }
        else{
            countlyCommon.drawGraph(this.dp[this.curMetric], "#dashboard-graph", "separate-bar");
        }
    },
    renderCommon:function (isRefresh) {
		var url = location.protocol+'//'+location.hostname+(location.port ? ':'+location.port: '')+"/at/";
        var data = countlyAttribution.getData();
        this.templateData = {
            "page-title":jQuery.i18n.map["attribution.title"],
            "logo-class":"frequency",
			"active-segmentation": this.curTitle,
			"segmentations": this.metrics,
            "hasPermission": (countlyGlobal["member"].global_admin || countlyGlobal["admin_apps"][countlyCommon.ACTIVE_APP_ID]) ? true : false,
			"url":url
        };
		var self = this;
        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));
            if(data.length)
                $("#empty-graph").hide();
            $("#"+this.filter).addClass("selected").addClass("active");
			var last;
			this.dtable = $('#attribution-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": data,
				"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
					$(nRow).attr("id", aData._id);
					last = aData;
                    if(aData._id == "_organic"){
                        $(nRow).attr("data-help", "attribution.organic");
                    }
				},
                "aoColumns": [
                    { "mData": function(row, type){if(countlyAttribution.getSelected(row._id)) return row.name+"<div class='color' style='background-color:"+self.getColor(row._id)+"'></div>"; else return row.name+"<div class='color'></div>";}, "sType":"string", "sTitle": jQuery.i18n.map["attribution.campaign"]},
					{ "mData": function(row, type){return row.aclk || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.total-clicks"], "sClass":"center"},
                    { "mData": function(row, type){return row.clk || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.unique-clicks"], "sClass":"center"},
                    { "mData": function(row, type){return row.ins || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.installs"], "sClass":"center"},
                    { "mData": function(row, type){if(row.cost > 0){ if(row.costtype == "click"){ return (row.aclk*row.cost).toFixed(2);}
					else if(row.costtype == "install"){return (row.ins*row.cost).toFixed(2);} else if(row.costtype == "campaign"){return parseFloat(row.cost).toFixed(2);} } return (0).toFixed(2);}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.total"]+" "+jQuery.i18n.map["attribution.cost"], "sClass":"center"},
                    { "mData": function(row, type){return parseFloat(row.rev).toFixed(2) || (0).toFixed(2);}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.total"]+" "+jQuery.i18n.map["attribution.revenue"], "sClass":"center"},
                    { "mData": function(row, type){return row.ses || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.sessions"], "sClass":"center"},
                    { "mData": function(row, type){if (row._id != "_organic") { return "<a class='table-link green' href='" + window.location.hash.toString() + "/" + row._id + "'>" + jQuery.i18n.map["attribution.view-campaign"] + "</a>"; } else { return ""; }}, "sType":"numeric", "sClass":"center", "bSortable": false}
                ]
            }));
			this.dtable.stickyTableHeaders();
			this.dtable.fnSort( [ [0,'desc'] ] );
            $.when(countlyAttribution.loadData(true)).then(function(){
                self.renderGraph();
                $(".campaign-switch-metric .segmentation-option").on("click", function () {
                    self.switchMetric($(this).data("value"));
                });
                $(".btn-new-campaign").click(function(){
                    AttributionForm(last);
                });
                $('#attribution-table tbody').on("click", "td", function (){
                    var id = $(this).parent().attr("id");

                    if(countlyAttribution.getSelected(id)){
                        countlyAttribution.unselect(id);
                        $(this).find(".check").removeClass("fa-check").addClass("fa-unchecked");
                        if(!countlyAttribution.anySelected()){
                            $("#empty-graph").show();
                        }
                        self.renderGraph();
                    } else {
                        if(countlyAttribution.select(id)){
                            $.when(countlyAttribution.loadData(true)).then(function(){
                                self.renderGraph();
                            });
                        }
                        else
                            self.renderGraph();
                        $(this).find(".check").removeClass("fa-unchecked").addClass("fa-check");
                        $("#empty-graph").hide();
                    }
                });
                
                $("#campaign-selector").find(">.button").click(function () {
                    if ($(this).hasClass("selected")) {
                        return true;
                    }
            
                    $(".campaign-selector").removeClass("selected").removeClass("active");
                    var filter = $(this).attr("id");
                    self.filterCampaigns(filter);
                });
                
                var graphSettings = $(".attribution-settings");
    
                graphSettings.find(".button").on("click", function(e) {
                    if ($(this).hasClass("active") || $(this).hasClass("disabled")) {
                        e.stopPropagation();
                        return true;
                    }

                    $("#dashboard-graph").html("");

                    $("#graph-container").removeClass(function (index, css) {
                        return (css.match (/(^|\s)type-\S+/g) || []).join(' ');
                    });
                    $("#graph-container").addClass("type-" + $(this).data("type"));

                    $(this).parents(".button-selector").find(".button").removeClass("active");
                    $(this).addClass("active");
                    self.graphType = $(this).data("type");
                    self.renderGraph();
                });
                
                $('#_organic').tipsy({gravity:$.fn.tipsy.autoNS, title:function () {
                    return ($(this).data("help")) ? jQuery.i18n.map[$(this).data("help")] : "";
                }, fade:true, offset:5, cssClass:'yellow', opacity:1, html:true});
            });
        }
    },
    refresh:function (force) {
        var self = this;
        $.when(countlyAttribution.refresh(null, this.filter)).then(function () {
            $.when(countlyAttribution.loadData(force)).then(function(){
                if (app.activeView != self) {
                    return false;
                }
                self.renderCommon(true);
                var data = countlyAttribution.getData();
                CountlyHelpers.refreshTable(self.dtable, data);
                self.renderGraph();
                app.localize();
                $('#_organic').tipsy({gravity:$.fn.tipsy.autoNS, title:function () {
                    return ($(this).data("help")) ? jQuery.i18n.map[$(this).data("help")] : "";
                }, fade:true, offset:5, cssClass:'yellow', opacity:1, html:true});
            });
        });
    },
	filterCampaigns: function(filter){
		this.filter = filter;
		store.set("countly_campaignfilter", filter);
		$("#"+this.filter).addClass("selected").addClass("active");
        countlyAttribution.deselect();
		this.refresh(true);
	},
	switchMetric:function(metric){
        this.curMetric = metric;
        if(metric === "ccon" || metric === "ucon" || metric === "cost"){
            //hide time graph icon
            $(".material-icons").parent().addClass("disabled");
            if(this.graphType === "time"){
                $("#dashboard-graph").html("");

                $("#graph-container").removeClass(function (index, css) {
                    return (css.match (/(^|\s)type-\S+/g) || []).join(' ');
                });
                $("#graph-container").addClass("type-pie");

                $(".ion-pie-graph").parents(".button-selector").find(".button").removeClass("active");
                $(".ion-pie-graph").parent().addClass("active");
                this.graphType = "pie";
            }
        }
        else{
            //show time graph icon
            $(".material-icons").parent().removeClass("disabled");
        }
        this.renderGraph();
	}
});

window.AttributionDetailsView = countlyView.extend({
	initialize:function () {
		this.curMetric = "aclk";
		this.curSegment = "pl";
		this.segments = {
			pl:jQuery.i18n.map["attribution.platform"],
			b:jQuery.i18n.map["attribution.browser"],
			cnty:jQuery.i18n.map["attribution.country"],
			l:jQuery.i18n.map["attribution.locale"]
		};
		this.metrics = {
			clk:jQuery.i18n.map["attribution.unique-clicks"],
			aclk:jQuery.i18n.map["attribution.total-clicks"],
			ins:jQuery.i18n.map["attribution.installs"],
			rev:jQuery.i18n.map["attribution.revenue"],
			ses:jQuery.i18n.map["attribution.sessions"]
		};
	},
    beforeRender: function() {
        this.curSegment = "pl";
		if(this.template)
			return $.when(countlyAttribution.initialize(this._id)).then(function () {});
		else{
			var self = this;
			return $.when($.get(countlyGlobal["path"]+'/attribution/templates/campaign.html', function(src){
				self.template = Handlebars.compile(src);
			}), countlyAttribution.initialize(this._id)).then(function () {});
		}
    },
    renderCommon:function (isRefresh) {
        this.segments = {
			pl:jQuery.i18n.map["attribution.platform"],
			b:jQuery.i18n.map["attribution.browser"],
			cnty:jQuery.i18n.map["attribution.country"],
			l:jQuery.i18n.map["attribution.locale"]
		};
        var meta = countlyAttribution.getMeta();
        for(var i in meta){
            if(!this.segments[i])
                this.segments[i] = i;
        }

		var url = location.protocol+'//'+location.hostname+(location.port ? ':'+location.port: '')+countlyGlobal["path"]+"/at/";
        var data = countlyAttribution.getData();
		var chartData = countlyAttribution.getChartData(this.curMetric, this.metrics[this.curMetric]);
		var dashboard = countlyAttribution.getDashboardData();
		data.totalCost = 0;
		data.userCost = 0;
		data.aclk = dashboard.usage.click.total;
		data.ins = dashboard.usage.install.total;
		data.clk = dashboard.usage.unique.total;
		data.rev = dashboard.usage.payment.total;
		data.ses = dashboard.usage.session.total;
		if(data.cost > 0){
			if(data.costtype == "click"){
				data.totalCost = data.aclk*data.cost;
			}
			else if(data.costtype == "install"){
				data.totalCost = data.ins*data.cost;
			}
			else if(data.costtype == "campaign"){
				data.totalCost = data.cost;
			}
			data.userCost = (data.ins > 0) ? data.totalCost/data.ins : 0;
		}
        this.templateData = {
            "page-title":data.name,
            "is_hidden": (data.is_hidden) ? true : false,
            "logo-class":"frequency",
			"url":url,
			"id":this._id,
			"data":data,
			"active-segmentation": this.segments[this.curSegment],
			"segmentations": this.segments,
            "hasPermission": (countlyGlobal["member"].global_admin || countlyGlobal["admin_apps"][countlyCommon.ACTIVE_APP_ID]) ? true : false,
			"usage":[
				{
					"title":jQuery.i18n.map["attribution.total-clicks"],
                    "help":"attribution.help.total-clicks",
					"data":dashboard.usage['click'],
					"id":"attribution-aclk"
				},
				{
					"title":jQuery.i18n.map["attribution.unique-clicks"],
                    "help":"attribution.help.unique-clicks",
					"data":dashboard.usage['unique'],
					"id":"attribution-clk"
				},
				{
					"title":jQuery.i18n.map["attribution.installs"],
                    "help":"attribution.help.installs",
					"data":dashboard.usage['install'],
					"id":"attribution-ins"
				},
				{
					"title":jQuery.i18n.map["attribution.revenue"],
                    "help":"attribution.help.revenue",
					"data":dashboard.usage['payment'],
					"id":"attribution-rev"
				},
				{
					"title":jQuery.i18n.map["attribution.sessions"],
                    "help":"attribution.help.sessions",
					"data":dashboard.usage['session'],
					"id":"attribution-ses"
				}
			],
			"big-numbers":{
                "items":[
					{
                        "title":jQuery.i18n.map["attribution.cost"]+" "+jQuery.i18n.map["attribution.cost-"+data.costtype],
                        "help":"attribution.help.cost",
                        "total":parseFloat(data.cost).toFixed(2)
                    },
					{
                        "title":jQuery.i18n.map["attribution.balance"],
                        "help":"attribution.help.balance",
                        "total":(data.rev - data.totalCost).toFixed(2)
                    },
                    {
                        "title":jQuery.i18n.map["attribution.user-conversion"],
                        "help":"attribution.help.user-conversion",
                        "total":(data.clk > 0) ? Math.round((data.ins/data.clk)*100)+"%" : "0%"
                    },
                    {
                        "title":jQuery.i18n.map["attribution.click-conversion"],
                        "help":"attribution.help.click-conversion",
                        "total":(data.aclk > 0) ? Math.round((data.ins/data.aclk)*100)+"%" : "0%"
                    }
                ]
            },
			"cdata":[
				{
                    "title":jQuery.i18n.map["attribution.cost"],
                    "help":"attribution.help.campaign-cost",
					"icon":"payment",
                    "total":data.totalCost.toFixed(2),
                    "user":data.userCost.toFixed(2)
                },
				{
                    "title":jQuery.i18n.map["attribution.revenue"],
                    "help":"attribution.help.campaign-revenue",
					"icon":"monetization_on",
                    "total":data.rev,
                    "user":(data.ins > 0) ? (data.rev/data.ins).toFixed(2) : (0).toFixed(2)
                },
				{
                    "title":jQuery.i18n.map["attribution.sessions"],
                    "help":"attribution.help.campaign-session",
					"icon":"timeline",
                    "total":data.ses,
                    "user":(data.ins > 0) ? (data.ses/data.ins).toFixed(2) : 0
                }
            ]
        };
		var self = this;
        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));
            if(data && data.type && data.type.indexOf("adwords") === 0){
                $(".campaign-link").val(url+data["_id"]+"?campaign={campaignid}&adgroup={adgroupid}&adid={creative}&network={network}&keyword={keyword}&placement={placement}&category={target}&position={adposition}&url={lpurl}");
            }
            if(addDrill){
                $(".attribution-detail .widget-header .left .title").after(addDrill("cmp.c", this._id));
            }
			this.dtable = $('#attribution-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": countlyAttribution.getMetricData(self.curSegment).chartData,
                "aoColumns": [
                    { "mData": function(row, type){return row[self.curSegment];}, "sType":"string", "sTitle": jQuery.i18n.map["attribution.value"]},
					{ "mData": function(row, type){return row.aclk || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.total-clicks"], "sClass":"center"},
                    { "mData": function(row, type){return row.clk || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.unique-clicks"], "sClass":"center"},
                    { "mData": function(row, type){return row.ins || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.installs"], "sClass":"center"},
                    { "mData": function(row, type){return parseFloat(row.rev).toFixed(2) || (0).toFixed(2);}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.revenue"], "sClass":"center"},
                    { "mData": function(row, type){return row.ses || 0;}, "sType":"numeric", "sTitle": jQuery.i18n.map["attribution.sessions"], "sClass":"center"}
                ]
            }));
			
			this.dtable.stickyTableHeaders();
			this.dtable.fnSort( [ [1,'desc'] ] );
			//draw chart with total data
			countlyCommon.drawTimeGraph(chartData.chartDP, "#dashboard-graph");
			$(".campaign-switch-segment .segmentation-option").on("click", function () {
				self.switchSegment($(this).data("value"));
			});
			$("#attribution-"+this.curMetric).parents(".big-numbers").addClass("active");
			$(".widget-content .inner").click(function () {
				$(".big-numbers").removeClass("active");
				$(".big-numbers .select").removeClass("selected");
				$(this).parent(".big-numbers").addClass("active");
				$(this).find('.select').addClass("selected");
			});
			$(".big-numbers .inner").click(function () {
				var elID = $(this).find('.select').attr("id");
	
				if (self.curMetric == elID.replace("attribution-", "")) {
					return true;
				}
	
				self.curMetric = elID.replace("attribution-", "");
				self.switchMetric();
			});
			$(".btn-delete-campaign").on("click", function(){
				var id = $(this).data("id");
				CountlyHelpers.confirm(jQuery.i18n.map["attribution.confirm-delete"], "red", function (result) {
					if (!result) {
						return true;
					}
					$.when(countlyAttribution.del(id)).then(function (data) {
						if(data.result == "Success"){
							window.location.hash = "/attribution";
						}
						else{
							CountlyHelpers.alert(data.result, "red");
						}
					});
				});
			});
			$(".btn-edit-campaign").on("click", function(){
				var id = $(".btn-delete-campaign").data("id");
				var data = countlyAttribution.getData();
				AttributionForm(null, id, data);
			});
            $(".btn-show-campaign").click(function(){
                $(".btn-show-campaign").addClass("active");
                var id = $(".btn-delete-campaign").data("id");
				countlyAttribution.show(id, function(data){
                    if(data){
                        $(".btn-show-campaign").removeClass("active");
                        $(".btn-show-campaign").css("display", "none");
                        $(".btn-hide-campaign").css("display", "block");
                    }
                    else{
                        CountlyHelpers.alert(jQuery.i18n.map["common.try-later"], "red");
                    }
				});
			});
            
            $(".btn-hide-campaign").click(function(){
                $(".btn-hide-campaign").addClass("active");
                var id = $(".btn-delete-campaign").data("id");
				countlyAttribution.hide(id, function(data){
                    if(data){
                        $(".btn-hide-campaign").removeClass("active");
                        $(".btn-hide-campaign").css("display", "none");
                        $(".btn-show-campaign").css("display", "block");
                    }
                    else{
                        CountlyHelpers.alert(jQuery.i18n.map["common.try-later"], "red");
                    }
				});
			});

            $(".btn-get-campaign-link").click(function() {
                $("#attribution-link-popup").toggle();
            });

            $("#get-link-done").click(function() {
                $("#attribution-link-popup").hide();
            });
        }
    },
    refresh:function () {
        var self = this;
        $.when(countlyAttribution.refresh(this._id)).then(function () {
            if (app.activeView != self) {
                return false;
            }
			self.renderCommon(true);
			var chartData = countlyAttribution.getChartData(self.curMetric, self.metrics[self.curMetric]);
			var newPage = $("<div>" + self.template(self.templateData) + "</div>");
			$(".attribution-detail .widget-header .title").replaceWith(newPage.find(".attribution-detail .widget-header .title"));
			$(".attribution-detail .dashboard").replaceWith(newPage.find(".dashboard"));
			$("#attribution-numbers-container").replaceWith(newPage.find("#attribution-numbers-container"));
			countlyCommon.drawTimeGraph(chartData.chartDP, "#dashboard-graph");
			CountlyHelpers.refreshTable(self.dtable, countlyAttribution.getMetricData(self.curSegment).chartData);
			
			$("#attribution-"+self.curMetric).parents(".big-numbers").addClass("active");
			$(".widget-content .inner").click(function () {
				$(".big-numbers").removeClass("active");
				$(".big-numbers .select").removeClass("selected");
				$(this).parent(".big-numbers").addClass("active");
				$(this).find('.select').addClass("selected");
			});
			$(".big-numbers .inner").click(function () {
				var elID = $(this).find('.select').attr("id");
	
				if (self.curMetric == elID.replace("attribution-", "")) {
					return true;
				}
	
				self.curMetric = elID.replace("attribution-", "");
				self.switchMetric();
			});
			
			app.localize();
        });
    },
	switchMetric:function(){
		var chartData = countlyAttribution.getChartData(this.curMetric, this.metrics[this.curMetric]);
		countlyCommon.drawTimeGraph(chartData.chartDP, "#dashboard-graph");
	},
	switchSegment:function(segment){
		this.curSegment = segment;
		CountlyHelpers.refreshTable(this.dtable, countlyAttribution.getMetricData(this.curSegment).chartData);
	}
});

function AttributionForm(last, id, data){
    var types = {
        adwordsdefault: {
            init: function(data){
                var d = {};
                content.find("#campaign-form #campaign-type-form").append("<div class='campaign-type campaign-type-adwordsdefault'>"+
                    "<div class='campaign-header'>"+
                        "<div>"+jQuery.i18n.map["attribution.tracking-url"]+"</div>"+
                    "</div>"+
                    "<div class='campaign-row'>"+
                        "<div class='campaign-cell-100'><textarea readonly onclick='this.select()'>"+url+formdata["_id"]+"?campaign={campaignid}&adgroup={adgroupid}&adid={creative}&network={network}&keyword={keyword}&placement={placement}&category={target}&position={adposition}&url={lpurl}</textarea></div>"+
                    "</div>"+
                "</div>");
            },
            select: function(){
                content.find(".platform-links").hide();
                $(".campaign-link").val(url+formdata["_id"]+"?campaign={campaignid}&adgroup={adgroupid}&adid={creative}&network={network}&keyword={keyword}&placement={placement}&category={target}&position={adposition}&url={lpurl}");
            },
            save: function(data){
                return {};
            }
        },
        adwords: {
            init: function(data){
                var host = location.protocol+'//'+location.hostname+(location.port ? ':'+location.port: '');
                var d = {};
                if(data && data.typedata && data.typedata.adwords)
                    d = data.typedata.adwords;

                content.find("#campaign-form #campaign-type-form").append(
                    "<div class='campaign-type campaign-type-adwords'>"+
                    "<div class='adwords-warning'>"+jQuery.i18n.map["attribution.adwords-warning"]+"</div>"+
                    "<div class='campaign-header'>"+
                        "<div>"+jQuery.i18n.map["attribution.tracking-url"]+"</div>"+
                    "</div>"+
                    "<div class='campaign-row'>"+
                        "<div class='campaign-cell-100'><textarea readonly onclick='this.select()'>"+url+formdata["_id"]+"?campaign={campaignid}&adgroup={adgroupid}&adid={creative}&network={network}&keyword={keyword}&placement={placement}&category={target}&position={adposition}&url={lpurl}</textarea></div>"+
                    "</div>"+
                    "<div id='campaign-selector'>" +
                        "<div class='left-container'>" +
                            "<div class='left active' data-open='android-campaign-container'>"+jQuery.i18n.map["attribution.android"]+"</div>" +
                            "<div class='left' data-open='ios-campaign-container'>"+jQuery.i18n.map["attribution.ios"]+"</div>" +
                        "</div>" +
                        "<div class='right active' id='android-campaign-container'>" +
                            "<div class='campaign-header'>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.conversion-id"]+"</div>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.conversion-label"]+"</div>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.package-id"]+"</div>"+
                            "</div>"+
                            "<div class='campaign-row'>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-android-conversion' value='"+((d && d.android && d.android.conversion) ? d.android.conversion : "")+"' placeholder='ex: 0123456789'/></div>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-android-label' value='"+((d && d.android && d.android.label) ? d.android.label : "")+"' placeholder='ex: abCDEFG12hIJk3Lm4nO'/></div>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-android-bundle' value='"+((d && d.android && d.android.bundle) ? d.android.bundle : "")+"' placeholder='ex: com.mycompany.myapp'/></div>"+
                            "</div>"+
                            "<div class='campaign-row' style='margin-bottom: 0; margin-top: 10px;'>"+
                                "<div>" +
                                    "<div style='margin-bottom: 5px;'>"+jQuery.i18n.map["attribution.android-postback"]+"</div>"+
                                    "<textarea readonly onclick='this.select()'>"+host+"/i/campaign/postback?cly_id="+formdata["_id"]+"&advertising_id={adid}&lat={lat}&click_url={click_url}&click_timestamp={click_ts}&trv_campaign_id={campaign_id}&video_id={video_id}</textarea>" +
                                "</div>"+
                            "</div>"+
                        "</div>" +
                        "<div class='right' id='ios-campaign-container'>" +
                            "<div class='campaign-header'>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.conversion-id"]+"</div>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.conversion-label"]+"</div>"+
                                "<div class='campaign-cell-33'>"+jQuery.i18n.map["attribution.bundle-id"]+"</div>"+
                            "</div>"+
                            "<div class='campaign-row'>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-ios-conversion' value='"+((d && d.ios && d.ios.conversion) ? d.ios.conversion : "")+"' placeholder='ex: 0123456789'/></div>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-ios-label' value='"+((d && d.ios && d.ios.label) ? d.ios.label : "")+"' placeholder='ex: abCDEFG12hIJk3Lm4nO'/></div>"+
                                "<div class='campaign-cell-33'><input type='text' id='adwords-ios-bundle' value='"+((d && d.ios && d.ios.bundle) ? d.ios.bundle : "")+"' placeholder='ex: com.mycompany.myapp'/></div>"+
                            "</div>"+
                            "<div class='campaign-row' style='margin-bottom: 0; margin-top: 10px;'>"+
                                "<div>" +
                                    "<div style='margin-bottom: 5px;'>"+jQuery.i18n.map["attribution.ios-postback"]+"</div>"+
                                    "<textarea readonly onclick='this.select()'>"+host+"/i/campaign/postback?cly_id="+formdata["_id"]+"&idfa={md5_advertising_id}&lat={lat}&click_url={click_url}&click_timestamp={click_ts}&trv_campaign_id={campaign_id}&video_id={video_id}</textarea>" +
                                "</div>"+
                            "</div>"+
                        "</div>" +
                    "</div>" +
                "</div>");

                content.on("click", "#campaign-selector .left", function() {
                    if (!$(this).hasClass("active")) {
                        content.find("#campaign-selector").find(".left-container .left").removeClass("active");
                        $(this).addClass("active");

                        var toOpen = $(this).data("open");

                        content.find("#campaign-selector").find(".right").removeClass("active");
                        $("#" + toOpen).addClass("active");
                    }
                });
            },
            select: function(){
                content.find(".platform-links").hide();
                $(".campaign-link").val(url+formdata["_id"]+"?campaign={campaignid}&adgroup={adgroupid}&adid={creative}&network={network}&keyword={keyword}&placement={placement}&category={target}&position={adposition}&url={lpurl}");
                if(countlyAttribution.hasAdwordsCampaign()){
                    content.find(".adwords-warning").show();
                }
            },
            save: function(data){
                return {
                    android:{
                        conversion: $("#adwords-android-conversion").val(),
                        label: $("#adwords-android-label").val(),
                        bundle: $("#adwords-android-bundle").val()
                    },
                    ios:{
                        conversion: $("#adwords-ios-conversion").val(),
                        label: $("#adwords-ios-label").val(),
                        bundle: $("#adwords-ios-bundle").val()
                    }
                };
                
            }
        }
    };
    var url = location.protocol+'//'+location.hostname+(location.port ? ':'+location.port: '')+"/at/";
    var formdata = {};
    formdata["_id"] = id || sha1(countlyCommon.ACTIVE_APP_ID+""+new Date().getTime());
	var dialog = $("#cly-popup").clone().removeAttr("id").addClass('campaign-create');
	var content = dialog.find(".content");
	content.html($('#campaign-create').html());
    for(var i in types){
        content.find("#campaign-type .select-items > div").append('<div data-value="'+i+'" class="segmentation-option item">'+jQuery.i18n.map["attribution.campaign-type-"+i]+'</div>');
        types[i].init(data);
    }
    content.find('#campaign-type-form .campaign-type').hide();
	content.find("#campaign-form .form-name").text(jQuery.i18n.map["attribution.create-campaign"]);
	content.find("#campaign-form #campaign-link").val(url+formdata["_id"]);
	content.find("#campaign-form #campaign-path").val(formdata["_id"]);
    content.find(".campaign-url").text(url);
    var costtype = "click";
    var campaigntype = "default";
    if(typeof data != "undefined"){
        content.find(".btn-create").hide();
        content.find(".btn-update").show();
        formdata["default"] = data.link;
        content.find("#campaign-name").val(data.name);
        content.find(".attribution-custom").hide();
        if(!data.fingerprint){
            content.find("#campaign-fingerprint").prop('checked', false);
        }
        else{
            content.find("#campaign-fingerprint").prop('checked', true);
        }
		content.find("#campaign-cost").val(data.cost);
		content.find("#campaign-form .form-name").text(jQuery.i18n.map["attribution.edit-campaign"]);
		content.find(".details .link textarea").val(data.link);
		content.find("#campaign-redirect-default .fa-check").css("display", "inline-block");
		costtype = data.costtype;
        campaigntype = data.type || "default";
        if(types[campaigntype]){
            types[campaigntype].select();
        }
        if(campaigntype != "default")
            content.find('#campaign-type-form .campaign-type-'+campaigntype).show();
        if(data.postbacks.length > 0){
			content.find('#campaign-initial-postback .campaign-postback').val(data.postbacks[0]);
			for(var i = 1; i < data.postbacks.length; i++){
				content.find('#campaign-initial-postback').append('<li><textarea class="campaign-postback">'+data.postbacks[i]+'</textarea></li>');
			}
		}
    }
    if(countlyAttributionConfig["custom_links"]){
        content.find(".attribution-generated").hide();
    }
    else{
        content.find(".attribution-custom").hide();
    }
	content.find('.btn-close').on('click', function(){
		$("#overlay").trigger('click');
	});
    content.find("#campaign-type .text").text(jQuery.i18n.map["attribution.campaign-type-"+campaigntype]);
    content.find("#campaign-type .segmentation-option").on("click", function () {
		content.find('#campaign-type-form .campaign-type').hide();
		content.find('#campaign-type-form .campaign-type-'+$(this).data("value")).show();
        if(types[$(this).data("value")]){
            types[$(this).data("value")].select();
        }
        else if($(this).data("value") == "default"){
            content.find(".platform-links").show();
            $(".campaign-link").val(url+formdata["_id"]);
        }
            
        var dialogHeight = content.outerHeight();
        dialog.css({
            "height":dialogHeight,
            "margin-top":Math.floor(-dialogHeight / 2)
        });
        campaigntype = $(this).data("value");
	});
	content.find('.btn-add-postback').on('click', function(){
		content.find('#campaign-initial-postback').append('<li><textarea class="campaign-postback"></textarea></li>');
		var dialogHeight = content.outerHeight(),
		dialogWidth = content.outerWidth();
		dialog.css({
			"height":dialogHeight,
			"margin-top":Math.floor(-dialogHeight / 2),
			"width":dialogWidth,
			"margin-left":Math.floor(-dialogWidth / 2)
		});
	});
	function save(){
		var args = {};
        if(typeof data != "undefined"){
            args._id = data._id;
        }
        else if(countlyAttributionConfig["custom_links"]){
            args._id = content.find("#campaign-path").val();
        }
        else{
            args._id = formdata["_id"];
        }
		args.name = content.find("#campaign-name").val();
		args.link = formdata["default"];
		args.cost = content.find("#campaign-cost").val() || 0;
		args.costtype = costtype;
		args.type = campaigntype;
        if(campaigntype != "default" && types[campaigntype]){
            args.typedata = {};
            args.typedata[campaigntype] = types[campaigntype].save();
        }
        args.fingerprint = (content.find("#campaign-fingerprint").is(':checked')) ? true : false;
		args.links = {};
		args.postbacks = [];
		var val;
		for(var i in platformlinks){
			val = formdata[i];
			if(val && val.length && val.length > 0){
				args.links[i] = val;
			}
		}
		content.find(".campaign-postback").each(function(){
			val = $( this ).val();
			if(val.length && val.length > 0){
				args.postbacks.push(val);
			}
		});
        if(typeof data != "undefined"){
            $.when(countlyAttribution.update(args)).then(function (data) {
				if(data.result == "Success"){
					$("#overlay").trigger('click');
					app.activeView.refresh();
                    data.result = "Updated";
				}
                if(data.result === "Not enough args")
                    CountlyHelpers.alert(jQuery.i18n.map["attribution.not-enough-args"], "red");
                else
                    CountlyHelpers.alert(data.result, "red");
			});
        }
        else{
            $.when(countlyAttribution.create(args)).then(function (data) {
                if(data.result == "Success"){
                    $("#overlay").trigger('click');
                    app.activeView.refresh();
                }
                else{
                    if(data.result === "Not enough args")
                        CountlyHelpers.alert(jQuery.i18n.map["attribution.not-enough-args"], "red");
                    else
                        CountlyHelpers.alert(data.result, "red");
                }
            });
        }
	}
    content.find('.btn-create').on('click', save);
    content.find('.btn-update').on('click', save);
	content.find('.fa-info').tipsy({gravity:$.fn.tipsy.autoNS, title:function () {
        return ($(this).data("help")) ? jQuery.i18n.map[$(this).data("help")] : "";
    }, fade:true, offset:5, cssClass:'yellow', opacity:1, html:true});
	
	if(last){
		formdata["default"] = last.link;
		content.find(".details .link textarea").val(last.link);
		content.find("#campaign-redirect-default .fa-check").css("display", "inline-block");
	}
	var val;
	for(var i in platformlinks){
		var link = i.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();}).replace(/-/g, " ").replace("Ios", "iOS");
		if(!platformlinks[i])
			content.find('.campaign-platform').append('<li id="campaign-redirect-'+i+'"><div class="platform">'+link+':</div><span class="fa fa-check"></span></li>');
		else
			content.find('.campaign-platform').append('<li id="campaign-redirect-'+i+'"><div class="platform">'+link+': <i class="fa fa-info" style="margin-left:5px; color:#CCC;" data-help="'+platformlinks[i]+'"></i></div><span class="fa fa-check"></span></li>');
        if(typeof data != "undefined"){
            val = data.links[i];
			if(val && val.length && val.length > 0){
				formdata[i] = val;
				content.find("#campaign-redirect-"+i+" .fa-check").css("display", "inline-block");
			}
        }
		else if(last){
			val = last.links[i];
			if(val && val.length && val.length > 0){
				formdata[i] = val;
				content.find("#campaign-redirect-"+i+" .fa-check").css("display", "inline-block");
			}
		}
	}
	var curPlatform = "default";
	content.find(".details .link textarea").on("keyup", function(){
		var val = $(this).val();
		formdata[curPlatform] = val;
		if(val.trim().length > 0)
			content.find("#campaign-redirect-"+curPlatform+" .fa-check").css("display", "inline-block");
		else
			content.find("#campaign-redirect-"+curPlatform+" .fa-check").css("display", "none");
			
	});
	if(last){
		costtype = last.costtype;
	}
	content.find("#campaign-cost-type .text").text(jQuery.i18n.map["attribution.cost-"+costtype]);
	content.find("#campaign-cost-type .segmentation-option").on("click", function () {
		costtype = $(this).data("value");
	});
	content.find('.fa-info').tipsy({gravity:$.fn.tipsy.autoNS, title:function () {
        return ($(this).data("help")) ? jQuery.i18n.map[$(this).data("help")] : "";
    }, fade:true, offset:5, cssClass:'yellow', opacity:1, html:true});
	content.find(".campaign-platform li").on("click", function(){
        var placeholders = {
            "default":"http://yourdomain.com",
            "android":"https://play.google.com/store/apps/details?id=app-id",
            "ios":"https://itunes.apple.com/us/app/app-name/app-id",
            "android-custom-scheme":"myapp://somedata",
            "ios-custom-scheme":"myapp://somedata",
            "kindle":"http://www.amazon.com/gp/product/product-code",
            "windows-phone":"http://windowsphone.com/s?appId=app-id"
        };
		content.find(".campaign-platform li").each(function() {
			$( this ).removeClass("selected");
		});
		$(this).addClass("selected");
		curPlatform = this.id.replace("campaign-redirect-", "");
		content.find(".details .link textarea").val(formdata[curPlatform]);
		content.find(".details .link textarea").attr("placeholder", placeholders[curPlatform] || "");
	});
	CountlyHelpers.initializeSelect(content);
	CountlyHelpers.revealDialog(dialog);
}
//register views
app.attributionView = new AttributionView();
app.attributionDetailsView = new AttributionDetailsView();

app.route('/attribution', 'attribution', function () {
	this.renderWhenReady(this.attributionView);
});

app.route('/attribution/:details', 'attributiondata', function (id) {
	this.attributionDetailsView._id = id;
	this.renderWhenReady(this.attributionDetailsView);
});



$( document ).ready(function() {
    app.addAppSwitchCallback(function(appId){
        countlyAttribution.loadList(appId);
    });
	$.get(countlyGlobal["path"]+'/attribution/templates/form.html', function(src){
        $("body").append(src);
    });
	var menu = '<a href="#/attribution" class="item" id="attribution-menu">'+
        '<div class="logo ion-pricetags"></div>'+
        '<div class="text" data-localize="attribution.title"></div>'+
    '</a>';
	
	if($('#mobile-type #management-menu').length)
		$('#mobile-type #management-menu').before(menu);
	else
		$('#mobile-type').append(menu);
    
    if($('#web-type #management-menu').length)
		$('#web-type #management-menu').before(menu);
	else
		$('#web-type').append(menu);
    
    //check if configuration view exists
    if(app.configurationsView){
        app.configurationsView.registerLabel("attribution", "attribution.title");
        app.configurationsView.registerLabel("attribution-custom_links", "attribution.allow-custom-links");
        app.configurationsView.registerLabel("attribution-pass_campaign", "attribution.pass-campaign");
    }
});


function sha1(str) {
  //  discuss at: http://phpjs.org/functions/sha1/
  // original by: Webtoolkit.info (http://www.webtoolkit.info/)
  // improved by: Michael White (http://getsprink.com)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  //    input by: Brett Zamir (http://brett-zamir.me)
  //  depends on: utf8_encode
  //   example 1: sha1('Kevin van Zonneveld');
  //   returns 1: '54916d2e62f65b3afa6e192e6a601cdbe5cb5897'

  var rotate_left = function(n, s) {
    var t4 = (n << s) | (n >>> (32 - s));
    return t4;
  };

  /*var lsb_hex = function (val) { // Not in use; needed?
    var str="";
    var i;
    var vh;
    var vl;

    for ( i=0; i<=6; i+=2 ) {
      vh = (val>>>(i*4+4))&0x0f;
      vl = (val>>>(i*4))&0x0f;
      str += vh.toString(16) + vl.toString(16);
    }
    return str;
  };*/

  var cvt_hex = function(val) {
    var str = '';
    var i;
    var v;

    for (i = 7; i >= 0; i--) {
      v = (val >>> (i * 4)) & 0x0f;
      str += v.toString(16);
    }
    return str;
  };

  var blockstart;
  var i, j;
  var W = new Array(80);
  var H0 = 0x67452301;
  var H1 = 0xEFCDAB89;
  var H2 = 0x98BADCFE;
  var H3 = 0x10325476;
  var H4 = 0xC3D2E1F0;
  var A, B, C, D, E;
  var temp;

  var str_len = str.length;

  var word_array = [];
  for (i = 0; i < str_len - 3; i += 4) {
    j = str.charCodeAt(i) << 24 | str.charCodeAt(i + 1) << 16 | str.charCodeAt(i + 2) << 8 | str.charCodeAt(i + 3);
    word_array.push(j);
  }

  switch (str_len % 4) {
    case 0:
      i = 0x080000000;
      break;
    case 1:
      i = str.charCodeAt(str_len - 1) << 24 | 0x0800000;
      break;
    case 2:
      i = str.charCodeAt(str_len - 2) << 24 | str.charCodeAt(str_len - 1) << 16 | 0x08000;
      break;
    case 3:
      i = str.charCodeAt(str_len - 3) << 24 | str.charCodeAt(str_len - 2) << 16 | str.charCodeAt(str_len - 1) <<
        8 | 0x80;
      break;
  }

  word_array.push(i);

  while ((word_array.length % 16) != 14) {
    word_array.push(0);
  }

  word_array.push(str_len >>> 29);
  word_array.push((str_len << 3) & 0x0ffffffff);

  for (blockstart = 0; blockstart < word_array.length; blockstart += 16) {
    for (i = 0; i < 16; i++) {
      W[i] = word_array[blockstart + i];
    }
    for (i = 16; i <= 79; i++) {
      W[i] = rotate_left(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);
    }

    A = H0;
    B = H1;
    C = H2;
    D = H3;
    E = H4;

    for (i = 0; i <= 19; i++) {
      temp = (rotate_left(A, 5) + ((B & C) | (~B & D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotate_left(B, 30);
      B = A;
      A = temp;
    }

    for (i = 20; i <= 39; i++) {
      temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotate_left(B, 30);
      B = A;
      A = temp;
    }

    for (i = 40; i <= 59; i++) {
      temp = (rotate_left(A, 5) + ((B & C) | (B & D) | (C & D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotate_left(B, 30);
      B = A;
      A = temp;
    }

    for (i = 60; i <= 79; i++) {
      temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotate_left(B, 30);
      B = A;
      A = temp;
    }

    H0 = (H0 + A) & 0x0ffffffff;
    H1 = (H1 + B) & 0x0ffffffff;
    H2 = (H2 + C) & 0x0ffffffff;
    H3 = (H3 + D) & 0x0ffffffff;
    H4 = (H4 + E) & 0x0ffffffff;
  }

  temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);
  return temp.toLowerCase();
}