(function (countlyBlocks, $, undefined) {
    //Private Properties
    var _data = {};
    
    //Public Methods
    countlyBlocks.initialize = function () {
		return $.ajax({
			type:"GET",
			url:countlyCommon.API_URL + "/o/blocks",
			data:{
                api_key:countlyGlobal['member'].api_key,
                app_id:countlyCommon.ACTIVE_APP_ID
            },
			success:function (json) {
				_data = json;
			}
		});
    };
    
    countlyBlocks.update = function (blocks, callback) {
		$.ajax({
			type:"GET",
			url:countlyCommon.API_URL + "/i/blocks/create",
			data:{
                blocks:JSON.stringify(blocks),
                api_key:countlyGlobal['member'].api_key,
                app_id:countlyCommon.ACTIVE_APP_ID
            },
			success:function (json) {
                if(callback)
                    callback(null, json);
			},
			error:function (json) {
                if(callback)
                    callback(true, json);
			}
		});
    };
    
    countlyBlocks.delete = function (id, callback) {
		$.ajax({
			type:"GET",
			url:countlyCommon.API_URL + "/i/blocks/delete",
			data:{
                block_id:id,
                api_key:countlyGlobal['member'].api_key,
                app_id:countlyCommon.ACTIVE_APP_ID
            },
			success:function (json) {
                if(callback)
                    callback(null, json);
			},
			error:function (json) {
                if(callback)
                    callback(true, json);
			}
		});
    };
    
    countlyBlocks.getData = function () {
		return _data;
    };
}(window.countlyBlocks = window.countlyBlocks || {}, jQuery));