window.BlocksView = countlyView.extend({
    initialize:function () {
        this.data = {};
        this.cache = {};
        this.changes = {};
    },
    beforeRender: function() {
        if(this.template)
            return $.when(countlyBlocks.initialize()).then(function () {});
        else{
            var self = this;
            return $.when($.get(countlyGlobal["path"]+'/block/templates/blocks.html', function(src){
                self.template = Handlebars.compile(src);
            }), countlyBlocks.initialize()).then(function () {});
        }
    },
    renderCommon:function (isRefresh) {
        this.data = countlyBlocks.getData();
        this.templateData = {
            "page-title": jQuery.i18n.prop('block.rule-for', countlyGlobal["apps"][countlyCommon.ACTIVE_APP_ID].name)
        };
        var self = this;
        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));
            this.dtable = $('.d-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": self.data,
				"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
					$(nRow).attr("id", aData._id);
				},
                "aoColumns": [
                    {"mData": function(row, type){
                        if(row.type == "event"){
                            if(row.key == "*")
                                return jQuery.i18n.map["block."+row.type]+": "+jQuery.i18n.map["block.all-events"];
                            else
                                return jQuery.i18n.map["block."+row.type]+": "+row.key;
                        } 
                        else{
                            return jQuery.i18n.map["block."+row.type];
                        }
                    }, "sType":"string", "sTitle": jQuery.i18n.map["block.type"] },
                    {"mData": function(row, type){
                        if(row.rule == "{}")
                            return jQuery.i18n.map["block.block-all"];
                        else
                            return row.name || row.rule}, "sType":"string", "sTitle": jQuery.i18n.map["block.rule"] },
                    {"mData": function(row, type){return "<a class='icon-button red delete-rule' data-id='"+row._id+"'>"+jQuery.i18n.map["block.delete"]+"</a>"}, "sType":"string", "sTitle": "", "bSortable":false, "sClass":"shrink center" }
                ]
            }));
            $.when(countlySegmentation.initialize("[CLY]_session")).then(function () {
                self.initDrill();
            });
            $("#block-selector #block-types .button").on("click", function () {
                $("#block-selector #block-types .button").removeClass("active").removeClass("selected");
                $(this).addClass("active").addClass("selected");
				if($(this).data("value") == "event")
                    $("#event-selector").show();
                else
                    $("#event-selector").hide();
			});
            $("#event-selector .segmentation-option").on("click", function () {
                $("#event-selector .text").data("value", $(this).data("value"));
			});
            $(".delete-rule").on("click", function(){
                var $this = $(this);
                CountlyHelpers.confirm(jQuery.i18n.map["block.confirm-delete"], "red", function(result){
                    if (!result) {
                        return true;
                    }
                    countlyBlocks.delete($this.data("id"), function(){
                        app.activeView.render();
                    });
                });
            });
        }
    },
    refresh:function (){
    },
    initDrill: function() {
        var self = this;
        this.filterObj = {};
        $(".blocks").on("click", "#toggle-filter", function() {
            $("#filter-view").toggle();
            self.adjustFilters();
        });

        var usedFilters = {},
            currEvent = "";

        function getFilters() {
            usedFilters = {};

            $(".query:visible").each(function (index) {
                var filterType = $(this).find(".filter-name .text").data("type");

                // number and date types can be used multiple times for range queries
                if (filterType != "n" && filterType != "d") {
                    usedFilters[$(this).find(".filter-name .text").data("value")] = true;
                }
            });

            var filters_all = countlySegmentation.getFilters(currEvent),
                allFilters = "";
            filters_all.splice(2, 0, {id:"up.ip", name:jQuery.i18n.map["block.ip-address"], type:"s"});
            var filters = [];
            for(var i = 0; i < filters_all.length; i++){
                if(filters_all[i].type != "d" && filters_all[i].id != "up.sc"){
                    filters.push(filters_all[i]);
                }
            }

            if (filters.length == 0) {
                CountlyHelpers.alert(jQuery.i18n.map["drill.no-filters"], "black");
            }

            for (var i = 0; i < filters.length; i++) {
                if(typeof filters[i].id != "undefined"){
                    if (usedFilters[filters[i].id] == true) {
                        continue;
                    }
    
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", filters[i].type);
                    tmpItem.attr("data-value", filters[i].id);
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
                else{
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("group");
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
            }

            return allFilters;
        }

        function getFilterObjAndByVal() {
            return self.getFilterObjAndByVal();
        }

        function initApply() {

        }
        
        $(".event-select").on("click", function() {
                var allEvents = countlyEvent.getEvents(),
                    eventStr = "";
                allEvents.unshift({key:"*",name:jQuery.i18n.map["block.any-events"]});
                for (var i = 0; i < allEvents.length; i++) {
                    var tmpItem = $("<div>");

                    tmpItem.addClass("item");
                    tmpItem.attr("data-value", allEvents[i].key);
                    tmpItem.text(allEvents[i].name);

                    eventStr += tmpItem.prop('outerHTML');
                }

                $(this).find(".select-items>div").html(eventStr);
            });

            $(".event-select").on("click", ".item", function() {
                var selectedItem = $(this).parents(".cly-select").find(".text");
                selectedItem.text($(this).text());
                selectedItem.data("value", $(this).data("value"));

                currEvent = $(this).data("value");
                
                if(currEvent == "*")
                    currEvent = "[CLY]_session";

                $(this).parents(".cly-select").removeClass("dark");

                countlySegmentation.reset();

                $.when(countlySegmentation.initialize(currEvent)).then(function () {
                    $("#drill").replaceWith($("#defalt-filter-block").clone(true));
                    self.adjustFilters();
                });
            });

            $("#segmentation").on("click", ".filter-connector", function() {
                var byUsed = false;
                $(".query:visible").each(function (index) {
                    byUsed = byUsed || ($(this).find(".filter-connector .text").data("value") == "BY");
                });

                if (byUsed) {
                    $(this).find(".item.by").hide();
                } else {
                    $(this).find(".item.by").show();
                }
            });

        $("#segmentation").on("click", ".filter-connector", function() {
            var byUsed = false;
            $(".query:visible").each(function (index) {
                byUsed = byUsed || ($(this).find(".filter-connector .text").data("value") == "BY");
            });

            if (byUsed) {
                $(this).find(".item.by").hide();
            } else {
                $(this).find(".item.by").show();
            }
        });

        $("#segmentation").on("click", ".filter-name", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") == "OR") {
                var existingFilters = [],
                    orFilters = [],
                    orFilterStr = "";

                $(".query:visible:not(.by)").each(function (index) {
                    if ($(this).find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                        return false;
                    }

                    if (existingFilters.indexOf($(this).find(".filter-name .text").data("value")) == -1) {
                        orFilters.push({
                            type: $(this).find(".filter-name .text").data("type"),
                            id: $(this).find(".filter-name .text").data("value"),
                            name: $(this).find(".filter-name .text").text()
                        });

                        existingFilters.push($(this).find(".filter-name .text").data("value"));
                    }
                });

                for (var i = 0; i < orFilters.length; i++) {
                    var tmpItem = $("<div>");

                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", orFilters[i].type);
                    tmpItem.attr("data-value", orFilters[i].id);
                    tmpItem.text(orFilters[i].name);

                    orFilterStr += tmpItem.prop('outerHTML');
                }

                $(this).find(".select-items>div").html(orFilterStr);
            } else {
                $(this).find(".select-items>div").html(getFilters());
            }

            initApply();
        });

        $("#segmentation").on("click", ".filter-name .item", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") != "BY") {
                $(this).parents(".filter-name").siblings(".filter-type").replaceWith($("#defalt-filter-block").clone(true).find(".filter-type"));
                $(this).parents(".filter-name").siblings(".filter-type").removeClass("disabled");

                $(this).parents(".filter-name").siblings(".filter-value").addClass("hidden");

                if ($(this).data("type") == "l") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "bl") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").addClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "n") {
                    $(this).parents(".filter-name").siblings(".filter-value.num").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").show();
                }  else if ($(this).data("type") == "s") {
                    $(this).parents(".filter-name").siblings(".filter-value.string").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                }  else if ($(this).data("type") == "d") {
                    $(this).parents(".filter-name").siblings(".filter-value.date").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.eq").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lt").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lte").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").trigger("click");
                    $(this).parents(".filter-name").siblings(".filter-value.date").find(".open-date-picker").trigger("click");
                }
            }
            
            $(this).parents(".query").find(".filter-value.num input").val("");
            $(this).parents(".query").find(".filter-value.date input").val("");
            $(this).parents(".query").find(".filter-value.date input").data("timestamp", null)
            $(this).parents(".query").find(".filter-value.string input").val("");
            
            var self = $(this).parents(".query").find(".filter-value .select-items>div");
            self.html("<div></div>");
            function setUpFilterValues(filterValues, filterNames, biglist){
                var filterValStr = "";
                
                if(biglist){
                    var tmpItem = $("<div>");
                    tmpItem.addClass("warning");
                    tmpItem.text(jQuery.i18n.map["drill.big-list-warning"]);       
                    filterValStr += tmpItem.prop('outerHTML');
                }
    
                if (jQuery.isArray(filterValues)) {
                    for (var i = 0; i < filterValues.length; i++) {
                        var tmpItem = $("<div>");
        
                        tmpItem.addClass("item");
                        tmpItem.attr("data-value", filterValues[i]);
                        tmpItem.text(filterNames[i]);
        
                        filterValStr += tmpItem.prop('outerHTML');
                    }
                } else {
                    for (var p in filterValues) {
                        var tmpItem = $("<div>");
                        tmpItem.addClass("group");
                        tmpItem.text(p);
            
                        filterValStr += tmpItem.prop('outerHTML');
                        for (var i = 0; i < filterValues[p].length; i++) {
                            var tmpItem = $("<div>");
            
                            tmpItem.addClass("item");
                            tmpItem.attr("data-value", filterValues[p][i]);
                            tmpItem.text(countlyCommon.decode(filterValues[p][i]));
            
                            filterValStr += tmpItem.prop('outerHTML');
                        }
                    }
                }
    
                self.html(filterValStr);
            }
            
            if($(this).data("type") == "bl"){
                var prop = $(this).data("value");
                $(this).parents(".query").find(".filter-value").addClass("loading");

                countlySegmentation.getBigListMetaData(prop, null, function(values, names){
                    self.parents(".query").find(".filter-value").removeClass("loading");
                    setUpFilterValues(values, names,  names.length >= countlyGlobal["list_limit"]);
                    var timeout = null;
                    self.parents(".query").find(".filter-value").on("keyup", ".search input", function(e) {
                        e.stopPropagation();
                        var search = $(this).val();
                        var parent = $(this).parents(".filter-value").find(".select-items");
                        if(!parent.find(".table-loader").length)
                            parent.prepend("<div class='table-loader'></div>");
                        if(timeout)
                        {
                            clearTimeout(timeout);
                            timeout = null;
                        }
                        timeout = setTimeout(function(){
                            countlySegmentation.getBigListMetaData(prop, search, function(values, names){
                                parent.find(".table-loader").remove();
                                setUpFilterValues(values, names, names.length >= countlyGlobal["list_limit"]);
                            });                                    
                        }, 1000);
                    });
                });
            }
            else{
                setUpFilterValues(countlySegmentation.getFilterValues($(this).data("value")), countlySegmentation.getFilterNames($(this).data("value")));
            }

            var selectedItem = $(this).parents(".cly-select").find(".text");
            selectedItem.text($(this).text());
            selectedItem.data("value", $(this).data("value"));
            selectedItem.data("type", $(this).data("type"));
        });

        $("#segmentation").on("click", ".filter-value .item", function() {
            setTimeout(function() { initApply(); }, 0);
        });

        $("#segmentation").on("keyup", ".filter-value input",function(event) {
            initApply();
        });

        $("#segmentation").on("keydown", ".filter-value.num input",function(event) {
            // Allow: backspace, delete, tab, escape, and enter
            if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
                // Allow: Ctrl+A
                (event.keyCode == 65 && event.ctrlKey === true) ||
                // Allow: home, end, left, right
                (event.keyCode >= 35 && event.keyCode <= 39)) {
                // let it happen, don't do anything
                return;
            }
            else {
                // Ensure that it is a number and stop the keypress
                if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                    event.preventDefault();
                }
            }
        });

        $("#segmentation").on("keydown", ".filter-value.date input",function(event) {
            event.preventDefault();
        });

        $("#segmentation").on("click", ".filter-connector .item", function() {
            $(this).parents(".query").find(".filters").replaceWith($("#defalt-filter-block").clone(true).find(".filters"));

            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");
            self.adjustFilters();

            $(this).parents(".query").removeClass("by");

            if ($(this).data("value") == "BY") {
                $(this).parents(".query").addClass("by");
                $(this).parents(".query").find(".filter-type").hide();
                $(this).parents(".query").find(".filter-value").hide();
                $(this).parents(".query").find(".filter-connector").addClass("disabled");
            } else if ($(this).data("value") == "AND") {

            } else if ($(this).data("value") == "OR") {

            }

            initApply();
        });

        $("#segmentation").on("click", ".query .delete", function() {
            $(this).parent(".query").remove();
            $(".query:visible:last-child").find(".filter-name").removeClass("disabled");
            $(".query:visible:last-child").find(".filter-type").removeClass("disabled");
            self.adjustFilters();
            initApply();
            var filterData = getFilterObjAndByVal();
            self.filterObj = filterData.dbFilter;
        });

        $("#segmentation").on("click", ".open-date-picker", function(e) {
            $(this).next(".date-picker").show();
            $(this).next(".date-picker").find(".calendar").datepicker({
                numberOfMonths:1,
                showOtherMonths:true,
                maxDate:moment().subtract('days', 1).toDate(),
                onSelect:function (selectedDate) {
                    var instance = $(this).data("datepicker"),
                        date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings),
                        currMoment = moment(date);

                    $(this).parents(".date-picker").prev(".open-date-picker").val(countlyCommon.formatDate(moment(date),"DD MMMM, YYYY"));
                    $(this).parents(".date-picker").prev(".open-date-picker").data("timestamp", moment(currMoment.format("DD MMMM, YYYY"), "DD MMMM, YYYY").unix());
                    $(".date-picker").hide();
                    initApply();
                }
            });

            $.datepicker.setDefaults($.datepicker.regional[""]);
            $(this).next(".date-picker").find(".calendar").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

            $(this).next(".date-picker").click(function(e) {
                e.stopPropagation();
            });

            e.stopPropagation();
        });

        $("#filter-add-container").on("click", function() {
            if ($(".query:visible:not(.by):last").find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                $(".query:visible:not(.by):last").find(".filter-name").addClass("req");
                return false;
            }

            var filterBlocks = $("#filter-blocks"),
                defaultFilters = $("#defalt-filter-block").html();

            filterBlocks.append(defaultFilters);
            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");

            var byFilter = $("#filter-blocks").find(".query.by").clone(true);
            $("#filter-blocks").find(".query.by").remove();
            $("#filter-blocks").append(byFilter);

            self.adjustFilters();
        });

        $("#apply-filter").on("click", function() {
            if ($(this).hasClass("disabled")) {
                return true;
            }
            self.showLoader = true;
            var filterData = getFilterObjAndByVal();
            var needData = false;

            self.filterObj = filterData.dbFilter;

            self.loadAndRefresh();
        });

        $("#remove-filter").on("click", function(e) {
            self.filterObj = {};
            self.showLoader = true;
            var wasFilterVisible = $("#filter-view").is(":visible");

            $("#filter-view").replaceWith(self.filterBlockClone.clone(true));
            if (wasFilterVisible) {
                $("#filter-view").show();
                self.adjustFilters();
            }

            $("#current-filter").hide();
            $("#no-filter").show();

            //countlyFunnel.setFilter(self.filterObj);
            self.loadAndRefresh();

            e.stopPropagation();
        });

        $(window).click(function() {
            $(".date-picker").hide();
        });
    },
    getFilterObjAndByVal: function(){
        var filterObj = {},
            filterObjTypes = {},
            byVal = "",
            byValText = "",
            bookmarkText = "";

        $(".query:visible").each(function (index) {
            var tmpConnector = $(this).find(".filter-connector .text").data("value"),
            tmpText = $(this).find(".filter-name .text").text(),
            tmpTypeText = $(this).find(".filter-type .text").text(),
            tmpValText = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").val() ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").text(),
            tmpName = $(this).find(".filter-name .text").data("value"),
            tmpType = $(this).find(".filter-type .text").data("value"),
            tmpVal = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").data("timestamp") ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").data("value"),
            tmpDataType = $(this).find(".filter-name .text").data("type");

            if(typeof tmpVal == "boolean")
                tmpVal = tmpVal+"";

            if (tmpConnector != "BY") {
                if (!tmpVal) {
                    return true;
                }

                if (tmpConnector && index != 0) {
                    bookmarkText += " [" + tmpConnector + "] ";
                }

                bookmarkText += tmpText + " " + tmpTypeText + " " + tmpValText;

                if (!filterObj[tmpName]) {
                    filterObj[tmpName] = [];
                }

                if (!filterObjTypes[tmpName]) {
                    filterObjTypes[tmpName] = [];
                }

                if (tmpDataType == "d" || tmpDataType == "n") {
                    tmpVal = parseInt(tmpVal, 10);
                }

                var exp = {};

                if (tmpType == "=" || tmpType == "!=") {
                    exp = tmpVal;
                } else {
                    exp[tmpType] = tmpVal;
                }

                filterObj[tmpName].push(exp);
                filterObjTypes[tmpName].push(tmpType);
            } else {
                byVal = tmpName;
                byValText = tmpText;
            }
        });

        var dbFilter = {};

        for (var filter in filterObj) {
            dbFilter[filter] = {};
            for (var i = 0; i < filterObj[filter].length; i++) {
                if(_.isObject(filterObj[filter][i])) {
                    for (var tmpFilter in filterObj[filter][i]) {
                        dbFilter[filter][tmpFilter] = filterObj[filter][i][tmpFilter];
                    }
                } else if (filterObjTypes[filter][i] == "!=") {
                    if (!dbFilter[filter]["$nin"]) {
                        dbFilter[filter]["$nin"] = [];
                    }

                    dbFilter[filter]["$nin"].push(filterObj[filter][i]);
                } else {
                    if (!dbFilter[filter]["$in"]) {
                        dbFilter[filter]["$in"] = [];
                    }

                    dbFilter[filter]["$in"].push(filterObj[filter][i]);
                }
            }
        }

        return {
            bookmarkText: bookmarkText,
            dbFilter: dbFilter,
            byVal: byVal,
            byValText: byValText
        };
    },
    adjustFilters: function() {
        if (!$("#filter-view").is(":visible")) {
            return;
        }
    
        var queryCount = $("#filter-blocks").find(".query:visible").length;
    
        if (queryCount == 0) {
            $("#filter-add-container").trigger("click");
        }
    
        $(".query:visible").each(function (index) {
            $(this).find(".connector div").hide();
    
            if (queryCount > 1) {
                $(this).find(".and-or").show();
    
                if (index == 0) {
                    $(this).find(".and-or").hide();
                    $(this).find(".connector .middle-bottom").show();
                } else if (index == (queryCount - 1)) {
                    $(this).find(".connector .middle-top").show();
                } else {
                    $(this).find(".connector .top").show();
                    $(this).find(".connector .middle-bottom").show();
                }
    
                if (index == (queryCount - 1)) {
                    $(this).find(".filter-connector").removeClass("disabled");
                } else {
                    $(this).find(".filter-connector").addClass("disabled");
                }
            } else {
                $(this).find(".and-or").hide();
            }
    
            if ($(this).find(".filter-connector .text").data("value") == "BY") {
                $(this).find(".cly-select").removeClass("disabled");
                $(this).find(".filter-connector").addClass("disabled");
                $(this).prev(".query").find(".filter-connector").removeClass("disabled");
                $(this).prev(".query").find(".filter-name").removeClass("disabled");
    
                if ($(this).prev(".query").find(".filter-name .text").text() != "Select a Filter") {
                    $(this).prev(".query").find(".filter-type").removeClass("disabled");
                }
            }
        });
    
        setTimeout(function() { $("#filter-blocks").removeClass("empty"); }, 1000);
    },
    loadAndRefresh: function() {
        var self = this;
        var filter = {};
        for(var i in this.filterObj){
            filter[i] = this.filterObj[i];
        }
        $(".required").fadeOut().remove();
        var reqSpan = $("<span>").addClass("required").text("*");
        var type = $("#block-selector #block-types .button.active").data("value");
        var key = $("#event-selector .text").data("value");
        if(type != "all" && type != "session" && type != "event"){
            $("#block-selector").append(reqSpan.clone());
        }
        
        if(type == "event" && !key){
            $("#event-selector").append(reqSpan.clone());
        }
        
        if ($(".required").length) {
            $(".required").fadeIn();
            return false;
        } else if ($(".red-text").length) {
            return false;
        }
        countlyBlocks.update({
                type:type, 
                key:key,
                name: self.getFilterObjAndByVal().bookmarkText,
                rule:filter
        }, function(){
            app.activeView.render();
        });
    }
});

//register views
app.blocksView = new BlocksView();
app.route('/manage/blocks', 'blocks', function () {
    if(countlyGlobal["member"].global_admin || countlyGlobal["admin_apps"][countlyCommon.ACTIVE_APP_ID]){
        this.renderWhenReady(this.blocksView);
    }
    else{
        app.navigate("/", true);
    }
});

$( document ).ready(function() {
    var style = "display:none;";
    if(countlyGlobal["member"].global_admin || countlyGlobal["admin_apps"][countlyCommon.ACTIVE_APP_ID]){
        style = "";
    }
    var menu = '<a href="#/manage/blocks" class="item block-request-menu" style="'+style+'">'+
        '<div class="logo-icon fa fa-ban"></div>'+
        '<div class="text" data-localize="block.title"></div>'+
    '</a>';
    if($('#management-submenu .help-toggle').length)
        $('#management-submenu .help-toggle').before(menu);
    
    //listen for UI app change
    app.addAppSwitchCallback(function(appId){
        if(countlyGlobal["member"].global_admin || countlyGlobal["admin_apps"][appId]){
            $(".block-request-menu").show();
        }
        else{
            $(".block-request-menu").hide();
        }
    });
});