window.DrillView = countlyView.extend({
	beforeRender: function() {
        this.bookmarkList = {};
		var self = this;
		if(!this.template){
			return $.when($.get(countlyGlobal["path"]+'/drill/templates/drill.html', function(src){
				self.template = Handlebars.compile(src);
			})).then(function () {});
		}
    },
    filterObj:{},
    byVal:"",
    graphType:"line",
    graphVal:"times",
    graphBucket:"daily",
    drillChartDP:{},
    drillChartData:{},
    activeSegmentForTable:"",
    draw:function (needData, dateChange){
        if (this.byVal == "") {
            this.graphType = "line";
        }

        this.initBuckets();

        var self = this;
        if (needData) {
            $.when(countlySegmentation.getSegmentationData()).then(function(){
                if (self.byVal == "") {
                    self.drillChartDP = countlySegmentation.getSegmentationDP().chartDP;
                } else {
                    self.drillChartDP = countlySegmentation.getSegmentationDPWithProjection().chartDP;
                }

                self.initBuckets();
                self.fillTable();
                self.drawGraph(dateChange);
            });
        } else {
            self.fillTable();
            self.drawGraph(false);
        }

        if (countlySegmentation.getEvent() == "[CLY]_session" || countlySegmentation.getEvent() == "[CLY]_crash") {
            $(".graph-settings .value-sum").hide();
            $(".graph-settings").find(".value .button[data-value=average]").addClass("last");
        } else {
            $(".graph-settings .value-sum").show();
            $(".graph-settings").find(".value .button").removeClass("last");
        }
    },
    drawGraph:function (dateChange) {
        $("#drill").find("#geo-chart").hide();
        $("#drill").find("#dashboard-graph").show();
        $("#drill").find(".widget-content").removeClass("pie");
        $("#drill").find(".widget-content").removeClass("bar");
        $("#label-container").hide();

        if (this.byVal == "") {
            $("#label-container").find(".labels").html("");
            countlyCommon.drawTimeGraph(this.drillChartDP[this.graphVal], "#dashboard-graph", this.graphBucket);
        } else {
            if (this.byVal == "up.cc" && countlyGlobal["config"].use_google) {
                this.drawMap();
            } else if (countlySegmentation.isHistogram()) {
                countlyCommon.drawGraph(this.drillChartDP["bar"][this.graphVal], "#dashboard-graph", "bar");
            } else {
                if (this.graphType == "line") {
                    $("#label-container").show();

                    var lineChartData = this.drillChartDP[this.graphType][this.graphVal],
                        labels = _.pluck(lineChartData, "label"),
                        labelsEl = $("#label-container").find(".labels"),
                        labelsClone = labelsEl.clone(),
                        self = this;

                    for (var i = 0; i < lineChartData.length; i++) {
                        lineChartData[i].color = countlyCommon.GRAPH_COLORS[i];
                    }

                    labelsEl.html("");

                    for (var i = 0; i < labels.length; i++) {
                        labelsEl.append("<div class='label'><div class='color' style='background-color:" + countlyCommon.GRAPH_COLORS[i] + "'></div><div class='text' title='"+ labels[i] + "'>" + labels[i] + "</div></div>");
                    }

                    if (dateChange) {
                        labelsClone.find(".label").each(function(index) {
                            if ($(this).hasClass("hidden")) {
                                var text = $(this).text();
                                labelsEl.find(".label").filter(function() {
                                    return $(this).text() == text;
                                }).addClass("hidden");
                            }
                        });
                    }

                    labelsEl.find(".label").unbind('click');
                    labelsEl.find(".label").click(function() {
                        if ($(this).hasClass("hidden")) {
                            $(this).toggleClass("hidden");
                            countlyCommon.drawTimeGraph(getActiveLabelData(lineChartData), "#dashboard-graph", self.graphBucket);
                        } else if (labelsEl.find(".label:not(.hidden)").length > 1) {
                            $(this).toggleClass("hidden");
                            countlyCommon.drawTimeGraph(getActiveLabelData(lineChartData), "#dashboard-graph", self.graphBucket);
                        }
                    });

                    countlyCommon.drawTimeGraph(getActiveLabelData(lineChartData), "#dashboard-graph", this.graphBucket);
                } else {
                    var graphProps = {};

                    if (this.graphType == "pie") {
                        graphProps = {series: {pie: { innerRadius: 0.45 }}};
                        $("#drill").find(".widget-content").addClass("pie");
                    } else if (this.graphType == "bar") {
                        $("#drill").find(".widget-content").addClass("bar");
                    }

                    countlyCommon.drawGraph(this.drillChartDP[this.graphType][this.graphVal], "#dashboard-graph", this.graphType, graphProps);
                }
            }
        }

        if ($("#empty-graph").is(":hidden")) {
            $(".graph-settings").find(".type").show();

            if (countlySegmentation.isHistogram() || countlySegmentation.isMap()) {
                $("#label-container").find(".labels").html("");
                $(".graph-settings").find(".type").hide();
            } else if (this.byVal) {
                $(".graph-settings").find(".type").show();
            } else {
                $(".graph-settings").find(".type").hide();
            }
        }

        function getActiveLabelData(data) {
            var labels = _.pluck(data, "label"),
                newData = $.extend(true, [], data),
                newLabels = $.extend(true, [], labels);

            for (var i = 0; i < newLabels.length; i++) {
                newLabels[i] += "";
            }

            $("#label-container").find(".label").each(function (index) {
                var escapedLabel = _.escape($(this).text().replace(/(?:\r\n|\r|\n)/g, ''));

                if ($(this).hasClass("hidden") && newLabels.indexOf(escapedLabel) != -1) {
                    delete newLabels[newLabels.indexOf(escapedLabel)];
                }
            });

            newLabels = _.compact(newLabels);

            for (var j = 0; j < newData.length; j++) {
                if (newLabels.indexOf(newData[j].label + "") == -1) {
                    delete newData[j];
                }
            }

            return _.compact(newData);
        }
    },
    drawMap:function () {
        $("#empty-graph").hide();
        $("#drill").find("#geo-chart").show();
        $("#drill").find("#dashboard-graph").hide();

        var countries = this.getFilterTicks(),
            values = this.getFilterTickValues(),
            mapData = [];

        for (var i = 0; i < countries.length; i++) {
            mapData.push({
                country:countries[i],
                value:values[i]
            });
        }

        countlyMapHelper.drawGeoChart({height:335}, mapData);
    },
    getFilterTicks:function (needUnique) {
        var data = this.drillChartDP.bar[this.graphVal].ticks,
            ticks = [];

        for (i = 0; i < data.length; i++) {
            ticks.push(data[i][1]);
        }

        ticks = _.compact(ticks);
        ticks.sort();

        if (needUnique) {
            return _.uniq(ticks);
        } else {
            return ticks;
        }
    },
    getFilterTickValues:function () {
        var ticks = _.sortBy(this.drillChartDP.bar[this.graphVal].ticks, function(arr) { return arr[0]; }),
            tickValues = _.sortBy(this.drillChartDP.bar[this.graphVal].dp[0]["data"], function(arr) { return arr[0]; }),
            combinedArr = [];

        for (var i = 0; i < ticks.length; i++) {
            if (!ticks[i]) {
                continue;
            }

            combinedArr.push({
                tick:ticks[i][1],
                data:Math.round(tickValues[i][1]*100) / 100
            });
        }

        combinedArr = _.sortBy(combinedArr, function(obj) { return obj.tick; });

        return _.compact(_.pluck(combinedArr, "data"));
    },
    isFilterInt:function () {
        var vals = this.getFilterTicks(),
            isInt = true;

        for (var i = 0; i < vals.length; i++) {
            if(!_.isNumber(vals[i])) {
                isInt = false;
                break;
            }
        }

        return isInt;
    },
    isFilterDate:function () {
        var vals = this.getFilterTicks(),
            isDate = true;

        for (var i = 0; i < vals.length; i++) {
            if(!_.isNumber(vals[i]) || (vals[i] + "").length != 10) {
                isDate = false;
                break;
            }
        }

        return isDate;
    },
    initBuckets:function() {
        var numberOfDays = countlyCommon.periodObj.numberOfDays,
            $graphSettings = $(".graph-settings"),
            showBuckets = false;

        $graphSettings.find(".bucket .button").hide();
        $graphSettings.find(".bucket").hide();

        if (numberOfDays == 1) {
            this.graphBucket = "hourly";
            countlySegmentation.setBucket("hourly");
        } else {
            if (numberOfDays <= 7) {
                $graphSettings.find(".bucket .button[data-bucket=daily]").show();
                $graphSettings.find(".bucket .button[data-bucket=hourly]").show();
                showBuckets = true;
            }

            if (numberOfDays >= 30) {
                $graphSettings.find(".bucket .button[data-bucket=daily]").show();
                $graphSettings.find(".bucket .button[data-bucket=weekly]").show();
                showBuckets = true;
            }

            if (numberOfDays >= 60) {
                $graphSettings.find(".bucket .button[data-bucket=monthly]").show();
                showBuckets = true;
            }

            var currBucket = countlySegmentation.getBucket();

            if (currBucket) {
                this.graphBucket = currBucket;
                countlySegmentation.setBucket(currBucket);
            } else {
                $graphSettings.find(".bucket .button").removeClass("active");
                $graphSettings.find(".bucket .button[data-bucket=daily]").addClass("active");

                this.graphBucket = "daily";
                countlySegmentation.setBucket("daily");
            }
        }

        if (this.graphType == "line" && showBuckets && !countlySegmentation.isHistogram() && !countlySegmentation.isMap()) {
            $graphSettings.find(".bucket").show();
        }

        var bucketButtons = $graphSettings.find(".bucket .button");

        bucketButtons.removeClass("first").removeClass("last");
        bucketButtons.not(':hidden').first().addClass("first");
        bucketButtons.not(':hidden').last().addClass("last");
    },
    fillTable:function() {
        var currEvent = countlySegmentation.getEvent();

        if (this.byVal == "") {
            this.drillChartData = countlySegmentation.getSegmentationDP().chartData;

            $("#drill-table-for").hide();

            var aoColumns = [
                { "mData": "date", "sType":"customDate", "sTitle": jQuery.i18n.map["common.date"] },
                { "mData": "u", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.users"] },
                { "mData": "t", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times"] },
                { "mData": "a", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times-users"] }
            ];

            if (currEvent != "[CLY]_session" && currEvent != "[CLY]_crash") {
                aoColumns.push({ "mData": "s", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum"] });
                aoColumns.push({ "mData": "as", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum-users"] });
                aoColumns.push({ "mData": "dur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur"] });
                aoColumns.push({ "mData": "adur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur-users"] });
            }

            this.dtable = $('#drill-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": this.drillChartData || [],
                "aoColumns": aoColumns
            }));
        } else if (this.graphType != "line" || countlySegmentation.isHistogram() || countlySegmentation.isMap()) {
            this.drillChartData = countlySegmentation.getSegmentationDPWithProjection().aggregatedChartData;

            $("#drill-table-for").hide();

            if (countlySegmentation.isMap()) {
                for (var i = 0; i < this.drillChartData.length; i++) {
                    this.drillChartData[i].curr_segment = countlyLocation.getCountryName(this.drillChartData[i].curr_segment);
                }
            }

            var aoColumns = [
                { "mData": "curr_segment", "sTitle": jQuery.i18n.map["events.table.segmentation"] },
                { "mData": "u", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.users"] },
                { "mData": "t", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times"] },
                { "mData": "a", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times-users"] }
            ];

            if (currEvent != "[CLY]_session" && currEvent != "[CLY]_crash") {
                aoColumns.push({ "mData": "s", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum"] });
                aoColumns.push({ "mData": "as", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum-users"] });
                aoColumns.push({ "mData": "dur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur"] });
                aoColumns.push({ "mData": "adur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur-users"] });
            }

            this.dtable = $('#drill-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": this.drillChartData || [],
                "aoColumns": aoColumns
            }));
        } else {
            this.drillChartData = countlySegmentation.getSegmentationDPWithProjection().chartData;

            var tableForStr = "",
                firstSegment = "";

            for (var segment in this.drillChartData) {
                firstSegment = segment;
                break;
            }

            for (var segment in this.drillChartData) {
                var tmpItem = $("<div>");

                tmpItem.addClass("item");
                tmpItem.attr("data-value", segment);
                tmpItem.text(countlySegmentation.getUserPropertyLongName(this.byVal, segment));

                tableForStr += tmpItem.prop('outerHTML');
            }

            var tableFor = (this.activeSegmentForTable)? this.activeSegmentForTable : firstSegment;

            if (!_.isEmpty(this.drillChartData)) {
                $("#drill-table-for").find(".text").text(countlySegmentation.getUserPropertyLongName(this.byVal, tableFor));
                $("#drill-table-for").find(".text").data("value", tableFor);
                $("#drill-table-for").find(".select-items>div").html(tableForStr);
                $("#drill-table-for").show();
            } else {
                $("#drill-table-for").hide();
            }

            var aoColumns = [
                { "mData": "date", "sType":"customDate", "sTitle": jQuery.i18n.map["common.date"] },
                { "mData": "u", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.users"] },
                { "mData": "t", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times"] },
                { "mData": "a", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.times-users"] }
            ];

            if (currEvent != "[CLY]_session" && currEvent != "[CLY]_crash") {
                aoColumns.push({ "mData": "s", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum"] });
                aoColumns.push({ "mData": "as", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.sum-users"] });
                aoColumns.push({ "mData": "dur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur"] });
                aoColumns.push({ "mData": "adur", sType:"formatted-num", "mRender":function(d) { return countlyCommon.formatNumber(d); }, "sTitle": jQuery.i18n.map["drill.dur-users"] });
            }

            this.dtable = $('#drill-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
                "aaData": this.drillChartData[tableFor] || [],
                "aoColumns": aoColumns
            }));
        }

        $("#drill-table").stickyTableHeaders();

        var self = this;
        $("#drill-table-for").find(".item").on("click", function() {
            self.activeSegmentForTable = $(this).data("value");
            self.fillTable();
        });
    },
    bookmarkList: {},
    fillBookmarks:function() {
        var self = this;
        $.when(countlySegmentation.getBookmarks()).then(function(bookmarks){
            var newBookmarkBody = "";

            for (var i = 0; i < bookmarks.length; i++) {
                if (bookmarks[i].query_obj) {
                    bookmarks[i].query_obj = _.unescape(bookmarks[i].query_obj);
                }
                self.bookmarkList[bookmarks[i]._id] = bookmarks[i];
                newBookmarkBody +=
                    "<tr>" +
                        "<td>" +
                            "<div class='fa fa-play-circle bookmark-action apply' data-id='" + bookmarks[i]._id + "' data-query='" + (bookmarks[i].query_obj || "") + "' data-by-val='" + (bookmarks[i].by_val || "") + "'></div>" +
                            "<div class='fa fa-trash bookmark-action delete' data-id='" + bookmarks[i]._id + "'></div>";
							if($.inArray("push", countlyGlobal["plugins"]) > -1)
								newBookmarkBody +="<div class='fa fa-envelope bookmark-action send' data-id='" + bookmarks[i]._id + "' data-query='" + (bookmarks[i].query_obj || "") + "'></div>";
      newBookmarkBody +="</td>" +
                        "<td>" + (bookmarks[i].query_text || "-").replace(/]/g, "]<br>") + "</td>" +
                        "<td>" + (bookmarks[i].by_val_text || "-") + "</td>" +
                    "</tr>";
            }

            if (bookmarks.length == 0) {
                newBookmarkBody =
                    "<tr>" +
                        "<td colspan='3' class='table-no-data'>" + jQuery.i18n.map["common.table.no-data"]  + "</td>" +
                    "</tr>";
            }

            $("#drill-bookmark-body").html(newBookmarkBody);
			
			var hasMessaging = false;
            var a = countlyGlobal['apps'][countlyCommon.ACTIVE_APP_ID];
            if ((a.apn && (a.apn.test || a.apn.prod)) || (a.gcm && a.gcm.key)) {
                if (countlyGlobal['admin_apps'][a._id]) {
                    hasMessaging = true;
                }
            }
            if (hasMessaging) {
                $('#bookmark-view').find('th').first().css({width: '75px'});
                $('#bookmark-view').find('.bookmark-action.send').show();
            } else {
                $('#bookmark-view').find('th').first().css({width: '45px'});
                $('#bookmark-view').find('.bookmark-action.send').hide();
            }
        });
    },
    initialize:function () {
        $.when($.get(countlyGlobal["path"]+'/drill/templates/filter-view.html', function(src){
            Handlebars.registerPartial("filter-view", src);
        })).then(function () {});
    },
    dateChanged:function () {
        countlySegmentation.clearBucket();
        this.draw(true, true);
    },
    adjustFilters: function() {
        var queryCount = $("#filter-blocks").find(".query:visible").length;

        if (queryCount == 0) {
            $("#filter-add-container").trigger("click");
        }

        $(".query:visible").each(function (index) {
            $(this).find(".connector div").hide();

            if (queryCount > 1) {
                $(this).find(".and-or").show();
                $(this).find(".connector").css("background-color", "transparent");

                if (index == 0) {
                    //if($("#filter-blocks").find(".query.by").length)
                    $(this).find(".and-or").hide();
                    $(this).find(".connector .middle-bottom").show();
                } else if (index == (queryCount - 1)) {
                    $(this).find(".connector .middle-top").show();
                } else {
                    $(this).find(".connector .top").show();
                    $(this).find(".connector .middle-bottom").show();
                }

                if (index == (queryCount - 1)) {
                    $(this).find(".filter-connector").removeClass("disabled");
                } else {
                    $(this).find(".filter-connector").addClass("disabled");
                }
            } else {
                //$(this).find(".and-or").hide();
                $(this).find(".and-or").show();
                $(this).find(".connector").css("background-color", "#f9f9f9");
            }

            if ($(this).find(".filter-connector .text").data("value") == "BY") {
                $(this).find(".cly-select").removeClass("disabled");
                $(this).find(".filter-connector").addClass("disabled");
                $(this).prev(".query").find(".filter-connector").removeClass("disabled");
                $(this).prev(".query").find(".filter-name").removeClass("disabled");

                if ($(this).prev(".query").find(".filter-name .text").text() != jQuery.i18n.map["drill.select-filter"]) {
                    $(this).prev(".query").find(".filter-type").removeClass("disabled");
                }
            }
        });

        setTimeout(function() { $("#filter-blocks").removeClass("empty"); }, 1000);
    },
    pageScript:function () {
        var self = this;
        $(document).ready(function() {
            var usedFilters = {},
                currEvent = "[CLY]_session",
                drillClone,
                $segmentation = $("#segmentation"),
                $drillNavigation = $("#drill-navigation"),
                $graphSettings = $(".graph-settings");

            $("#drill-type-sessions").on("click", function() {
                if ($(this).hasClass("active")) {
                    return true;
                }

                $("#drill-types").find(".item").removeClass("active");
                $(this).addClass("active");
                $("#event-selector").hide();

                $("#drill-no-event").fadeOut();

                $(".event-select.cly-select").find(".text").text(jQuery.i18n.map["drill.select-event"]);
                $(".event-select.cly-select").find(".text").data("value","");

                currEvent = "[CLY]_session";

                self.graphType = "line";
                self.graphVal = "times";
                self.filterObj = {};
                self.byVal = "";
                self.drillChartDP = {};
                self.drillChartData = {};
                self.activeSegmentForTable = "";
                countlySegmentation.reset();

                $.when(countlySegmentation.initialize(currEvent)).then(function () {
                    $("#drill").replaceWith(drillClone.clone(true));
                    adjustFilters();
                    self.draw(true, false);
                });
            });

            $("#drill-type-events").on("click", function() {
                if ($(this).hasClass("active")) {
                    return true;
                }

                $("#drill-types").find(".item").removeClass("active");
                $(this).addClass("active");

                if ($("#event-selector").is(":visible")) {
                    $("#event-selector").hide();
                } else {
                    $("#event-selector").css({"display":"inline-block"});
                }
            });

            function getFilters() {
                usedFilters = {};

                $(".query:visible").each(function (index) {
                    var filterType = $(this).find(".filter-name .text").data("type");

                    // number and date types can be used multiple times for range queries
                    if (filterType != "n" && filterType != "d") {
                        usedFilters[$(this).find(".filter-name .text").data("value")] = true;
                    }
                });

                var filters = countlySegmentation.getFilters(currEvent),
                    allFilters = "";

                if (filters.length == 0) {
                    CountlyHelpers.alert(jQuery.i18n.map["drill.no-filters"], "black");
                }

                for (var i = 0; i < filters.length; i++) {
                    if(typeof filters[i].id != "undefined"){
                        if (usedFilters[filters[i].id] == true) {
                            continue;
                        }
    
                        var tmpItem = $("<div>");
    
                        tmpItem.addClass("item");
                        tmpItem.attr("data-type", filters[i].type);
                        tmpItem.attr("data-value", filters[i].id);
                        tmpItem.text(filters[i].name);
    
                        allFilters += tmpItem.prop('outerHTML');
                    }
                    else{
                        var tmpItem = $("<div>");
    
                        tmpItem.addClass("group");
                        tmpItem.text(filters[i].name);
    
                        allFilters += tmpItem.prop('outerHTML');
                    }
                }

                return allFilters;
            }

            function adjustFilters() {
                self.adjustFilters();
            }

            function getFilterObjAndByVal() {
                var filterObj = {},
                    filterObjTypes = {},
                    byVal = "",
                    byValText = "",
                    bookmarkText = "";

                $("#filter-blocks").find(".query").each(function (index) {
                    var tmpConnector = $(this).find(".filter-connector .text").data("value"),
                        tmpText = $(this).find(".filter-name .text").text(),
                        tmpTypeText = $(this).find(".filter-type .text").text(),
                        tmpValText = $(this).find(".filter-value.num input").val() ||
                            $(this).find(".filter-value.date input").val() ||
                            $(this).find(".filter-value.string input").val() ||
                            $(this).find(".filter-value .text").text(),
                        tmpName = $(this).find(".filter-name .text").data("value"),
                        tmpType = $(this).find(".filter-type .text").data("value"),
                        tmpVal = $(this).find(".filter-value.num input").val() ||
                            $(this).find(".filter-value.date input").data("timestamp") ||
                            $(this).find(".filter-value.string input").val() ||
                            $(this).find(".filter-value .text").data("value"),
                        tmpDataType = $(this).find(".filter-name .text").data("type");

                    if(typeof tmpVal == "boolean")
                        tmpVal = tmpVal+"";
                    if (tmpConnector != "BY") {
                        if (!tmpVal) {
                            return true;
                        }

                        if (tmpConnector && index != 0) {
                            bookmarkText += " [" + tmpConnector + "] ";
                        }

                        bookmarkText += tmpText + " " + tmpTypeText + " " + tmpValText;

                        if (!filterObj[tmpName]) {
                            filterObj[tmpName] = [];
                        }

                        if (!filterObjTypes[tmpName]) {
                            filterObjTypes[tmpName] = [];
                        }

                        if (tmpDataType == "d" || tmpDataType == "n") {
                            tmpVal = parseInt(tmpVal, 10);
                        }

                        var exp = {};

                        if (tmpType == "=" || tmpType == "!=") {
                            exp = tmpVal;
                        } else {
                            exp[tmpType] = tmpVal;
                        }

                        filterObj[tmpName].push(exp);
                        filterObjTypes[tmpName].push(tmpType);
                    } else {
                        byVal = tmpName;
                        byValText = tmpText;
                    }
                });
                self.getFilterObjAndByVal = getFilterObjAndByVal;

                var dbFilter = {};

                for (var filter in filterObj) {
                    dbFilter[filter] = {};
                    for (var i = 0; i < filterObj[filter].length; i++) {
                        if(_.isObject(filterObj[filter][i])) {
                            for (var tmpFilter in filterObj[filter][i]) {
                                dbFilter[filter][tmpFilter] = filterObj[filter][i][tmpFilter];
                            }
                        } else if (filterObjTypes[filter][i] == "!=") {
                            if (!dbFilter[filter]["$nin"]) {
                                dbFilter[filter]["$nin"] = [];
                            }

                            dbFilter[filter]["$nin"].push(filterObj[filter][i]);
                        } else {
                            if (!dbFilter[filter]["$in"]) {
                                dbFilter[filter]["$in"] = [];
                            }

                            dbFilter[filter]["$in"].push(filterObj[filter][i]);
                        }
                    }
                }

                return {
                    bookmarkText: bookmarkText,
                    dbFilter: dbFilter,
                    byVal: byVal,
                    byValText: byValText
                };
            }

            function initApply() {
                var filterData = getFilterObjAndByVal();

                if (_.isEmpty(filterData.dbFilter) && filterData.byVal == "") {
                    if (!$("#apply-filter").hasClass("disabled")) {
                        self.filterObj = {};
                        self.byVal = "";
                        self.activeSegmentForTable = "";

                        countlySegmentation.setQueryObject(self.filterObj, self.byVal);
                        self.draw(true, false);
                    }
                    $("#drill-actions").removeClass("visible");
                    $("#apply-filter").addClass("disabled");
                } else {
                    $("#apply-filter").removeClass("disabled");
                }
            }

            $(".event-select").on("click", function() {
                var allEvents = countlyEvent.getEvents(),
                    eventStr = "";

                for (var i = 0; i < allEvents.length; i++) {
                    var tmpItem = $("<div>");

                    tmpItem.addClass("item");
                    tmpItem.attr("data-value", allEvents[i].key);
                    tmpItem.text(allEvents[i].name);

                    eventStr += tmpItem.prop('outerHTML');
                }

                $(this).find(".select-items>div").html(eventStr);
            });

            $(".event-select").on("click", ".item", function() {
                var selectedItem = $(this).parents(".cly-select").find(".text");
                selectedItem.text($(this).text());
                selectedItem.data("value", $(this).data("value"));

                currEvent = $(this).data("value");

                $("#drill-no-event").fadeOut();

                self.graphType = "line";
                self.graphVal = "times";
                self.filterObj = {};
                self.byVal = "";
                self.drillChartDP = {};
                self.drillChartData = {};
                self.activeSegmentForTable = "";
                countlySegmentation.reset();

                $.when(countlySegmentation.initialize(currEvent)).then(function () {
                    $("#drill").replaceWith(drillClone.clone(true));
                    adjustFilters();
                    self.draw(true, false);
                });
            });

            $segmentation.on("click", ".filter-connector", function() {
                var byUsed = false;
                $(".query:visible").each(function (index) {
                    byUsed = byUsed || ($(this).find(".filter-connector .text").data("value") == "BY");
                });

                if (byUsed) {
                    $(this).find(".item.by").hide();
                } else {
                    $(this).find(".item.by").show();
                }
            });

            $segmentation.on("click", ".filter-name", function() {
                if ($(this).parents(".query").find(".filter-connector .text").data("value") == "OR") {
                    var existingFilters = [],
                        orFilters = [],
                        orFilterStr = "";

                    $(".query:visible:not(.by)").each(function (index) {
                        if ($(this).find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                            return false;
                        }

                        if (existingFilters.indexOf($(this).find(".filter-name .text").data("value")) == -1) {
                            orFilters.push({
                                type: $(this).find(".filter-name .text").data("type"),
                                id: $(this).find(".filter-name .text").data("value"),
                                name: $(this).find(".filter-name .text").text()
                            });

                            existingFilters.push($(this).find(".filter-name .text").data("value"));
                        }
                    });

                    for (var i = 0; i < orFilters.length; i++) {
                        var tmpItem = $("<div>");

                        tmpItem.addClass("item");
                        tmpItem.attr("data-type", orFilters[i].type);
                        tmpItem.attr("data-value", orFilters[i].id);
                        tmpItem.text(orFilters[i].name);

                        orFilterStr += tmpItem.prop('outerHTML');
                    }

                    $(this).find(".select-items>div").html(orFilterStr);
                } else {
                    $(this).find(".select-items>div").html(getFilters());
                }

                initApply();
            });

            $segmentation.on("click", ".filter-name .item", function() {
                if ($(this).parents(".query").find(".filter-connector .text").data("value") != "BY") {
                    $(this).parents(".filter-name").siblings(".filter-type").replaceWith($("#defalt-filter-block").clone(true).find(".filter-type"));
                    $(this).parents(".filter-name").siblings(".filter-type").removeClass("disabled");

                    $(this).parents(".filter-name").siblings(".filter-value").addClass("hidden");

                    if ($(this).data("type") == "l") {
                        $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                        $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("big-list");
                        $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                        $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                        $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    } else if ($(this).data("type") == "bl") {
                        $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                        $(this).parents(".filter-name").siblings(".filter-value.list").addClass("big-list");
                        $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                        $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                        $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    } else if ($(this).data("type") == "n") {
                        $(this).parents(".filter-name").siblings(".filter-value.num").removeClass("hidden");
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").show();
                    }  else if ($(this).data("type") == "s") {
                        $(this).parents(".filter-name").siblings(".filter-value.string").removeClass("hidden");
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    }  else if ($(this).data("type") == "d") {
                        $(this).parents(".filter-name").siblings(".filter-value.date").removeClass("hidden");
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.eq").hide();
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.lt").show();
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.lte").hide();
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").show();
                        $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").trigger("click");
                        $(this).parents(".filter-name").siblings(".filter-value.date").find(".open-date-picker").trigger("click");
                    }
                }
                
                $(this).parents(".query").find(".filter-value.num input").val("");
                $(this).parents(".query").find(".filter-value.date input").val("");
                $(this).parents(".query").find(".filter-value.date input").data("timestamp", null)
                $(this).parents(".query").find(".filter-value.string input").val("");
                
                var self = $(this).parents(".query").find(".filter-value .select-items>div");
                self.html("<div></div>");
                function setUpFilterValues(filterValues, filterNames, biglist){
                    var filterValStr = "";
                    
                    if(biglist){
                        var tmpItem = $("<div>");
                        tmpItem.addClass("warning");
                        tmpItem.text(jQuery.i18n.map["drill.big-list-warning"]);       
                        filterValStr += tmpItem.prop('outerHTML');
                    }
    
                    if (jQuery.isArray(filterValues)) {
                        for (var i = 0; i < filterValues.length; i++) {
                            var tmpItem = $("<div>");
        
                            tmpItem.addClass("item");
                            tmpItem.attr("data-value", filterValues[i]);
                            tmpItem.text(filterNames[i]);
        
                            filterValStr += tmpItem.prop('outerHTML');
                        }
                    } else {
                        for (var p in filterValues) {
                            var tmpItem = $("<div>");
                            tmpItem.addClass("group");
                            tmpItem.text(p);
            
                            filterValStr += tmpItem.prop('outerHTML');
                            for (var i = 0; i < filterValues[p].length; i++) {
                                var tmpItem = $("<div>");
            
                                tmpItem.addClass("item");
                                tmpItem.attr("data-value", filterValues[p][i]);
                                tmpItem.text(countlyCommon.decode(filterValues[p][i]));
            
                                filterValStr += tmpItem.prop('outerHTML');
                            }
                        }
                    }
    
                    self.html(filterValStr);
                }
                
                if($(this).data("type") == "bl"){
                    var prop = $(this).data("value");
                    $(this).parents(".query").find(".filter-value").addClass("loading");

                    countlySegmentation.getBigListMetaData(prop, null, function(values, names){
                        self.parents(".query").find(".filter-value").removeClass("loading");
                        setUpFilterValues(values, names,  names.length >= countlyGlobal["list_limit"]);
                        var timeout = null;
                        self.parents(".query").find(".filter-value").on("keyup", ".search input", function(e) {
                            e.stopPropagation();
                            var search = $(this).val();
                            var parent = $(this).parents(".filter-value").find(".select-items");
                            if(!parent.find(".table-loader").length)
                                parent.prepend("<div class='table-loader'></div>");
                            if(timeout)
                            {
                                clearTimeout(timeout);
                                timeout = null;
                            }
                            timeout = setTimeout(function(){
                                countlySegmentation.getBigListMetaData(prop, search, function(values, names){
                                    parent.find(".table-loader").remove();
                                    setUpFilterValues(values, names, names.length >= countlyGlobal["list_limit"]);
                                });                                    
                            }, 1000);
                        });
                    });
                }
                else{
                    setUpFilterValues(countlySegmentation.getFilterValues($(this).data("value")), countlySegmentation.getFilterNames($(this).data("value")));
                }

                var selectedItem = $(this).parents(".cly-select").find(".text");
                selectedItem.text($(this).text());
                selectedItem.data("value", $(this).data("value"));
                selectedItem.data("type", $(this).data("type"));
            });

            $segmentation.on("click", ".filter-value .item", function() {
                setTimeout(function() { initApply(); }, 0);
            });

            $segmentation.on("keyup", ".filter-value input",function(event) {
                initApply();
            });

            $segmentation.on("keydown", ".filter-value.num input",function(event) {
                // Allow: backspace, delete, tab, escape, and enter
                if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
                    // Allow: Ctrl+A
                    (event.keyCode == 65 && event.ctrlKey === true) ||
                    // Allow: home, end, left, right
                    (event.keyCode >= 35 && event.keyCode <= 39) ||
                    // Allow single dot for floats
                    (event.keyCode == 190 && this.value.indexOf(".") === -1)) {
                    // let it happen, don't do anything
                    return;
                }
                else {
                    // Ensure that it is a number and stop the keypress
                    if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                        event.preventDefault();
                    }
                }
            });

            $segmentation.on("keydown", ".filter-value.date input",function(event) {
                event.preventDefault();
            });

            $segmentation.on("click", ".filter-connector .item", function() {
                $(this).parents(".query").find(".filters").replaceWith($("#defalt-filter-block").clone(true).find(".filters"));

                $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
                $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");
                adjustFilters();

                $(this).parents(".query").removeClass("by");

                if ($(this).data("value") == "BY") {
                    $(this).parents(".query").addClass("by");
                    $(this).parents(".query").find(".filter-type").hide();
                    $(this).parents(".query").find(".filter-value").hide();
                    $(this).parents(".query").find(".filter-connector").addClass("disabled");
                } else if ($(this).data("value") == "AND") {

                } else if ($(this).data("value") == "OR") {

                }

                initApply();
            });

            $segmentation.on("click", ".query .delete", function() {
                $(this).parent(".query").remove();
                $(".query:visible:last-child").find(".filter-name").removeClass("disabled");
                $(".query:visible:last-child").find(".filter-type").removeClass("disabled");
                adjustFilters();
                initApply();
                
                var filterData = getFilterObjAndByVal();

                countlySegmentation.setQueryObject(filterData.dbFilter, filterData.byVal);

                var needData = false;
                if (!_.isEqual(self.filterObj, filterData.dbFilter) || (self.byVal != filterData.byVal)) {
                    // If the query is not changed we don't need to get data
                    needData = true;
                }

                self.filterObj = filterData.dbFilter;
                self.byVal = filterData.byVal;
                self.activeSegmentForTable = "";
                self._filter = filterData;

                // Call draw only if our filters are not empty, if they are empty initApply already called draw
                if (!(_.isEmpty(filterData.dbFilter) && filterData.byVal == "")) {
                    self.draw(needData, false);
                }

                if(JSON.stringify(self._filter.dbFilter) == "{}" && self._filter.byVal == "")
                    app.navigate("/drill", false);
                else
                    app.navigate("/drill/"+JSON.stringify({event:countlySegmentation.getActiveEvent() || "[CLY]_session", dbFilter:self._filter.dbFilter, byVal:self._filter.byVal || ""}), false);
            });

            $segmentation.on("click", ".open-date-picker", function(e) {

                var queryType = $(this).parents(".filters").find(".filter-type .text").data("value");
                var maxDate = (queryType == "$gte")? moment().subtract('days', 1).toDate() : moment().add('days', 1).toDate();

                $(".date-picker").hide();
                $(this).next(".date-picker").show();
                $(this).next(".date-picker").find(".calendar").datepicker({
                    numberOfMonths:1,
                    showOtherMonths:true,
                    onSelect:function (selectedDate) {
                        var instance = $(this).data("datepicker"),
                            date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings),
                            currMoment = moment(date);

                        $(this).parents(".date-picker").prev(".open-date-picker").val(countlyCommon.formatDate(currMoment, "DD MMMM, YYYY"));

                        var selectedTimestamp = moment(currMoment.format("DD MMMM, YYYY"), "DD MMMM, YYYY").unix();
                        var tzCorr = countlyCommon.getOffsetCorrectionForTimestamp(selectedTimestamp);

                        $(this).parents(".date-picker").prev(".open-date-picker").data("timestamp", selectedTimestamp - tzCorr);
                        $(".date-picker").hide();
                        initApply();
                    }
                });

                $(this).next(".date-picker").find(".calendar").datepicker('option', 'maxDate', maxDate);

                $.datepicker.setDefaults($.datepicker.regional[""]);
                $(this).next(".date-picker").find(".calendar").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

                $(this).next(".date-picker").click(function(e) {
                    e.stopPropagation();
                });

                e.stopPropagation();

                $segmentation.on("click", ".cly-select", function() {
                    $(".date-picker").hide();
                });

                $segmentation.on("click", ".filter-type .item", function() {
                    $(this).parents(".filters").find(".open-date-picker").val("");
                    $(this).parents(".filters").find(".open-date-picker").data("timestamp","");
                    setTimeout(function() { initApply(); }, 0);
                });
            });

            $("#filter-add-container").on("click", function() {
                if ($(".query:visible:not(.by):last").find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                    $(".query:visible:not(.by):last").find(".filter-name").addClass("req");
                } else {
                    var filterBlocks = $("#filter-blocks"),
                        defaultFilters = $("#defalt-filter-block").html();

                    filterBlocks.append(defaultFilters);
                    $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
                    $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");

                    var byFilter = $("#filter-blocks").find(".query.by").clone(true);
                    $("#filter-blocks").find(".query.by").remove();
                    $("#filter-blocks").append(byFilter);

                    adjustFilters();
                }
            });

            $segmentation.on("click", "#apply-filter:not(.disabled)", function() {
                $("#drill-actions").addClass("visible");

                var filterData = getFilterObjAndByVal();

                countlySegmentation.setQueryObject(filterData.dbFilter, filterData.byVal);

                var needData = false;
                if (!_.isEqual(self.filterObj, filterData.dbFilter) || (self.byVal != filterData.byVal)) {
                    // If the query is not changed we don't need to get data
                    needData = true;
                }

                self.filterObj = filterData.dbFilter;
                self.byVal = filterData.byVal;
                self.activeSegmentForTable = "";
                self.draw(needData, false);
                self._filter = filterData;
                app.navigate("/drill/"+JSON.stringify({event:countlySegmentation.getActiveEvent() || "[CLY]_session", dbFilter:self._filter.dbFilter, byVal:self._filter.byVal || ""}), false);
            });

            $segmentation.on("click", "#bookmark-filter:not(.disabled)", function() {
                var filterData = getFilterObjAndByVal();

                $.ajax({
                    type:"GET",
                    url:countlyGlobal["path"]+"/i/drill/add_bookmark",
                    data:{
                        "app_id":countlyCommon.ACTIVE_APP_ID,
                        "event_key":countlySegmentation.getActiveEvent(),
                        "query_obj":JSON.stringify(filterData.dbFilter),
                        "query_text":filterData.bookmarkText,
                        "by_val":filterData.byVal,
                        "by_val_text":filterData.byValText,
                        "api_key":countlyGlobal["member"].api_key
                    },
                    success:function (result) {
                        $("#drill-navigation").find(".fa-bookmark-o").animate({"zoom":'1.3'},200).animate({"zoom":'1'},200);
                        self.fillBookmarks();
                    }
                });
            });

            $graphSettings.on("click", ".button", function(e) {
                if (!$(this).hasClass("active")) {
                    $(this).parents(".button-selector").find(".button").removeClass("active");
                    $(this).addClass("active");
                }
            });

            $graphSettings.find(".type .button").on("click", function() {
                if (!$(this).hasClass("active")) {
                    $("#drill").find("#dashboard-graph").html("");
                    self.graphType = $(this).data("type");
                    self.draw(false,false);
                }
            });

            $graphSettings.find(".value .button").on("click", function() {
                if (!$(this).hasClass("active")) {
                    self.graphVal = $(this).data("value");
                    self.draw(false, false);
                }
            });

            $graphSettings.find(".bucket .button").on("click", function() {
                if (!$(this).hasClass("active")) {
                    countlySegmentation.setBucket($(this).data("bucket"));
                    self.draw(true, false);
                }
            });

            $drillNavigation.on("click", ".menu", function() {
                $("#drill-navigation").find(".menu").removeClass("active");
                $(this).addClass("active");

                $(".navigation-menu").hide();
                $("#" + $(this).data("open")).show();

                if ($(this).data("open") == "table-view") {
                    self.fillTable();
                } else if ($(this).data("open") == "bookmark-view") {
                    self.fillBookmarks();
                }
            });

            $("#bookmark-view").on("click", ".bookmark-action.delete", function() {
                var bookmarkId = $(this).data("id");

                CountlyHelpers.confirm(jQuery.i18n.map["drill.bookmark-delete"], "red", function (result) {
                    if (!result) {
                        return true;
                    }

                    $.ajax({
                        type:"GET",
                        url:countlyGlobal["path"]+"/i/drill/delete_bookmark",
                        data:{
                            "bookmark_id": bookmarkId,
                            "app_id": countlyCommon.ACTIVE_APP_ID,
                            "api_key":countlyGlobal["member"].api_key
                        },
                        success:function(res) {
                            if (res == false) {
                                CountlyHelpers.alert(jQuery.i18n.map["drill.bookmark-error"], "red");
                            }

                            self.fillBookmarks();
                        }
                    });
                });
            });

            $("#bookmark-view").on("click", ".bookmark-action.apply", function() {
                var query = self.bookmarkList[$(this).data("id")];

                try{
                    query.query_obj = JSON.parse(query.query_obj);
                }
                catch(ex){
                    query.query_obj = {};
                }
                app.navigate("/drill/"+JSON.stringify({event:countlySegmentation.getActiveEvent() || "[CLY]_session", dbFilter:query.query_obj || {}, byVal:query.by_val || ""}), true);
            });

            $(window).click(function() {
                $(".date-picker").hide();
            });

            adjustFilters();

            setTimeout(function() {
                drillClone = $("#drill").clone(true);
                if (self._filter) {
                    currEvent = self._filter.event || "[CLY]_session";

                    if (currEvent == "[CLY]_session") {
                        if (!$("#drill-type-sessions").hasClass("active")) {
        
                            $("#drill-types").find(".item").removeClass("active");
                            $("#drill-type-sessions").addClass("active");
                            $("#event-selector").hide();
        
                            $("#drill-no-event").fadeOut();

                            $("#drill-type-select").find(".text").text(jQuery.i18n.map["sidebar.analytics.sessions"]);

                            $(".event-select.cly-select").find(".text").text(jQuery.i18n.map["drill.select-event"]);
                            $(".event-select.cly-select").find(".text").data("value","");
                        }
                    } else if (currEvent == "[CLY]_crash") {
                        if (!$("#drill-type-crashes").hasClass("active")) {
                            $("#drill-types").find(".item").removeClass("active");
                            $("#drill-type-crashes").addClass("active");
                            $("#event-selector").hide();
        
                            $("#drill-no-event").fadeOut();

                            $("#drill-type-select").find(".text").text(jQuery.i18n.map["crashes.title"]);

                            $(".event-select.cly-select").find(".text").text(jQuery.i18n.map["drill.select-event"]);
                            $(".event-select.cly-select").find(".text").data("value","");
                        }
                    } else {
                        if (!$("#drill-type-events").hasClass("active")) {
        
                            $("#drill-types").find(".item").removeClass("active");
                            $("#drill-type-events").addClass("active");
                            $("#event-selector").css({"display":"inline-block"});
        
                            $("#drill-no-event").fadeOut();

                            $("#drill-type-select").find(".text").text(jQuery.i18n.map["sidebar.events"]);

                            $(".event-select.cly-select").find(".text").text(currEvent);
                            $(".event-select.cly-select").find(".text").data("value",currEvent);
                        }
                    }

                    $.when(countlySegmentation.initialize(currEvent)).then(function () {
                        var filter = self._filter.dbFilter,
                        byVal = self._filter.byVal;

                        countlySegmentation.setQueryObject(filter, byVal);
        
                        self.filterObj = filter;
                        self.byVal = byVal;
                        self.activeSegmentForTable = "";
                        adjustFilters();
                        self.draw(true, false);
                        
                        var inputs = [];
                        var subs = {};

                        for (var i in filter) {
                            inputs.push(i);
                            subs[i] = [];
                            for(var j in filter[i]){
                                if(filter[i][j].length){
                                    for(var k = 0; k < filter[i][j].length; k++){
                                        subs[i].push([j, filter[i][j][k]]);
                                    }
                                }
                                else{
                                    subs[i].push([j, filter[i][j]]);
                                }
                            }
                        }

                        function setInput(cur, sub, total){
                            sub = sub || 0;
                            if(inputs[cur]){
                                var filterType = subs[inputs[cur]][sub][0];
                                if(filterType == "$in")
                                    filterType = "=";
                                else if(filterType == "$nin")
                                    filterType = "!=";
            
                                var val = subs[inputs[cur]][sub][1];
                                var el = $(".query:nth-child("+(total)+")");
                                el.find(".filter-name").trigger("click");
                                el.find(".filter-type").trigger("click");
                                el.find(".filter-name").find(".select-items .item[data-value='" + inputs[cur] + "']").trigger("click");
                                el.find(".filter-type").find(".select-items .item[data-value='" + filterType + "']").trigger("click");
                                setTimeout(function() {
                                    el.find(".filter-value").not(".hidden").trigger("click");
                                    if(el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").length)
                                        el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").trigger("click");
                                    else if(_.isNumber(val) && (val + "").length == 10){
                                        el.find(".filter-value.date").find("input").val(countlyCommon.formatDate(moment(val*1000),"DD MMMM, YYYY"));
                                        el.find(".filter-value.date").find("input").data("timestamp", val);
                                    }
                                    else
                                        el.find(".filter-value").not(".hidden").find("input").val(val);
                                    
                                    if(subs[inputs[cur]].length == sub+1){
                                        cur++;
                                        sub = 0;
                                    }
                                    else
                                        sub++;
                                    total++;
                                    if(inputs[cur]){
                                        $("#filter-add-container").trigger("click");
                                        if(sub > 0)
                                            setTimeout(function() {
                                                var el = $(".query:nth-child("+(total)+")");
                                                el.find(".and-or").find(".select-items .item[data-value='OR']").trigger("click");
                                                setInput(cur, sub, total);
                                            }, 500);
                                        else
                                            setInput(cur, sub, total);
                                    }
                                    else{
                                        if(byVal){
                                            $("#filter-add-container").trigger("click");
                                            setTimeout(function() {
                                                var el = $(".query:nth-child("+(total)+")");
                                                el.find(".and-or").find(".select-items .item[data-value='BY']").trigger("click");
                                                el.find(".filter-name").trigger("click");
                                                el.find(".filter-name").find(".select-items .item[data-value='" + byVal + "']").trigger("click");
                                            }, 500);
                                        }
                                    }
                                }, 500);
                            }
                            else if(byVal){
                                $("#filter-add-container").trigger("click");
                                setTimeout(function() {
                                    var el = $("#filter-blocks").find(".query:visible");
                                    el.find(".and-or").find(".select-items .item[data-value='BY']").trigger("click");
                                    el.find(".filter-name").trigger("click");
                                    el.find(".filter-name").find(".select-items .item[data-value='" + byVal + "']").trigger("click");
                                }, 500);
                            }
                        }
                        setInput(0, 0, 1);

                        setTimeout(function() { $("#drill-actions").addClass("visible"); }, 500);
                    });
                } else {
                    $("#drill-type-sessions").trigger("click");
                    $("#drill-type-select").trigger("click");
                }
            }, 0);

            setTimeout(function() { $("#filter-blocks").removeClass("empty"); }, 1000);

            var navigationTop = $drillNavigation.offset().top;

            $(window).on("scroll", function(e) {
                if ($(this).scrollTop() > navigationTop) {
                    $("#drill-navigation").addClass("fixed");
                } else {
                    $("#drill-navigation").removeClass("fixed");
                }
            });
        });
    },
    renderCommon:function (isRefresh) {
        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));

            this.pageScript();
        }
    },
    refresh:function () {}
});

//register views
app.drillView = new DrillView();

app.route('/drill/*query', 'drill', function (query) {
    try{
        query = JSON.parse(query);
    }
    catch(ex){
        query = null;
    }
    this.drillView._filter = query;
	this.renderWhenReady(this.drillView);
});

app.route("/drill", "drill", function () {
    this.drillView._filter = null;
	this.renderWhenReady(this.drillView);
});

app.addPageScript("#", function(){
	$("#drill-down-for-view").on("click", function() {
        app.navigate("/drill/"+JSON.stringify($(this).data("drill-query")), true);
    });
});

function addDrill(drillId, drillVal, drillSection){
    drillSection = drillSection || "[CLY]_session";
    drillId = drillId || "";
    var query = {"event":drillSection};
    if(drillVal){
        query["dbFilter"] = {};
        query["dbFilter"][drillId] = {"$in":[drillVal]};
        query["byVal"] = "";
    }
    else{
        query["dbFilter"] = {};
        query["byVal"] = drillId;
    }
    drillVal = drillVal || {};
    var str = '<div title="Drill down this data with Countly Drill" id="drill-down-for-view" data-drill-query=\''+JSON.stringify(query)+'\' ';
    str += 'class="icon-button light" style="font-size: 14px; padding: 5px 5px 4px 5px; margin: 6px 0 0 13px; border-radius: 15px;">'+
        '<span class="fa fa-sort-amount-desc" style="color:#86BB64;"></span>'+
    '</div>';
    return str;
}

app.addPageScript("/analytics/sessions", function(){
	$(".widget-header .left .title").first().after(addDrill("s"));
});

app.addPageScript("/analytics/users", function(){
	$(".widget-header .left .title").first().after(addDrill("u"));
});

app.addPageScript("/analytics/countries", function(){
	$(".widget-header .left .title").first().after(addDrill("up.cc"));
});

app.addPageScript("/analytics/devices", function(){
	$(".widget-header .left .title").first().after(addDrill("up.d"));
});

app.addPageScript("/analytics/platforms", function(){
	$(".widget-header .left .title").first().after(addDrill("up.p"));
});

app.addPageScript("/analytics/versions", function(){
	$(".widget-header .left .title").first().after(addDrill("up.av"));
});

app.addPageScript("/analytics/carriers", function(){
	$(".widget-header .left .title").first().after(addDrill("up.c"));
});

app.addPageScript("/analytics/resolutions", function(){
	$(".widget-header .left .title").first().after(addDrill("up.r"));
});

app.addPageScript("/attribution", function(){
	$(".widget:nth-child(1) .widget-header .left .title").first().after(addDrill("cmp.c"));
});

app.addPageScript("/crashes", function(){
	$(".widget:nth-child(1) .widget-header .left .title").first().after(addDrill("sg.crash", null, "[CLY]_crash"));
});

$( document ).ready(function() {
	var menu = '<a href="#/drill" class="item analytics" id="sidebar-drill">'+
        '<div class="logo ion-android-funnel"></div>'+
        '<div class="text" data-localize="drill.drill">Drill</div>'+
	'</a>';
	if($('.sidebar-menu #management-menu').length)
		$('.sidebar-menu #management-menu').before(menu);
	else
		$('.sidebar-menu ').append(menu);
    
    //check if configuration view exists
    if(app.configurationsView){
        app.configurationsView.registerLabel("drill", "drill.drill");
        app.configurationsView.registerLabel("drill-list_limit", "drill.item-limit");
        app.configurationsView.registerLabel("drill-big_list_limit", "drill.big_list_limit");
        app.configurationsView.registerLabel("drill-custom_property_limit", "drill.max-custom-properties");
        app.configurationsView.registerLabel("drill-projection_limit", "drill.projection_limit");
        app.configurationsView.registerLabel("drill-record_sessions", "drill.record_sessions");
        app.configurationsView.registerLabel("drill-record_views", "drill.record_views");
        app.configurationsView.registerLabel("drill-record_actions", "drill.record_actions");
        app.configurationsView.registerLabel("drill-record_pushes", "drill.record_pushes");
        app.configurationsView.registerLabel("drill-record_crashes", "drill.record_crashes");
        app.configurationsView.registerLabel("drill-record_star_rating", "drill.record_star_rating");
    }
});