var async = require('async'),
crypto = require('crypto'),
countlyConfig = require('../../frontend/express/config', 'dont-enclose'),
plugins = require('../pluginManager.js'),
countlyConfig2;

try{
countlyConfig2 = require('./config');
}
catch(err){
    countlyConfig2 = countlyConfig;
}
console.log("Updating drill indexes");

var countlyDb = plugins.dbConnection(countlyConfig);

if (typeof countlyConfig2.mongodb === "string") {
	countlyConfig2.mongodb = countlyConfig2.mongodb.replace(new RegExp('countly$'), 'countly_drill');
} else{
	countlyConfig2.mongodb.db = 'countly_drill';
}
	
var countlyDrillDb = plugins.dbConnection(countlyConfig2);

fixEventKey = function (eventKey) {
    var shortEventName = eventKey.replace(/system\.|\.\.|\$/g, "");

    if (shortEventName.length >= 128) {
        return false;
    } else {
        return shortEventName;
    }
};

//check indexes
//db.currentOp({$or: [{ op: "query", "query.createIndexes": { $exists: true } },{ op: "insert", ns: /\.system\.indexes\b/ }]})

countlyDb.collection('apps').find({}).toArray(function (err, apps) {

    if (!apps || err) {
		console.log("No apps to upgrade");
        return;
    }
    var appCnt = 0;
    var eventCnt = {};
    
    function finishEvent(){
        
    }
    
	function upgrade(app, done){
        appCnt++;
        var applocal = appCnt;
        eventCnt[applocal] = 0;
		console.log("Adding uid indexes to " + app.name, applocal);
		
        var collection = countlyDrillDb.collection("drill_events" + crypto.createHash('sha1').update("[CLY]_session" + app._id).digest('hex'));  
		collection.createIndex({"uid":1},{"background": true}, function(){console.log("finished session for", app._id)});
		collection.createIndex({"ts":-1},{"background": true}, function(){console.log("finished session for", app._id)});
        
        var collection = countlyDrillDb.collection("drill_events" + crypto.createHash('sha1').update("[CLY]_crash" + app._id).digest('hex'));  
		collection.createIndex({"uid":1},{"background": true}, function(){console.log("finished session for", app._id)});
		collection.createIndex({"ts":-1},{"background": true}, function(){console.log("finished session for", app._id)});
        
        var collection = countlyDrillDb.collection("drill_events" + crypto.createHash('sha1').update("[CLY]_view" + app._id).digest('hex'));  
		collection.createIndex({"uid":1},{"background": true}, function(){console.log("finished session for", app._id)});
		collection.createIndex({"ts":-1},{"background": true}, function(){console.log("finished session for", app._id)});
        
        var collection = countlyDrillDb.collection("drill_events" + crypto.createHash('sha1').update("[CLY]_action" + app._id).digest('hex'));  
		collection.createIndex({"uid":1},{"background": true}, function(){console.log("finished session for", app._id)});
		collection.createIndex({"ts":-1},{"background": true}, function(){console.log("finished session for", app._id)});
        
        countlyDb.collection("events").findOne({'_id':app._id}, {list:1}, function (err, eventData) {
            function eventIterator(key, done){
                eventKey = fixEventKey(key);
				if (eventKey) {
                    eventCnt[applocal]++;
                    var collection = countlyDrillDb.collection("drill_events" + crypto.createHash('sha1').update(eventKey + app._id).digest('hex'));
                    collection.createIndex({"uid":1},{"background": true}, function(){
                        collection.createIndex({"ts":-1},{"background": true}, function(){
                            eventCnt[applocal]--;
                            console.log("finished events "+key+" for", app.name, eventCnt[applocal]);
                            if(eventCnt[applocal] == 0){
                                appCnt--;
                                console.log("finished events for", app.name, appCnt);
                            }
                        });
                    });
                }
            }
            if(eventData && eventData.list)
				async.map(eventData.list, eventIterator, function(err, results) {});
        });
        done();
	}
	async.forEach(apps, upgrade, function(){
		console.log("Drill index finished");
	});
});