(function (countlyLive, $, undefined) {

    //Private Properties
    var _periodObj = {},
        _onlineCountsDb = {},
        _liveGraph = [];

    //Public Methods
    countlyLive.initialize = function () {
        _periodObj = countlyCommon.periodObj;

        if (!countlyCommon.DEBUG) {
            return $.when(
                $.ajax({
                    type:"GET",
                    url:countlyCommon.API_PARTS.data.r,
                    data:{
                        "api_key":countlyGlobal.member.api_key,
                        "app_id":countlyCommon.ACTIVE_APP_ID,
                        "method":"live"
                    },
                    dataType:"jsonp",
                    success:function (json) {
                        _onlineCountsDb = json;
                    }
                }),
                $.ajax({
                    type:"GET",
                    url:countlyCommon.API_PARTS.data.r,
                    data:{
                        "api_key":countlyGlobal.member.api_key,
                        "app_id":countlyCommon.ACTIVE_APP_ID,
                        "method":"live_graph"
                    },
                    dataType:"jsonp",
                    success:function (json) {
                        _liveGraph = json;
                    }
                })
            ).then(function () {
                    return true;
                });
        } else {
            _onlineCountsDb = {"online_users":0, "new_users":0};
            _liveGraph = [];
            return true;
        }
    };

    countlyLive.refresh = countlyLive.initialize;

    countlyLive.getOnlineUsers = function () {
        return _onlineCountsDb;
    };

    countlyLive.getOnlineUsersGraphData = function () {
        return _liveGraph;
    };

}(window.countlyLive = window.countlyLive || {}, jQuery));