var pluginManager = require('../pluginManager.js'),
	async = require('async'),
	db = pluginManager.dbConnection();
	
console.log("Installing live plugin");
db.collection('apps').find({}).toArray(function (err, apps) {

    if (!apps || err) {
        return;
    }
	function upgrade(app, done){
		var cnt = 0;
		console.log("Adding live collections to " + app.name);
		function cb(){
			cnt++;
			if(cnt == 5)
				done();
		}
        db.command({"convertToCapped": 'live_data' + app._id, size: 100000, max: 60}, function(err,data){
            if(err){
                db.createCollection('live_data' + app._id, {capped: true, size: 100000, max: 60}, cb);
            }
            else{
                cb();
            }
        });
		db.collection('max_online_counts').insert({'_id': app._id, nu: 0, ou: 0}, cb);
		db.collection('max_online_counts').ensureIndex({"nu": 1}, cb);
		db.collection('max_online_counts').ensureIndex({"ou": 1}, cb);
		db.collection('online_users').ensureIndex({la: 1}, {expireAfterSeconds: 180}, cb);
	}
	async.forEach(apps, upgrade, function(){
		console.log("Live plugin installation finished");
		db.close();
	});
});