function pathsToSectionNames(arr){
    var map = {};
    $("#sidebar-menu a").each(function(){
        var code = this.href.substring(this.href.indexOf('#'));
        if(code && code != "#/" && !map[code]){
            if($(this).parent().hasClass("sidebar-submenu")){
                map[code] = ($(this).parent().prev().text() + " > "+ $(this).text()).replace(/\r\n|\r|\n|\/n/g, "").replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '').replace(/\s\s+/g, ' ');
            }
            else{
                map[code] = $(this).text().replace(/\r\n|\r|\n|\/n/g, "").replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '').replace(/\s\s+/g, ' ');
            }
        }
    });
    var ret = [];
    for(var i = 0; i < arr.length; i++){
        ret.push(map[arr[i]]);
    }
    return ret.join(", ");
}

window.RestrictedView = countlyView.extend({
    renderCommon:function () {
        $(this.el).html("<div id='no-app-type'><h1>"+jQuery.i18n.map["restrict.all-sections-restricted"]+"</h1><h3>"+jQuery.i18n.map["restrict.all-sections-restricted-explain"]+"</h3></div>");
    }
});

//register views
app.restrictedView = new RestrictedView();

app.route('/restricted', 'restricted', function () {
	this.renderWhenReady(this.restrictedView);
});

//get list of all urls in the menus
function getUrls(){
    var urls = [];
    var map = {};
    $("#sidebar-menu a").each(function(){
        var code = this.href.substring(this.href.indexOf('#'));
        if(code && !map[code]){
            urls.push(code);
            map[code] = true;
        }
    });
    return urls;
};
function goToAvailableSection(){
    //go to dashboard if available
    if(countlyGlobal["member"].restrict.indexOf("#/") === -1){
        window.location.hash = "/";
        return;
    }
    //find any section that is not blocked
    var urls = getUrls();
    urls.sort();
    for(var i = 0; i < urls.length; i++){
        if(countlyGlobal["member"].restrict.indexOf(urls[i]) === -1){
            window.location.hash = urls[i];
            return;
        }
    }
    //if everything is blocked, show restricted message
    window.location.hash = "/restricted";
}

//recheck restriction on each page
app.addPageScript("#", function(){
    var url = "#"+Backbone.history.fragment;
    if(countlyGlobal["member"].restrict && countlyGlobal["member"].restrict.length){
        for(var i = 0; i < countlyGlobal["member"].restrict.length; i++){
            if(countlyGlobal["member"].restrict[i] == "#/"){
                if(url == countlyGlobal["member"].restrict[i]){
                    goToAvailableSection();
                    break;
                }
            }
            else if(url.indexOf(countlyGlobal["member"].restrict[i]) === 0){
                goToAvailableSection();
                break;
            }
        }
    }
});

$( document ).ready(function() { 
    //hide restricted menu elements
    setTimeout(function(){
        if(countlyGlobal["member"].restrict){
            var elem;
            for(var i = 0; i < countlyGlobal["member"].restrict.length; i++){
                elem = $('a[href="'+countlyGlobal["member"].restrict[i]+'"]');
                elem.addClass("restrict");
            }
            //check if there are any children still visible in submenu, and if not hide main menu item too
            $(".sidebar-submenu").each(function(){
                if($(this).find("a.item").map(function(){if($(this).css("display") != "none") return true}).get().length == 0)
                    $(this).prev().addClass("restrict");
            });
        }
    },500);
    
    function initRestrictPlugins(data){
        var map = {};
        var urls = [];
        $("#sidebar-menu a").each(function(){
            var code = this.href.substring(this.href.indexOf('#'));
            if(code && !map[code]){
                urls.push(code);
                if($(this).parent().hasClass("sidebar-submenu")){
                    map[code] = $(this).parent().prev().text() + " > "+ $(this).text();
                }
                else{
                    map[code] = $(this).text();
                }
            }
        });
        
        function compare(a,b) {
            if (map[a] < map[b])
                return -1;
            else if (map[a] > map[b])
                return 1;
            else 
                return 0;
        }

        var pluginList = "<div id=\"listof-plugins\"><div class=\"search\"><i class=\"fa fa-search\"></i><input type=\"text\" placeholder='"+jQuery.i18n.map["restrict.search-for-sections"]+"'></div><div id='listof-plugins-header'><div class='name'>"+jQuery.i18n.map["restrict.sections"]+"</div><div class='allow'>"+jQuery.i18n.map["restrict.allow"]+"</div><div class='disallow'>"+jQuery.i18n.map["restrict.restrict"]+"</div></div><div class=\"scrollable\">";
        var plugins = urls.sort(compare);
        for(var i = 0; i <  plugins.length; i++){
            pluginList += "<div class=\"plugin searchable\"><div class=\"name\">"+map[plugins[i]]+"</div><div class='allow'><div class='styled-radio checked'></div></div><div class='disallow'><div class='styled-radio'></div></div><input class=\"plugin_id\" type=\"hidden\" value=\""+plugins[i]+"\"/></div>";
        }
        pluginList += "</div><div class=\"button-container\"><a class=\"icon-button green\" id=\"done-plugin-list\" data-localize=\"common.done\">"+jQuery.i18n.map["common.done"]+"</a><a class=\"icon-button dark\" id=\"allow-all-plugin-list\" data-localize=\"restrict.allow-all\">"+jQuery.i18n.map["restrict.allow-all"]+"</a><a class=\"icon-button dark\" id=\"restrict-all-plugin-list\" data-localize=\"restrict.restrict-all\">"+jQuery.i18n.map["restrict.restrict-all"]+"</a></div></div>";
        $("#listof-apps").after(pluginList);
        
        $(document).on('input', "#listof-plugins .search input", function(e) {
            var searchText = new RegExp($(this).val().toLowerCase()),
                searchInside = $(this).closest("#listof-plugins").find(".searchable");

            searchInside.filter(function () {
                return !(searchText.test($(this).text().toLowerCase()));
            }).css('display','none');

            searchInside.filter(function () {
                return searchText.test($(this).text().toLowerCase());
            }).css('display','block');
        });
        
        var restrictPlugins = "<div class=\"row help-zone-vs\" data-help-localize=\"restrict.help\">"+
                "<div class=\"title\" data-localize=\"restrict.title\">"+jQuery.i18n.map["restrict.title"]+"</div>"+
                    "<div class=\"select-plugins\">"+
                        "<i class=\"fa fa-plus-circle\"></i>"+
                        "<input type=\"hidden\" value=\"\" class=\"plugin-list\"/>"+
                    "</div>"+
                    "<div class=\"detail user-plugin-list\">"+
                        "<div><span class='sections-allowed'>"+jQuery.i18n.map["restrict.sections-allowed"]+":</span><span class='allowed-amount'></span></div>"+
                        "<div><span class='sections-restricted'>"+jQuery.i18n.map["restrict.sections-restricted"]+":</span><span class='restrict-amount'></span></div>"+
                    "</div>"+
                "</div>";

        function setSelectDeselect() {
            var searchInput = $("#listof-plugins").find(".search input").val();

            if (searchInput == "") {
                if ($("#listof-plugins .plugin:not(.disabled)").length == 0) {
                    $("#allow-all-plugin-list").hide();
                    $("#restrict-all-plugin-list").hide();
                } else {
                    $("#allow-all-plugin-list").show();
                    $("#restrict-all-plugin-list").show();
                }
            } else {
                $("#allow-all-plugin-list").hide();
                $("#restrict-all-plugin-list").hide();
            }
        }

        function initializeUserEdit(container){
            $("#listof-plugins").hide();
            container.find(".button-container").before(restrictPlugins);
            container.find(".button-container").each(function(){
                var id = $(this).find(".user_id").val();
                if(id && id.length){
                    var row = $(this).prev();
                    if(data[id] && data[id].length){
                        row.find(".user-plugin-list .restrict-amount").text(data[id].length);
                        row.find(".user-plugin-list .allowed-amount").text(urls.length - data[id].length);
                        row.find(".plugin-list").val(data[id]);
                    }
                    else{
                        row.find(".user-plugin-list .restrict-amount").text(0);
                        row.find(".user-plugin-list .allowed-amount").text(urls.length);
                    }
                }
            });

            container.find(".select-plugins").off().on('click', function() {
                $("#listof-plugins .plugin").removeClass("selected");
                var activeRow = $(this).parent(".row");
                activeRow.addClass("selected-plugin-row");
                var buttonPos = $(this).offset();
                buttonPos.top += 26;
                buttonPos.left -= 18;
                
                if ($("#listof-plugins").is(":visible") && JSON.stringify(buttonPos) === JSON.stringify(previousSelectAppPos)) {
                    $("#listof-plugins").hide();
                    return true;
                }
                
                previousSelectAppPos = buttonPos;
                
                var appList = activeRow.find(".plugin-list").val().split(",");
                
                $("#listof-plugins .styled-radio").removeClass("checked");
                $("#listof-plugins").find(".plugin_id").each(function() {
                    if (appList.indexOf($(this).val()) != -1) {
                        $(this).parents(".plugin").find(".disallow .styled-radio").addClass("checked");
                    }
                    else {
                        $(this).parents(".plugin").find(".allow .styled-radio").addClass("checked");
                    }
                });

                setSelectDeselect();
                
                $("#listof-plugins").show().offset(buttonPos);
                $("#listof-plugins").find(".search input").focus();
            });

            container.find(".select-apps").on('click', function() {
                $("#listof-plugins").hide();
            });
            container.on("click", ".cancel-user", function() {
                $("#listof-plugins").hide();
            });
            container.on("click", ".cancel-user-row", function() {
                $("#listof-plugins").hide();
            });
            container.on("click", ".save-user", function() {
                var currUserDetails = $(".user-details:visible");
                var data = currUserDetails.find(".plugin-list").val().split(",");
                if(data == "")
                    data = [];
                var user_id = $(this).parent(".button-container").find(".user_id").val();
                saveUserRestriction(user_id, data);
                $("#listof-plugins").hide();
            });
        }
        
        $("#user-table").on("click", "tr", function(){
            var container = $(this);
            if(container.find("td.details").length == 0){
                setTimeout(function(){
                    initializeUserEdit(container.next("tr"));
                }, 0);
            }
        });
        
        function resetList(){
            setSelectDeselect();
            var adminOfIds = [];
            $("#listof-plugins .plugin .disallow .styled-radio.checked").each(function() {
                adminOfIds[adminOfIds.length] = $(this).parents(".plugin").find(".plugin_id").val();
            });
            var activeRow = $(".row.selected-plugin-row");
            
            activeRow.find(".user-plugin-list .restrict-amount").text(adminOfIds.length);
            activeRow.find(".user-plugin-list .allowed-amount").text(urls.length - adminOfIds.length);
            activeRow.find(".plugin-list").val(adminOfIds.join(","));
        }
        
        $("#allow-all-plugin-list").on('click', function() {
            $("#listof-plugins .plugin .disallow .styled-radio").removeClass("checked");
            $("#listof-plugins .plugin .allow .styled-radio").addClass("checked");
            resetList();
        });
        
        $("#restrict-all-plugin-list").on('click', function() {
            $("#listof-plugins .plugin .disallow .styled-radio").addClass("checked");
            $("#listof-plugins .plugin .allow .styled-radio").removeClass("checked");
            resetList();
        });

        $("#done-plugin-list").on('click', function() {
            $("#listof-plugins").hide();
        });

        $("#listof-plugins").find(".search").on('input', 'input', function(e,v) {
            setSelectDeselect();
        });
        
        $("#listof-plugins .styled-radio").on('click', function() {
            $(this).addClass("checked");
            if($(this).parent().hasClass("allow")){
                $(this).parents(".plugin").find(".disallow .styled-radio").removeClass("checked");
            }
            else{
                $(this).parents(".plugin").find(".allow .styled-radio").removeClass("checked");
            }
            resetList();
            
        });
        
        $("#user-table").find("tbody tr").not(".user-details").on('click', function() {
            $("#listof-plugins").hide();
        });
        $(".create-user").on("click", function() {		
            $("#listof-plugins").hide();
        });
        $("#user-table").find("tbody tr").not(".user-details").on('click', function() {
            if ($(this).hasClass("active")) {
                $("#listof-plugins").hide();
            }
        });
    }
    
    function saveUserRestriction(user_id, data){
        $.ajax({
            type:"GET",
            url:countlyCommon.API_URL + "/i/restrict",
            data:{
                api_key:countlyGlobal['member'].api_key,
                user_id:user_id,
                restrict:JSON.stringify(data)
            },
            success:function (json) {}
        });
    }
    
    app.addPageScript("/manage/users", function(){
        setTimeout(function(){
            if(countlyGlobal["member"].global_admin){
                $.ajax({
                    type:"GET",
                    url:countlyCommon.API_URL + "/o/restrict",
                    data:{
                        api_key:countlyGlobal['member'].api_key
                    },
                    success:function (json) {
                        initRestrictPlugins(json);
                    },
                    error:function (){
                        initRestrictPlugins({});
                    }
                });
            }
        }, 1000);
    });
});