var plugin = {},
	common = require('../../../api/utils/common.js'),
	retention = require('./parts/data/retention.js'),
    plugins = require('../../pluginManager.js');

(function (plugin) {
	plugins.register("/worker", function(ob){
		common.dbUserMap['retention_lost'] = 'rl';
		common.dbUserMap['retention_lost.daily'] = 'rl.d';
		common.dbUserMap['retention_lost.weekly'] = 'rl.w';
		common.dbUserMap['retention_lost.monthly'] = 'rl.m';
	});
	//read api call
	plugins.register("/o", function(ob){
		var params = ob.params
		var validateUserForDataReadAPI = ob.validateUserForDataReadAPI;
		if(params.qstring.method == 'retention'){
            validateUserForDataReadAPI(params, retention.get);
			return true;
		}
	});
	
	plugins.register("/session/retention", function(ob){
		var user = ob.user;
		var params = ob.params;
		var isNewUser = ob.isNewUser;
		retention.process(user, isNewUser, params);
	});
	
	plugins.register("/i/apps/create", function(ob){
		common.db.collection('retention_daily').ensureIndex({"d": 1}, function() {});
		common.db.collection('retention_weekly').ensureIndex({"d": 1}, function() {});
		common.db.collection('retention_monthly').ensureIndex({"d": 1}, function() {});
	});
	
	plugins.register("/i/apps/delete", function(ob){
		var appId = ob.appId;
		common.db.collection("retention_daily").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
        common.db.collection("retention_weekly").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
        common.db.collection("retention_monthly").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
	});
	
	plugins.register("/i/apps/reset", function(ob){
		var appId = ob.appId;
		common.db.collection("retention_daily").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
        common.db.collection("retention_weekly").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
        common.db.collection("retention_monthly").remove({_id:{$regex: "^" + appId + "_.*"}},function(){});
	});
    
    plugins.register("/i/apps/clear", function(ob){
		var appId = ob.appId;
        var lt = parseInt(ob.moment.format("YYYYMMDD"));
		common.db.collection("retention_daily").remove({_id:{$regex: "^" + appId + "_.*"}, d:{$lt:lt}},function(){});
        common.db.collection("retention_weekly").remove({_id:{$regex: "^" + appId + "_.*"}, d:{$lt:lt}},function(){});
        common.db.collection("retention_monthly").remove({_id:{$regex: "^" + appId + "_.*"}, d:{$lt:lt}},function(){});
	});
}(plugin));

module.exports = plugin;