var retention = {},
    common = require('../../../../../api/utils/common.js'),
    momentiso = require('moment-isocalendar');

(function (retention) {

    retention.process = function (user, isNewUser, params) {
        var currMoment = common.moment(common.getDate(params.time.timestamp, params.appTimezone)),
            currIsoMoment = common.moment(common.getDate(params.time.timestamp, params.appTimezone)).isoday(1),
            dailyBucket = currMoment.format("YYYYMMDD"),
            weeklyBucket = currIsoMoment.format("YYYYMMDD"),
            monthlyBucket = currMoment.format("YYYYMM");

        if (!isNewUser && user && user[common.dbUserMap.first_seen]) {
                var userFirstMoment = common.moment(common.getDate(user[common.dbUserMap.first_seen], params.appTimezone)),
                    userFirstIsoMoment = common.moment(common.getDate(user[common.dbUserMap.first_seen], params.appTimezone)).isoday(1),
                    userLastMoment = common.moment(common.getDate(user[common.dbUserMap.last_seen], params.appTimezone)),
                    userLastIsoMoment = common.moment(common.getDate(user[common.dbUserMap.last_seen], params.appTimezone)).isoday(1),
                    incObj = {},
                    usrObj = {};

                if (!(user.rl && user.rl.d)) {
                    if (currMoment.subtract('days', 1).format("YYYYMMDD") == userLastMoment.format("YYYYMMDD")) {
                        currMoment.add('days', 1);
                        var retDays = parseInt(common.getDiff(currMoment, userFirstMoment, 'days'));
                        if (retDays < 15) {
                            incObj = {};
                            incObj[retDays] = 1;

                            common.db.collection("retention_daily").update({'_id': params.app_id + "_" + userFirstMoment.format("YYYYMMDD")}, {'$inc': incObj}, {upsert: false},function(err, res){});
                        }
                    } else if (dailyBucket != userLastMoment.format("YYYYMMDD")) {
                        currMoment.add('days', 1);
                        if (common.getDiff(currMoment,userLastMoment, 'seconds') > 0) {
                            usrObj = {};
                            usrObj[common.dbUserMap['retention_lost.daily']] = dailyBucket;

                            common.db.collection('app_users' + params.app_id).update({'_id': params.app_user_id}, {$set: usrObj}, {upsert: false},function(){});
                        }
                    } else {
                        currMoment.add('days', 1);
                    }
                }

                if (!(user.rl && user.rl.w)) {
                    if (currIsoMoment.subtract('days', 7).format("YYYYMMDD") == userLastIsoMoment.format("YYYYMMDD")) {
                        currIsoMoment.add('days', 7);

                        var firstSeenYear = userFirstIsoMoment.isocalendar()[0],
                            currYear = currIsoMoment.isocalendar()[0],
                            retWeeks;

                        if (currYear == firstSeenYear) {
                            retWeeks = currIsoMoment.isoweek() - userFirstIsoMoment.isoweek();
                        } else {
                            var weeksToAdd = 0;
                            for (var i = parseInt(firstSeenYear); i < parseInt(currYear); i++) {
                                weeksToAdd += common.getISOWeeksInYear(i);
                            }

                            retWeeks = (weeksToAdd + currIsoMoment.isoweek()) - userFirstIsoMoment.isoweek();
                        }

                        if (retWeeks < 15) {
                            incObj = {};
                            incObj[retWeeks] = 1;

                            common.db.collection("retention_weekly").update({'_id': params.app_id + "_" + userFirstIsoMoment.format("YYYYMMDD")}, {'$inc': incObj}, {upsert: false},function(){});
                        }
                    } else if (weeklyBucket != userLastIsoMoment.format("YYYYMMDD")) {
                        currIsoMoment.add('days', 7);

                        if (common.getDiff(currIsoMoment,userLastIsoMoment, 'seconds') > 0) {
                            usrObj = {};
                            usrObj[common.dbUserMap['retention_lost.weekly']] = weeklyBucket;

                            common.db.collection('app_users' + params.app_id).update({'_id': params.app_user_id}, {$set: usrObj}, {upsert: false},function(){});
                        }
                    } else {
                        currIsoMoment.add('days', 7);
                    }
                }

                if (!(user.rl && user.rl.m)) {
                    // Check if user's last session is in the previous month
                    if (currMoment.subtract('months', 1).format("YYYYMM") == userLastMoment.format("YYYYMM")) {
                        currMoment.add('months', 1); // Fix the above subtraction

                        var yearDiff = (currMoment.format("YYYY") - userFirstMoment.format("YYYY")),
                            monthDiff = (currMoment.format("M") - userFirstMoment.format("M")),
                            retMonths = (yearDiff * 12) + monthDiff;

                        if (retMonths < 15) {
                            incObj = {};
                            incObj[retMonths] = 1;

                            common.db.collection("retention_monthly").update({'_id': params.app_id + "_" + userFirstMoment.format("YYYYMM")}, {'$inc': incObj}, {upsert: false},function(){});
                        }
                    } else if (monthlyBucket != userLastMoment.format("YYYYMM")) { // If the user's session is not the previous month and this month than set the retention lost date to rl.m
                        currMoment.add('months', 1); // Fix the subtraction in the previous if

                        if (common.getDiff(currMoment,userLastMoment, 'seconds') > 0) {
                            usrObj = {};
                            usrObj[common.dbUserMap['retention_lost.monthly']] = monthlyBucket;

                            common.db.collection('app_users' + params.app_id).update({'_id': params.app_user_id}, {$set: usrObj}, {upsert: false},function(){});
                        }
                    } else {
                        currMoment.add('months', 1);
                    }
                }
        } else {
            common.db.collection("retention_daily").update({'_id': params.app_id + "_" + dailyBucket}, {'$set': {'d': parseInt(dailyBucket)}, '$inc': {'tu': 1}}, {upsert: true},function(){});
            common.db.collection("retention_weekly").update({'_id': params.app_id + "_" + weeklyBucket}, {'$set': {'d': parseInt(weeklyBucket)}, '$inc': {'tu': 1}}, {upsert: true},function(){});
            common.db.collection("retention_monthly").update({'_id': params.app_id + "_" + monthlyBucket}, {'$set': {'d': parseInt(monthlyBucket)}, '$inc': {'tu': 1}}, {upsert: true},function(){});
        }
    };

    retention.get = function (params) {
        var currMoment = common.moment(common.getDate(params.time.timestamp, params.appTimezone)),
            collName = 'retention_',
            retentionId = '',
            maxRetId = '';

        switch (params.qstring.period) {
            case 'daily':
                collName = collName + 'daily';
                maxRetId = currMoment.format("YYYYMMDD");
                retentionId = currMoment.subtract('days', 10).format("YYYYMMDD");
                break;
            case 'weekly':
                collName = collName + 'weekly';
                maxRetId = currMoment.format("YYYYMMDD");
                retentionId = currMoment.subtract('weeks', 10).isoday(1).format("YYYYMMDD");
                break;
            case 'monthly':
                collName = collName + 'monthly';
                maxRetId = currMoment.format("YYYYMM");
                retentionId = currMoment.subtract('months', 10).format("YYYYMM");
                break;
            default:
                collName = collName + 'daily';
                maxRetId = currMoment.format("YYYYMMDD");
                retentionId = currMoment.subtract('days', 10).format("YYYYMMDD");
                break;
        }

        common.db.collection(collName).find({'_id': {$regex: '^' + params.app_id + '_.*'}, d: {'$gt': parseInt(retentionId), '$lte': parseInt(maxRetId)}}, {limit: 14}).toArray(function (err, retentionData) {
            for (var i = 0; i < retentionData.length; i++) {
                retentionData[i]._id = retentionData[i].d + "";
                delete retentionData[i].d;
            }

            common.returnOutput(params, retentionData);
        });
    };

}(retention));

module.exports = retention;