window.RetentionView = countlyView.extend({
    beforeRender: function() {
		if(this.template)
			return $.when(countlyRetention.initialize()).then(function () {});
		else{
			var self = this;
			return $.when($.get(countlyGlobal["path"]+'/retention/templates/retention.html', function(src){
				self.template = Handlebars.compile(src);
			}), countlyRetention.initialize()).then(function () {});
		}
    },
    initialize:function () {
    },
    pageScript:function () {
        var self = this;

        $("#retention-date").datepicker({
            numberOfMonths:1,
            showOtherMonths:true,
            maxDate:moment().toDate(),
            onSelect:function (selectedDate) {
                var instance = $(this).data("datepicker"),
                    date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings);

                countlyRetention.setTimestamp(moment(date.getTime()).unix());
            }
        });

        $.datepicker.setDefaults($.datepicker.regional[""]);
        $("#retention-date").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

        $("#retention-date-submit").click(function (e) {
            countlyRetention.setActiveBucket($("#retention-buckets").find(".cly-button-dark.active").data("bucket"));
            self.refresh();
            $("#date-picker").fadeOut("fast");
        });

        $("#retention-buckets").find(".cly-button-dark").click(function (e) {
            $("#retention-buckets").find(".cly-button-dark").removeClass("active");
            $(this).addClass("active");
        });

        $("#date-picker").click(function (e) {
            e.stopPropagation();
        });

        $(".retaining-cell").on({
            mouseenter:function () {
                var width = $(this).width();

                $(this).text($(this).data("users"));
                $(this).width(width);
            },
            mouseleave:function () {
                $(this).text("%" + $(this).data("percent"));
            }
        });

        $(".retention-row").on({
            mouseenter:function () {
                var retCols = $(this).data("cols");

                for (var i = 0; i < retCols.length; i++) {
                    $("#retention-date" + (i + 1)).text("(" + retCols[i] + ")");
                }
            },
            mouseleave:function () {
                $(".retention-date").text("");
            }
        });

        var isiPad = navigator.userAgent.match(/iPad/i) != null;

        if (isiPad) {
            $(".retention-col").css({"min-width":0});
        } else {
            $(".retention-col").css({"min-width":"75px"});
        }

        app.localize();
    },
    activeGraphFunction:function () {
    },
    initGraphAlternatives:function (retentionData) {
        var seriesProps = {
                lines:{ stack:false, show:true, fill:true, lineWidth:2, fillColor:{ colors:[
                    { opacity:0 },
                    { opacity:0 }
                ] }, shadowSize:0 },
                points:{ show:true, radius:4, shadowSize:0 },
                shadowSize:0
            },
            self = this;

        var alternativeOne = function () {
            $("#graph-alternatives").find(".active").removeClass("active");
            $("#alt1").addClass("active");

            countlyCommon.drawGraph(retentionData.graph1, "#retention-graph", "line", {
                series:seriesProps,
                xaxis:{min:0, max:retentionData.graph1.dpMax, ticks:retentionData.graph1.ticks}
            });

            graphHover();
        };

        var alternativeTwo = function () {
            $("#graph-alternatives").find(".active").removeClass("active");
            $("#alt2").addClass("active");

            countlyCommon.drawGraph(retentionData.graph2, "#retention-graph", "line", {
                series:seriesProps,
                xaxis:{min:0, max:retentionData.graph2.dpMax, ticks:retentionData.graph2.ticks}
            });

            graphHover();
        };

        function graphHover() {
            _.defer(function() {
                $("#retention-graph").unbind("plothover");
                $("#retention-graph").bind("plothover", function (event, pos, item) {
                    if (item) {
                        if (previousPoint != item.dataIndex) {
                            previousPoint = item.dataIndex;

                            $("#graph-tooltip").remove();
                            var x = item.datapoint[0].toFixed(1).replace(".0", ""),
                                y = item.datapoint[1].toFixed(1).replace(".0", "");

                            var formattedContent = "<div style='font-size:13px;'><div style='text-align:center; font-size:14px;'>" + "%" + y + " Retained" + "</div><div class='separator'></div><div style='padding-bottom:1px;'><i class='fa fa-plane' style='font-size:13px; margin-right:10px; color:#AAAAAA; text-shadow:0 1px #000;'></i>" + retentionData.graph1.tip[item.datapoint[0]] + " users left off" + "</div></div>";

                            showTooltip(item.pageX, item.pageY - 70, formattedContent);
                        }
                    } else {
                        $("#graph-tooltip").remove();
                        previousPoint = null;
                    }
                });

                function showTooltip(x, y, contents) {
                    var tooltip = '<div id="graph-tooltip">' + contents + '</div>';

                    $("#content").append("<div id='tooltip-calc'>" + tooltip + "</div>");
                    var widthVal = $("#graph-tooltip").outerWidth();
                    $("#tooltip-calc").remove();

                    var newLeft = (x - (widthVal / 2)),
                        xReach = (x + (widthVal / 2));

                    if (xReach > $(window).width()) {
                        newLeft = (x - widthVal);
                    } else if (xReach < 340) {
                        newLeft = x;
                    }

                    $(tooltip).css({
                        top:y,
                        left:newLeft
                    }).appendTo("body").fadeIn(200);
                }
            });
        }

        $("#alt1").click(alternativeOne);
        $("#alt2").click(alternativeTwo);

        if ($("#graph-alternatives").find(".active").data("alternative") == "one") {
            this.activeGraphFunction = alternativeOne;
        } else {
            this.activeGraphFunction = alternativeTwo;
        }

        this.activeGraphFunction();
    },
    renderCommon:function () {
        var retentionData = countlyRetention.getRetentionData();

        this.templateData = {
            "page-title":"RETENTION",
            "logo-class":"retention",
            "chart-helper":"",
            "table-helper":"",
            "retention-table":{
                columnCount:retentionData["max"],
                columnTicks:retentionData["column-ticks"],
                period:retentionData["period"],
                rows:retentionData.rows
            }
        };

        $(this.el).html(this.template(this.templateData));

        this.initGraphAlternatives(retentionData);
        this.pageScript();
    },
    refresh:function () {
        var self = this;
        $.when(this.beforeRender()).then(function () {
            if (app.activeView != self) {
                return false;
            }

            var retentionData = countlyRetention.getRetentionData();

            self.templateData["retention-table"] = {
                columnCount:retentionData["max"],
                columnTicks:retentionData["column-ticks"],
                period:retentionData["period"],
                rows:retentionData.rows
            };

            var newPage = $("<div>" + self.template(self.templateData) + "</div>");

            $("#retention-table").replaceWith(newPage.find("#retention-table"));
            $("#retention-graph-placeholder").replaceWith(newPage.find("#retention-graph-placeholder"));

            $(".retaining-cell").on({
                mouseenter:function () {
                    var width = $(this).width();

                    $(this).text($(this).data("users"));
                    $(this).width(width);
                },
                mouseleave:function () {
                    $(this).text("%" + $(this).data("percent"));
                }
            });

            $(".retention-row").on({
                mouseenter:function () {
                    var retCols = $(this).data("cols");

                    for (var i = 0; i < retCols.length; i++) {
                        $("#retention-date" + (i + 1)).text("(" + retCols[i] + ")");
                    }
                },
                mouseleave:function () {
                    $(".retention-date").text("");
                }
            });

            var isiPad = navigator.userAgent.match(/iPad/i) != null;

            if (isiPad) {
                $(".retention-col").css({"min-width":0});
            } else {
                $(".retention-col").css({"min-width":"75px"});
            }

            self.initGraphAlternatives(retentionData);

            app.localize();
        });
    }
});

//register views
app.retentionView = new RetentionView();

app.route("/analytics/retention", "retention", function () {
	this.renderWhenReady(this.retentionView);
});

$( document ).ready(function() {
	$('.sidebar-menu #engagement-submenu').prepend(
		'<a href="#/analytics/retention" class="item">'+
            '<div class="logo retention"></div>'+
            '<div class="text" data-localize="sidebar.engagement.retention"></div>'+
        '</a>');
});