var plugin = {},
	common = require('../../../api/utils/common.js'),
	retention = require('./parts/data/retention.js'),
    plugins = require('../../pluginManager.js');

plugins.setConfigs("retention_segments", {
    span:10
}, true);
(function (plugin) {
	//read api call
	plugins.register("/o", function(ob){
		var params = ob.params
		var validateUserForDataReadAPI = ob.validateUserForDataReadAPI;
		if(params.qstring.method == 'retention'){
            validateUserForDataReadAPI(params, retention.get);
			return true;
		}
	});
	
	plugins.register("/session/retention", function(ob){
		var user = ob.user;
		var params = ob.params;
		var isNewUser = ob.isNewUser;
		retention.process(user, isNewUser, params);
	});
}(plugin));

module.exports = plugin;