window.RetentionView = countlyView.extend({
    beforeRender: function() {
		if(this.template)
			return $.when(countlyRetention.initialize(this._query)).then(function () {});
		else{
			var self = this;
			return $.when($.get(countlyGlobal["path"]+'/retention_segments/templates/retention.html', function(src){
				self.template = Handlebars.compile(src);
			}), countlyRetention.initialize(this._query)).then(function () {});
		}
    },
    initialize:function () {
    },
    pageScript:function () {
        var self = this;

        $("#retention-date").datepicker({
            numberOfMonths:1,
            showOtherMonths:true,
            maxDate:moment().toDate(),
            onSelect:function (selectedDate) {
                var instance = $(this).data("datepicker"),
                    date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings);
                date.setDate(date.getDate() + 1);
                var selectedTimestamp = moment(date.getTime()).unix();
                    tzCorr = countlyCommon.getOffsetCorrectionForTimestamp(selectedTimestamp);

                countlyRetention.setTimestamp(selectedTimestamp - tzCorr);
            }
        });

        $.datepicker.setDefaults($.datepicker.regional[""]);
        $("#retention-date").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

        $("#retention-date-submit").click(function (e) {
            countlyRetention.setActiveBucket($("#retention-buckets").find(".button.active").data("bucket"));
            self.refresh(true);
            $("#date-picker").fadeOut("fast");
        });

        $("#retention-buckets").find(".button").on("click", function (e) {
            $("#retention-buckets").find(".button").removeClass("active");
            $(this).addClass("active");

            countlyRetention.setActiveBucket($(this).data("bucket"));
            self.refresh(true);
        });

        $("#date-picker").click(function (e) {
            e.stopPropagation();
        });

        $(document).off("click", "#table-download");
        $(document).on("click", "#table-download", function() {
            var table = $("#retention-table");
            var title = "";
            var rows = [];

            table.find("tbody tr").each(function(indexTR) {
                if (indexTR == 0) {
                    var colCount = $(this).find("td").length,
                        tmpTitle = [];

                    for (var i = 0; i < colCount; i++) {
                        if (i == 0) {
                            tmpTitle.push(jQuery.i18n.map["common.date"]);
                        } else if (i == 1) {
                            tmpTitle.push(jQuery.i18n.map["common.table.new-users"]);
                        } else {
                            tmpTitle.push("(+" + (i - 1) + ')');
                        }
                    }

                    title = tmpTitle.join(",") + "\n";
                }

                var currRow = [];

                $(this).find("td").each(function(indexTD) {
                    if (indexTD == 0) {
                        currRow.push('"' + $(this).text() + '"');
                    } else if (indexTD == 1) {
                        currRow.push($(this).text());
                    } else {
                        currRow.push($(this).data("users"));
                    }
                });

                rows.push(currRow.join(","));
            });

            rows = rows.join("\n");

            var download_link = document.createElement('a');

            download_link.href = 'data:application/csv;charset=UTF-8,' + '\uFEFF' + encodeURIComponent(title + rows);
            download_link.download = "Retention-" + moment().format("DD-MMM-YYYY") + ".csv";

            document.body.appendChild(download_link);
            download_link.click();
            document.body.removeChild(download_link);
        });

        self.tableJS();
    },
    activeGraphFunction:function () {
    },
    initGraphAlternatives:function (retentionData) {
        var seriesProps = {
                lines:{ stack:false, show:true, fill:true, lineWidth:2, fillColor:{ colors:[
                    { opacity:0 },
                    { opacity:0 }
                ] }, shadowSize:0 },
                points:{ show:true, radius:3, shadowSize:0 },
                shadowSize:0
            };

        var altType = 1;

        var alternativeOne = function () {
            altType = 1;
            $("#graph-alternatives").find(".active").removeClass("active");
            $("#alt1").addClass("active");

            countlyCommon.drawGraph(retentionData.graph1, "#retention-graph", "line", {
                series:seriesProps,
                xaxis:{min:0, max:retentionData.graph1.dpMax, ticks:retentionData.graph1.ticks}
            });

            graphHover();
        };

        var alternativeTwo = function () {
            altType = 2;
            $("#graph-alternatives").find(".active").removeClass("active");
            $("#alt2").addClass("active");

            countlyCommon.drawGraph(retentionData.graph2, "#retention-graph", "line", {
                series:seriesProps,
                xaxis:{min:0, max:retentionData.graph2.dpMax, ticks:retentionData.graph2.ticks}
            });

            graphHover();
        };

        var previousPoint;

        function graphHover() {
            _.defer(function() {
                $("#retention-graph").unbind("plothover").bind("plothover", function (event, pos, item) {
                    if (item) {
                        if (previousPoint != item.dataIndex) {
                            previousPoint = item.dataIndex;

                            $("#graph-tooltip").remove();
                            var x = item.datapoint[0].toFixed(1).replace(".0", ""),
                                y = item.datapoint[1].toFixed(1).replace(".0", "");

                            var formattedContent = "<div style='text-align:center;'>" + y + "% Retained" + "</div>";
                            if(altType == 1)
                                formattedContent += "<div class='separator'></div><div style='padding-bottom:1px;'>" + retentionData.graph1.tip[item.datapoint[0]] + " users left off" + "</div>";
                            formattedContent += "</div>";

                            showTooltip(item.pageX, item.pageY - 70, formattedContent);
                        }
                    } else {
                        $("#graph-tooltip").remove();
                        previousPoint = null;
                    }
                });

                function showTooltip(x, y, contents) {
                    var tooltip = '<div id="graph-tooltip" class="white"><div class="inner">' + contents + '</div></div>';

                    $("#content").append("<div id='tooltip-calc'>" + tooltip + "</div>");
                    var widthVal = $("#graph-tooltip").outerWidth();
                    $("#tooltip-calc").remove();

                    var newLeft = (x - (widthVal / 2)),
                        xReach = (x + (widthVal / 2));

                    if (xReach > $(window).width()) {
                        newLeft = (x - widthVal);
                    } else if (xReach < 400) {
                        newLeft = x;
                    }

                    $(tooltip).css({
                        top:y,
                        left:newLeft
                    }).appendTo("body").fadeIn(200);
                }
            });
        }

        $("#alt1").click(alternativeOne);
        $("#alt2").click(alternativeTwo);

        if ($("#graph-alternatives").find(".active").data("alternative") == "one") {
            this.activeGraphFunction = alternativeOne;
        } else {
            this.activeGraphFunction = alternativeTwo;
        }

        this.activeGraphFunction();
    },
    renderCommon:function () {
        var self = this;
        var retentionData = countlyRetention.getRetentionData();

        this.templateData = {
            "page-title":"RETENTION",
            "logo-class":"retention",
            "chart-helper":"",
            "table-helper":"",
            "retention-table":{
                columnCount:retentionData["max"],
                columnTicks:retentionData["column-ticks"],
                period:retentionData["period"],
                rows:retentionData.rows
            }
        };

        $(this.el).html(this.template(this.templateData));

        $.when(countlySegmentation.initialize("[CLY]_session")).then(function () {
            self.initDrill();
            app.localize();
            self.initGraphAlternatives(retentionData);
            self.pageScript();
            setTimeout(function() {
                self.filterBlockClone = $("#filter-view").clone(true);
                if(self._query){
                    if ($(".filter-view-container").is(":visible")) {
                        $("#filter-view").hide();
                        $(".filter-view-container").hide();
                    } else {
                        $("#filter-view").show();
                        $(".filter-view-container").show();
                        self.adjustFilters();
                    }

                    $(".flot-text").hide().show(0);
                    var filter = self._query;
                    var inputs = [];
                    var subs = {};
                    for(var i in filter){
                        inputs.push(i);
                        subs[i] = [];
                        for(var j in filter[i]){
                            if(filter[i][j].length){
                                for(var k = 0; k < filter[i][j].length; k++){
                                    subs[i].push([j, filter[i][j][k]]);
                                }
                            }
                            else{
                                subs[i].push([j, filter[i][j]]);
                            }
                        }
                    }
                    function setInput(cur, sub, total){
                        sub = sub || 0;
                        if(inputs[cur]){
                            var filterType = subs[inputs[cur]][sub][0];
                            if(filterType == "$in")
                                filterType = "=";
                            else if(filterType == "$nin")
                                filterType = "!=";
            
                            var val = subs[inputs[cur]][sub][1];
                            var el = $(".query:nth-child("+(total)+")");
                            el.find(".filter-name").trigger("click");
                            el.find(".filter-type").trigger("click");
                            el.find(".filter-name").find(".select-items .item[data-value='up." + inputs[cur] + "']").trigger("click");
                            el.find(".filter-type").find(".select-items .item[data-value='" + filterType + "']").trigger("click");
                            setTimeout(function() {
                                el.find(".filter-value").not(".hidden").trigger("click");
                                if(el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").length)
                                    el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").trigger("click");
                                else if(_.isNumber(val) && (val + "").length == 10){
                                    el.find(".filter-value.date").find("input").val(countlyCommon.formatDate(moment(val*1000),"DD MMMM, YYYY"));
                                    el.find(".filter-value.date").find("input").data("timestamp", val);
                                }
                                else
                                    el.find(".filter-value").not(".hidden").find("input").val(val);
                                
                                if(subs[inputs[cur]].length == sub+1){
                                    cur++;
                                    sub = 0;
                                }
                                else
                                    sub++;
                                total++;
                                if(inputs[cur]){
                                    $("#filter-add-container").trigger("click");
                                    if(sub > 0)
                                        setTimeout(function() {
                                            var el = $(".query:nth-child("+(total)+")");
                                            el.find(".and-or").find(".select-items .item[data-value='OR']").trigger("click");
                                            setInput(cur, sub, total);
                                        }, 500);
                                    else
                                        setInput(cur, sub, total);
                                }
                                else{
                                    setTimeout(function(){
                                        $("#apply-filter").removeClass("disabled");
                                        $("#no-filter").hide();
                                        var filterData = self.getFilterObjAndByVal();
                                        $("#current-filter").show().find(".text").text(filterData.bookmarkText);
                                        $("#connector-container").show();
                                    }, 500);
                                }
                            }, 500);
                    }
                    }
                    setInput(0, 0, 1);
                }
            },0);
        });
    },
    refresh:function (needsTableRedraw) {
        var self = this;
        $.when(countlyRetention.refresh(self._query)).then(function () {
            if (app.activeView != self) {
                return false;
            }

            var retentionData = countlyRetention.getRetentionData();

            self.templateData["retention-table"] = {
                columnCount:retentionData["max"],
                columnTicks:retentionData["column-ticks"],
                period:retentionData["period"],
                rows:retentionData.rows
            };

            var newPage = $("<div>" + self.template(self.templateData) + "</div>");

            if (needsTableRedraw) {
                $("#retention-table").replaceWith(newPage.find("#retention-table"));
                self.tableJS();
            } else {
                for (var i = 0; i < retentionData.rows.length; i++) {
                    var usrColID = "#users-cell" + i;

                    $(usrColID).text(newPage.find(usrColID).text());

                    for (var j = 0; j < retentionData.rows[i].retention.length; j++) {
                        var retColID = "#retaining-cell" + i + "" + j;
                        $(retColID).find("span").text(newPage.find(retColID).find("span").text());
                        $(retColID).data("users", newPage.find(retColID).data("users"));
                        $(retColID).data("percent", newPage.find(retColID).data("percent"));
                    }
                }
            }

            if (self.hoveredCellID) {
                var newContent = self.getTooltipText($('#' + self.hoveredCellID)),
                    existingContent = $('#' + self.hoveredCellID).find(".retention-info").tooltipster('content');

                if (newContent != existingContent) {
                    $('#' + self.hoveredCellID).find(".retention-info").tooltipster('content', newContent);
                }
            }

            $("#retention-graph-placeholder").replaceWith(newPage.find("#retention-graph-placeholder"));

            self.initGraphAlternatives(retentionData);

            app.localize($("#retention-table"));
            app.localize($("#retention-graph-placeholder"));
        });
    },
    resetFilter: function() {
        this.filterObj = {};
        $("#filter-view").replaceWith(this.filterBlockClone.clone(true));
        $("#current-filter").hide();
        $("#no-filter").show();
    },
    initDrill: function() {
        var self = this;
        this.filterObj = {};
        $("#retention-filter").on("click", "#toggle-filter", function() {
            if ($(".filter-view-container").is(":visible")) {
                $("#filter-view").hide();
                $(".filter-view-container").hide();
            } else {
                $("#filter-view").show();
                $(".filter-view-container").show();
                self.adjustFilters();
            }

            $(".flot-text").hide().show(0);
        });

        var usedFilters = {},
            currEvent = "";

        function getFilters() {
            usedFilters = {};

            $(".query:visible").each(function (index) {
                var filterType = $(this).find(".filter-name .text").data("type");

                // number and date types can be used multiple times for range queries
                if (filterType != "n" && filterType != "d") {
                    usedFilters[$(this).find(".filter-name .text").data("value")] = true;
                }
            });

            var filters = countlySegmentation.getFilters(currEvent),
                allFilters = "";

            if (filters.length == 0) {
                CountlyHelpers.alert(jQuery.i18n.map["drill.no-filters"], "black");
            }

            for (var i = 0; i < filters.length; i++) {
                if(typeof filters[i].id != "undefined"){
                    if (usedFilters[filters[i].id] == true) {
                        continue;
                    }
    
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", filters[i].type);
                    tmpItem.attr("data-value", filters[i].id);
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
                else{
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("group");
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
            }

            return allFilters;
        }

        function getFilterObjAndByVal() {
            return self.getFilterObjAndByVal();
        }

        function initApply() {
            var filterData = getFilterObjAndByVal();

            if (_.isEmpty(filterData.dbFilter) && filterData.byVal == "") {
                $("#apply-filter").addClass("disabled");
            } else {
                $("#apply-filter").removeClass("disabled");
            }
        }

        $("#segmentation").on("click", ".filter-connector", function() {
            var byUsed = false;
            $(".query:visible").each(function (index) {
                byUsed = byUsed || ($(this).find(".filter-connector .text").data("value") == "BY");
            });

            if (byUsed) {
                $(this).find(".item.by").hide();
            } else {
                $(this).find(".item.by").show();
            }
        });

        $("#segmentation").on("click", ".filter-name", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") == "OR") {
                var existingFilters = [],
                    orFilters = [],
                    orFilterStr = "";

                $(".query:visible:not(.by)").each(function (index) {
                    if ($(this).find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                        return false;
                    }

                    if (existingFilters.indexOf($(this).find(".filter-name .text").data("value")) == -1) {
                        orFilters.push({
                            type: $(this).find(".filter-name .text").data("type"),
                            id: $(this).find(".filter-name .text").data("value"),
                            name: $(this).find(".filter-name .text").text()
                        });

                        existingFilters.push($(this).find(".filter-name .text").data("value"));
                    }
                });

                for (var i = 0; i < orFilters.length; i++) {
                    var tmpItem = $("<div>");

                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", orFilters[i].type);
                    tmpItem.attr("data-value", orFilters[i].id);
                    tmpItem.text(orFilters[i].name);

                    orFilterStr += tmpItem.prop('outerHTML');
                }

                $(this).find(".select-items>div").html(orFilterStr);
            } else {
                $(this).find(".select-items>div").html(getFilters());
            }

            initApply();
        });

        $("#segmentation").on("click", ".filter-name .item", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") != "BY") {
                $(this).parents(".filter-name").siblings(".filter-type").replaceWith($("#defalt-filter-block").clone(true).find(".filter-type"));
                $(this).parents(".filter-name").siblings(".filter-type").removeClass("disabled");

                $(this).parents(".filter-name").siblings(".filter-value").addClass("hidden");

                if ($(this).data("type") == "l") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "bl") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").addClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "n") {
                    $(this).parents(".filter-name").siblings(".filter-value.num").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").show();
                }  else if ($(this).data("type") == "s") {
                    $(this).parents(".filter-name").siblings(".filter-value.string").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                }  else if ($(this).data("type") == "d") {
                    $(this).parents(".filter-name").siblings(".filter-value.date").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.eq").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lt").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lte").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").trigger("click");
                    $(this).parents(".filter-name").siblings(".filter-value.date").find(".open-date-picker").trigger("click");
                }
            }
            
            $(this).parents(".query").find(".filter-value.num input").val("");
            $(this).parents(".query").find(".filter-value.date input").val("");
            $(this).parents(".query").find(".filter-value.date input").data("timestamp", null)
            $(this).parents(".query").find(".filter-value.string input").val("");
            
            var self = $(this).parents(".query").find(".filter-value .select-items>div");
            self.html("<div></div>");
            function setUpFilterValues(filterValues, filterNames, biglist){
                var filterValStr = "";
                
                if(biglist){
                    var tmpItem = $("<div>");
                    tmpItem.addClass("warning");
                    tmpItem.text(jQuery.i18n.map["drill.big-list-warning"]);       
                    filterValStr += tmpItem.prop('outerHTML');
                }
    
                if (jQuery.isArray(filterValues)) {
                    for (var i = 0; i < filterValues.length; i++) {
                        var tmpItem = $("<div>");
        
                        tmpItem.addClass("item");
                        tmpItem.attr("data-value", filterValues[i]);
                        tmpItem.text(filterNames[i]);
        
                        filterValStr += tmpItem.prop('outerHTML');
                    }
                } else {
                    for (var p in filterValues) {
                        var tmpItem = $("<div>");
                        tmpItem.addClass("group");
                        tmpItem.text(p);
            
                        filterValStr += tmpItem.prop('outerHTML');
                        for (var i = 0; i < filterValues[p].length; i++) {
                            var tmpItem = $("<div>");
            
                            tmpItem.addClass("item");
                            tmpItem.attr("data-value", filterValues[p][i]);
                            tmpItem.text(countlyCommon.decode(filterValues[p][i]));
            
                            filterValStr += tmpItem.prop('outerHTML');
                        }
                    }
                }
    
                self.html(filterValStr);
            }
            
            if($(this).data("type") == "bl"){
                var prop = $(this).data("value");
                $(this).parents(".query").find(".filter-value").addClass("loading");

                countlySegmentation.getBigListMetaData(prop, null, function(values, names){
                    self.parents(".query").find(".filter-value").removeClass("loading");
                    setUpFilterValues(values, names,  names.length >= countlyGlobal["list_limit"]);
                    var timeout = null;
                    self.parents(".query").find(".filter-value").on("keyup", ".search input", function(e) {
                        e.stopPropagation();
                        var search = $(this).val();
                        var parent = $(this).parents(".filter-value").find(".select-items");
                        if(!parent.find(".table-loader").length)
                            parent.prepend("<div class='table-loader'></div>");
                        if(timeout)
                        {
                            clearTimeout(timeout);
                            timeout = null;
                        }
                        timeout = setTimeout(function(){
                            countlySegmentation.getBigListMetaData(prop, search, function(values, names){
                                parent.find(".table-loader").remove();
                                setUpFilterValues(values, names, names.length >= countlyGlobal["list_limit"]);
                            });                                    
                        }, 1000);
                    });
                });
            }
            else{
                setUpFilterValues(countlySegmentation.getFilterValues($(this).data("value")), countlySegmentation.getFilterNames($(this).data("value")));
            }

            var selectedItem = $(this).parents(".cly-select").find(".text");
            selectedItem.text($(this).text());
            selectedItem.data("value", $(this).data("value"));
            selectedItem.data("type", $(this).data("type"));
        });

        $("#segmentation").on("click", ".filter-value .item", function() {
            setTimeout(function() { initApply(); }, 0);
        });

        $("#segmentation").on("keyup", ".filter-value input",function(event) {
            initApply();
        });

        $("#segmentation").on("keydown", ".filter-value.num input",function(event) {
            // Allow: backspace, delete, tab, escape, and enter
            if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
                // Allow: Ctrl+A
                (event.keyCode == 65 && event.ctrlKey === true) ||
                // Allow: home, end, left, right
                (event.keyCode >= 35 && event.keyCode <= 39)) {
                // let it happen, don't do anything
                return;
            }
            else {
                // Ensure that it is a number and stop the keypress
                if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                    event.preventDefault();
                }
            }
        });

        $("#segmentation").on("keydown", ".filter-value.date input",function(event) {
            event.preventDefault();
        });

        $("#segmentation").on("click", ".filter-connector .item", function() {
            $(this).parents(".query").find(".filters").replaceWith($("#defalt-filter-block").clone(true).find(".filters"));

            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");
            self.adjustFilters();

            $(this).parents(".query").removeClass("by");

            if ($(this).data("value") == "BY") {
                $(this).parents(".query").addClass("by");
                $(this).parents(".query").find(".filter-type").hide();
                $(this).parents(".query").find(".filter-value").hide();
                $(this).parents(".query").find(".filter-connector").addClass("disabled");
            } else if ($(this).data("value") == "AND") {

            } else if ($(this).data("value") == "OR") {

            }

            initApply();
        });

        $("#segmentation").on("click", ".query .delete", function() {
            $(this).parent(".query").remove();
            $(".query:visible:last-child").find(".filter-name").removeClass("disabled");
            $(".query:visible:last-child").find(".filter-type").removeClass("disabled");
            self.adjustFilters();
            initApply();

            var filterData = getFilterObjAndByVal();
            self.filterObj = filterData.dbFilter;

            if (_.isEmpty(filterData.dbFilter)) {
                $("#no-filter").show();
                $("#current-filter").hide().find(".text").text("");
            } else {
                $("#no-filter").hide();
                $("#current-filter").show().find(".text").text(filterData.bookmarkText);
            }

            self.loadAndRefresh();
        });

        $("#segmentation").on("click", ".open-date-picker", function(e) {
            $(this).next(".date-picker").show();
            $(this).next(".date-picker").find(".calendar").datepicker({
                numberOfMonths:1,
                showOtherMonths:true,
                maxDate:moment().subtract('days', 1).toDate(),
                onSelect:function (selectedDate) {
                    var instance = $(this).data("datepicker"),
                        date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings),
                        currMoment = moment(date);

                    $(this).parents(".date-picker").prev(".open-date-picker").val(countlyCommon.formatDate(moment(date),"DD MMMM, YYYY"));
                    $(this).parents(".date-picker").prev(".open-date-picker").data("timestamp", moment(currMoment.format("DD MMMM, YYYY"), "DD MMMM, YYYY").unix());
                    $(".date-picker").hide();
                    initApply();
                }
            });

            $.datepicker.setDefaults($.datepicker.regional[""]);
            $(this).next(".date-picker").find(".calendar").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

            $(this).next(".date-picker").click(function(e) {
                e.stopPropagation();
            });

            e.stopPropagation();
        });

        $("#filter-add-container").on("click", function() {
            if ($(".query:visible:not(.by):last").find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                $(".query:visible:not(.by):last").find(".filter-name").addClass("req");
                return false;
            }

            var filterBlocks = $("#filter-blocks"),
                defaultFilters = $("#defalt-filter-block").html();

            filterBlocks.append(defaultFilters);
            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");

            var byFilter = $("#filter-blocks").find(".query.by").clone(true);
            $("#filter-blocks").find(".query.by").remove();
            $("#filter-blocks").append(byFilter);

            self.adjustFilters();
        });

        $("#apply-filter").on("click", function() {
            if ($(this).hasClass("disabled")) {
                return true;
            }
            self.showLoader = true;
            var filterData = getFilterObjAndByVal();
            var needData = false;
            if (!_.isEqual(self.filterObj, filterData.dbFilter)) {
                // If the query is not changed we don't need to get data
                needData = true;
            }

            self.filterObj = filterData.dbFilter;

            /*
            self.byVal = filterData.byVal;
            self.activeSegmentForTable = "";
            self.draw(needData, false);
            */

            if (needData) {
                //countlyFunnel.setFilter(self.filterObj);
                self.loadAndRefresh();
            }

            $("#no-filter").hide();
            $("#current-filter").show().find(".text").text(filterData.bookmarkText);
        });

        $("#remove-filter").on("click", function(e) {
            self.filterObj = {};
            self.showLoader = true;
            var wasFilterVisible = $("#filter-view").is(":visible");

            $("#filter-view").replaceWith(self.filterBlockClone.clone(true));
            if (wasFilterVisible) {
                $("#filter-view").show();
                $("#filter-view-container").show();
                self.adjustFilters();
                $(".flot-text").hide().show(0);
            }

            $("#current-filter").hide();
            $("#no-filter").show();

            //countlyFunnel.setFilter(self.filterObj);
            self.loadAndRefresh();

            e.stopPropagation();
        });

        $(window).click(function() {
            $(".date-picker").hide();
        });
    },
    getFilterObjAndByVal: function(){
        var filterObj = {},
            filterObjTypes = {},
            byVal = "",
            byValText = "",
            bookmarkText = "";

        $(".query:visible").each(function (index) {
            var tmpConnector = $(this).find(".filter-connector .text").data("value"),
            tmpText = $(this).find(".filter-name .text").text(),
            tmpTypeText = $(this).find(".filter-type .text").text(),
            tmpValText = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").val() ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").text(),
            tmpName = $(this).find(".filter-name .text").data("value"),
            tmpType = $(this).find(".filter-type .text").data("value"),
            tmpVal = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").data("timestamp") ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").data("value"),
            tmpDataType = $(this).find(".filter-name .text").data("type");

            if(typeof tmpVal == "boolean")
                tmpVal = tmpVal+"";

            if (tmpConnector != "BY") {
                if (!tmpVal) {
                    return true;
                }

                if (tmpConnector && index != 0) {
                    bookmarkText += " [" + tmpConnector + "] ";
                }

                bookmarkText += tmpText + " " + tmpTypeText + " " + tmpValText;

                if (!filterObj[tmpName]) {
                    filterObj[tmpName] = [];
                }

                if (!filterObjTypes[tmpName]) {
                    filterObjTypes[tmpName] = [];
                }

                if (tmpDataType == "d" || tmpDataType == "n") {
                    tmpVal = parseInt(tmpVal, 10);
                }

                var exp = {};

                if (tmpType == "=" || tmpType == "!=") {
                    exp = tmpVal;
                } else {
                    exp[tmpType] = tmpVal;
                }

                filterObj[tmpName].push(exp);
                filterObjTypes[tmpName].push(tmpType);
            } else {
                byVal = tmpName;
                byValText = tmpText;
            }
        });

        var dbFilter = {};

        for (var filter in filterObj) {
            dbFilter[filter] = {};
            for (var i = 0; i < filterObj[filter].length; i++) {
                if(_.isObject(filterObj[filter][i])) {
                    for (var tmpFilter in filterObj[filter][i]) {
                        dbFilter[filter][tmpFilter] = filterObj[filter][i][tmpFilter];
                    }
                } else if (filterObjTypes[filter][i] == "!=") {
                    if (!dbFilter[filter]["$nin"]) {
                        dbFilter[filter]["$nin"] = [];
                    }

                    dbFilter[filter]["$nin"].push(filterObj[filter][i]);
                } else {
                    if (!dbFilter[filter]["$in"]) {
                        dbFilter[filter]["$in"] = [];
                    }

                    dbFilter[filter]["$in"].push(filterObj[filter][i]);
                }
            }
        }

        return {
            bookmarkText: bookmarkText,
            dbFilter: dbFilter,
            byVal: byVal,
            byValText: byValText
        };
    },
    adjustFilters: function() {
        if (!$("#filter-view").is(":visible")) {
            return;
        }
    
        var queryCount = $("#filter-blocks").find(".query:visible").length;
    
        if (queryCount == 0) {
            $("#filter-add-container").trigger("click");
        }
    
        $(".query:visible").each(function (index) {
            $(this).find(".connector div").hide();
    
            if (queryCount > 1) {
                $(this).find(".and-or").show();
    
                if (index == 0) {
                    $(this).find(".and-or").hide();
                    $(this).find(".connector .middle-bottom").show();
                } else if (index == (queryCount - 1)) {
                    $(this).find(".connector .middle-top").show();
                } else {
                    $(this).find(".connector .top").show();
                    $(this).find(".connector .middle-bottom").show();
                }
    
                if (index == (queryCount - 1)) {
                    $(this).find(".filter-connector").removeClass("disabled");
                } else {
                    $(this).find(".filter-connector").addClass("disabled");
                }
            } else {
                $(this).find(".and-or").hide();
            }
    
            if ($(this).find(".filter-connector .text").data("value") == "BY") {
                $(this).find(".cly-select").removeClass("disabled");
                $(this).find(".filter-connector").addClass("disabled");
                $(this).prev(".query").find(".filter-connector").removeClass("disabled");
                $(this).prev(".query").find(".filter-name").removeClass("disabled");
    
                if ($(this).prev(".query").find(".filter-name .text").text() != "Select a Filter") {
                    $(this).prev(".query").find(".filter-type").removeClass("disabled");
                }
            }
        });
    
        setTimeout(function() { $("#filter-blocks").removeClass("empty"); }, 1000);
    },
    loadAndRefresh: function() {
        var filter = {};
        for(var i in this.filterObj){
            filter[i.replace("up.", "")] = this.filterObj[i];
        }
        this._query = filter;
        app.navigate("/analytics/retention/"+JSON.stringify(filter), false);
        this.refresh(true);
    },
    getTooltipText: function(jqueryEl) {
        var users = jqueryEl.data('users'),
            colDate = jqueryEl.data('date');

        var $parentRow = jqueryEl.parents(".retention-row"),
            date = $parentRow.find("td:first-child").text(),
            totalUsers = $parentRow.find("td:nth-child(2)").text();

        var tooltipStr = "<div id='retention-tip'>";
        tooltipStr += jQuery.i18n.prop("retention.first-seen-on", totalUsers, date) + "<br/>";

        var upLink = "";

        if (users > 0 && typeof countlyUserdata !== "undefined") {
            var query = JSON.parse(JSON.stringify(this._query)) || {};
            var bucket = ["fsd", "cdfs"];

            switch(countlyRetention.getActiveBucket()){
                case "monthly":
                    bucket = ["fsm", "cmfs"];
                    break;
                case "weekly":
                    bucket = ["fsw", "cwfs"];
                    break;
            }

            query[bucket[0]] = jqueryEl.data("bucket")+"";
            query[bucket[1]] = { "$gte": parseInt(jqueryEl.attr("data-retention")) };

            upLink = "#/users/query/"+JSON.stringify(query);
        }

        tooltipStr += jQuery.i18n.prop("retention.active-until", "<a href='" + upLink + "'>" + users + " (" + jqueryEl.data('percent') + "%)</a>", colDate);
        tooltipStr += "</div>";

        return tooltipStr;
    },
    tableJS: function() {
        var self = this;

        $('.retaining-cell').find(".retention-info").tooltipster({
            animation: 'fade',
            animationDuration: 100,
            delay: 100,
            theme: 'tooltipster-borderless',
            trigger: 'custom',
            triggerOpen: {
                mouseenter: true,
                touchstart: true
            },
            triggerClose: {
                mouseleave: true,
                touchleave: true
            },
            interactive: true,
            contentAsHTML: true,
            functionInit: function(instance, helper) {
                instance.content(self.getTooltipText($(helper.origin).parents(".retaining-cell")));
            }
        });

        $(".retention-row").on({
            mouseenter:function () {
                var retCols = $(this).data("cols");

                for (var i = 0; i < retCols.length; i++) {
                    $("#retention-date" + (i + 1)).text("(" + retCols[i] + ")");
                }
            },
            mouseleave:function () {
                $(".retention-date").text("");
            }
        });

        $(".retaining-cell").on({
            mouseenter:function () {
                $(".retention-info").removeClass("hover");
                self.hoveredCellID = $(this).attr("id");
            },
            mouseleave:function () {
                self.hoveredCellID = null;
            }
        });

        $(".retention-info").on({
            mouseenter:function () {
                $(".retention-info").removeClass("hover");
                $(this).addClass("hover");
            }
        });
    }
});

//register views
app.retentionView = new RetentionView();

app.route("/analytics/retention", "retention", function () {
    this.retentionView._query = null;
	this.renderWhenReady(this.retentionView);
});

app.route("/analytics/retention/*query", "retention", function (query) {
     try{
        query = JSON.parse(query);
    }
    catch(ex){
        query = null;
    }
    this.retentionView._query = query;
	this.renderWhenReady(this.retentionView);
});

$( document ).ready(function() {
    //check if configuration view exists
    if(app.configurationsView){
        app.configurationsView.registerLabel("retention_segments", "sidebar.engagement.retention");
        app.configurationsView.registerLabel("retention_segments-span", "retention.span");
    }

	$('.sidebar-menu:not(#iot-type) #engagement-submenu').prepend(
		'<a href="#/analytics/retention" class="item">'+
            '<div class="text" data-localize="sidebar.engagement.retention"></div>'+
        '</a>');
});