var plugin = {},
	common = require('../../../api/utils/common.js'),
    plugins = require('../../pluginManager.js');

(function (plugin) {
	plugins.register("/worker", function(ob){
		common.dbMap['paying'] = 'p';
	});
	plugins.register("/i", function(ob){
		var params = ob.params;
		var app = ob.app;
		params.iap_event = app['iap_event'];
		return true;
	});
	plugins.register("/o/validate", function(ob){
		var params = ob.params;
		var app = ob.app;
		params.iap_event = app['iap_event'];
		return true;
	});
	plugins.register("/i/events", function(ob){
		var params = ob.params;
		var currEvent = ob.currEvent;
		if (params.iap_event && params.iap_event == currEvent.key) {
            var sum = 0;
            if(currEvent.sum){
                sum = currEvent.sum*currEvent.count;
            }
            common.db.collection('app_users' + params.app_id).findAndModify({'_id': params.app_user_id },{}, {$max:{"lp":params.time.timestamp}, $inc:{tp:sum, tpc:1}, $set:{"lpa":sum}},{upsert:true, new:false}, function (err, dbAppUser){
                if(dbAppUser && dbAppUser.value)
                    dbAppUser = dbAppUser.value;
                var updateUsersZero = {},
				updateUsersMonth = {},
				dbDateIds = common.getDateIds(params);

				if (dbAppUser && dbAppUser[common.dbUserMap['last_payment']]) {
					var userLastPaymentTimestamp = dbAppUser[common.dbUserMap['last_payment']],
						currDate = common.getDate(params.time.timestamp, params.appTimezone),
						userLastPaymentDate = common.getDate(userLastPaymentTimestamp, params.appTimezone),
						secInMin = (60 * (currDate.getMinutes())) + currDate.getSeconds(),
						secInHour = (60 * 60 * (currDate.getHours())) + secInMin,
						secInMonth = (60 * 60 * 24 * (currDate.getDate() - 1)) + secInHour,
						secInYear = (60 * 60 * 24 * (common.getDOY(params.time.timestamp, params.appTimezone) - 1)) + secInHour;
		
					if (userLastPaymentTimestamp < (params.time.timestamp - secInMin)) {
						updateUsersMonth['d.' + params.time.day + '.' + params.time.hour + '.' + common.dbMap['paying']] = 1;
					}
		
					if (userLastPaymentTimestamp < (params.time.timestamp - secInHour)) {
						updateUsersMonth['d.' + params.time.day + '.' + common.dbMap['paying']] = 1;
					}
		
					if (userLastPaymentDate.getFullYear() == params.time.yearly &&
						Math.ceil(common.moment(userLastPaymentDate).format("DDD") / 7) < params.time.weekly) {
						updateUsersZero["d.w" + params.time.weekly + '.' + common.dbMap['paying']] = 1;
					}
		
					if (userLastPaymentTimestamp < (params.time.timestamp - secInMonth)) {
						updateUsersZero['d.' + params.time.month + '.' + common.dbMap['paying']] = 1;
					}
		
					if (userLastPaymentTimestamp < (params.time.timestamp - secInYear)) {
						updateUsersZero['d.' + common.dbMap['paying']] = 1;
					}
		
				} else {
					common.fillTimeObjectZero(params, updateUsersZero, common.dbMap.paying);
					common.fillTimeObjectMonth(params, updateUsersMonth, common.dbMap.paying);
				}
                var postfix = common.crypto.createHash("md5").update(params.qstring.device_id).digest('base64')[0];
				if (Object.keys(updateUsersZero).length) {
					common.db.collection('users').update({'_id': params.app_id + "_" + dbDateIds.zero + "_" + postfix}, {$set: {m: dbDateIds.zero, a: params.app_id + ""}, '$inc': updateUsersZero}, {'upsert': true},function(){});
				}
                if (Object.keys(updateUsersMonth).length) {
                    common.db.collection('users').update({'_id': params.app_id + "_" + dbDateIds.month + "_" + postfix}, {$set: {m: dbDateIds.month, a: params.app_id + ""}, '$inc': updateUsersMonth}, {'upsert': true},function(){});
                }
            });
			return true;
        }
	});
}(plugin));

module.exports = plugin;