var plugin = {},
	common = require('../../../api/utils/common.js'),
	async = require('async'),
	jimp = require('jimp'),
	fs = require('fs'),
    _ = require('underscore'),
    countlyCommon = require('../../../api/lib/countly.common.js'),
    Promise = require("bluebird"),
    plugins = require('../../pluginManager.js');

(function (plugin) {
	//write api call
    plugins.setConfigs("users", {
        custom_set_limit: 50,
        custom_prop_limit: 20
    });
	plugins.register("/i", function(ob){
        return new Promise(function(resolve, reject){
            var params = ob.params;
    
            if (typeof params.qstring.user_details == "string") {
                try {
                    params.qstring.user_details = JSON.parse(params.qstring.user_details);
                } catch (SyntaxError) {
                    params.qstring.user_details = {};
                }
            }
    
            if(params.qstring.user_details){
                var userDetails = {
                        "$set":{},
                        "$unset":{},
                        "$inc":{},
                        "$mul":{},
                        "$max":{},
                        "$min":{},
                        "$setOnInsert":{},
                        "$setOnce":{},
                        "$push":{},
                        "$pull":{},
                        "$addToSet":{}
                    },
                    remDetails = {},
                    shouldUpdate = false;
    
                if(params.files){
                    for(var i in params.files){
                        var tmp_path = params.files[i].path;
                        var type = params.files[i].type;
                        var target_path = __dirname+'/../../../frontend/express/public/userimages/'+params.app_user_id+'.png';
                        if (type != "image/png" && type != "image/gif" && type != "image/jpeg") {
                            fs.unlink(tmp_path, function () {});
                        }
                        else{
                            userDetails["$set"]["picture"] = common.config.path+'/userimages/'+params.app_user_id+'.png';
                            shouldUpdate = true;
                            fs.rename(tmp_path, target_path, function (err) {
                                if(err)
                                    console.log(err);
                                fs.unlink(tmp_path, function () {});
                                try{
                                    jimp.read(target_path, function (err, icon) {
                                        if (err) console.log(err, err.stack);
                                        icon.cover(72, 72)            // resize                // set JPEG quality                 // set greyscale 
                                            .write(target_path); // save 
                                    });
                                } catch(e){
                                    console.log(e.stack);
                                }
                            });
                        }
                        break;
                    }
                }
    
                //defaults
                var props = ["name", "username", "email", "organization", "phone", "picture", "gender", "byear", "custom"];
                var prop;
                for(var i = 0, l = props.length; i < l; i++){
                    prop = props[i];
                    if(params.qstring.user_details[prop] && params.qstring.user_details[prop] != ""){
                        shouldUpdate = true;
                        if(prop == "custom"){
                            if(typeof params.qstring.user_details[prop] === 'object'){
                                for(var key in params.qstring.user_details[prop]){
                                    var escapedKey = key.replace(/^\$/, "").replace(/\./g, ":");
                                    if(params.qstring.user_details[prop][key] === null || params.qstring.user_details[prop][key] === ""){
                                        userDetails["$unset"]["custom."+escapedKey] = "";
                                    }
                                    else if(!params.app_user || !params.app_user.custom || typeof params.app_user.custom[escapedKey] !== "undefined" || Object.keys(params.app_user.custom).length < parseInt(plugins.getConfig("users").custom_prop_limit)){
                                        if(typeof params.qstring.user_details[prop][key] == "object"){
                                            if(Array.isArray(params.qstring.user_details[prop][key])){
                                                for(var el = 0; el < params.qstring.user_details[prop][key].length; el++){
                                                    params.qstring.user_details[prop][key][el] = common.convertToType(params.qstring.user_details[prop][key][el]);
                                                }
                                                userDetails["$set"]["custom."+escapedKey] = params.qstring.user_details[prop][key];
                                            }
                                            else{
                                                for(var action in params.qstring.user_details[prop][key]){
                                                    if(userDetails[action]){
                                                        userDetails[action]["custom."+escapedKey] = common.convertToType(params.qstring.user_details[prop][key][action]);
                                                    }
                                                }
                                            }
                                        }
                                        else{
                                            userDetails["$set"]["custom."+escapedKey] = common.convertToType(params.qstring.user_details[prop][key]);
                                        }
                                    }
                                }
                            }
                        }
                        else{
                            userDetails["$set"]["hasInfo"] = true;
                            userDetails["$set"][prop] = params.qstring.user_details[prop];
                        }
                    }
                    else if(params.qstring.user_details[prop] === null || params.qstring.user_details[prop] === ""){
                        shouldUpdate = true;
                        userDetails["$unset"][prop] = "";
                    }
                }
            }

            if(shouldUpdate){
                var user = params.app_user;
                var update = {};

                for(var i in userDetails){

                    if(Object.keys(userDetails[i]).length > 0){
                        //emulate set once
                        if(i == "$setOnce"){
                            for(var key in userDetails[i]){
                                if(!user || !user.custom || typeof user.custom[key.replace("custom.", "")] == "undefined"){
                                    if(!update["$set"])
                                        update["$set"] = {};
                                    update["$set"][key] = userDetails[i][key];
                                }
                            }
                        }
                        //check array properties
                        else if(i == "$push" || i == "$pull" || i == "$addToSet"){
                            for(var key in userDetails[i]){
                                var realKey = key.replace("custom.", "");
                                if(!user || !user.custom || typeof user.custom[realKey] == "undefined" || Array.isArray(user.custom[realKey])){
                                    if(!update[i])
                                        update[i] = {};
                                    if(!Array.isArray(userDetails[i][key]))
                                        userDetails[i][key] = [userDetails[i][key]];
                                    if(i == "$pull")
                                        update[i][key] = {$in: userDetails[i][key]};
                                    else if(i == "$push"){
                                        update[i][key] = {$each: userDetails[i][key], $slice:-parseInt(plugins.getConfig('users').custom_set_limit)};
                                    }
                                    else if(i == "$addToSet"){
                                        //filter out unique values
                                        userDetails[i][key] = userDetails[i][key].filter(function(val, index, self){
                                            if((!user || !user.custom || typeof user.custom[realKey] == "undefined" || user.custom[realKey].indexOf(val) === -1) && self.indexOf(val) === index)
                                                return true;
                                            return false;
                                        });
                                        //use push to update with slice
                                        delete update[i];
                                        if(userDetails[i][key].length){
                                            if(!update["$push"])
                                                update["$push"] = {};
                                            update["$push"][key] = {$each: userDetails[i][key], $slice:-parseInt(plugins.getConfig('users').custom_set_limit)};
                                        }
                                    }
                                }
                                //convert property to array
                                else if(user && user.custom && !Array.isArray(user.custom[realKey]) && (i == "$push" || i == "$addToSet")){
                                    if(!Array.isArray(userDetails[i][key]))
                                        userDetails[i][key] = [userDetails[i][key]];
                                    userDetails[i][key].unshift(user.custom[realKey]);
                                    if(!update["$set"])
                                        update["$set"] = {};
                                    update["$set"][key] = _.uniq(userDetails[i][key]);
                                }
                            }
                        }
                        else
                            update[i] = userDetails[i];
                    }

                }

                //update regular properties
                if(Object.keys(update).length)
                    common.updateAppUser(params, update, resolve);
            }
            else{
                resolve();
            }
        });
	});

	//read api call
	plugins.register("/o", function(ob){
		var params = ob.params
		var validate = ob.validateUserForDataReadAPI;
		if(params.qstring.method == 'user_details'){
            validate(params, function(params){
				if (!params.qstring.uid) {
					var columns = ["name", "cc", "d", "sc", "ls", "tsd"];
					var infos = {"user-known":true, "user-anonymous":null};
					var filter = {};
                    if(params.qstring.query && params.qstring.query != ""){
                        try{
                            filter = JSON.parse(params.qstring.query);
                        }
                        catch(ex){
                            console.log("Cannot parse user list query", params.qstring.query);
                        }
                    }
					if(params.qstring.sSearch && params.qstring.sSearch != ""){
						//filter["name"] = {"$regex": new RegExp(".*"+params.qstring.sSearch+".*", 'i')};
						filter["$text"] = { "$search": "\""+params.qstring.sSearch+"\"" };
					}
					if(params.qstring.filter && params.qstring.filter != "" && params.qstring.filter != "user-all"){
						if(infos[params.qstring.filter])
							filter["hasInfo"] = infos[params.qstring.filter];
						else
							filter["hasInfo"] = {"$ne": true};
					}
                    filter["seq"] = {"$exists": false};

					common.db.collection('app_users' + params.app_id).count({},function(err, total) {
                        total--;
						var cursor = common.db.collection('app_users' + params.app_id).find(filter,{name:1, cc:1, cty:1, d:1, brw:1, p:1, sc: 1, ls:1, tsd:1, events:1, email:1, picture:1, hasInfo:1});
						cursor.count(function (err, count) {
							if(params.qstring.iDisplayStart && params.qstring.iDisplayStart != 0)
								cursor.skip(parseInt(params.qstring.iDisplayStart));
							if(params.qstring.iDisplayLength && params.qstring.iDisplayLength != -1)
								cursor.limit(parseInt(params.qstring.iDisplayLength));
							if(params.qstring.iSortCol_0 && params.qstring.sSortDir_0){
								var ob = {};
                                if(columns[params.qstring.iSortCol_0] === "d" && params.app.type === "web"){
                                    if(plugins.isPluginEnabled("browser"))
                                        ob["brw"] = (params.qstring.sSortDir_0 == "asc") ? 1 : -1;
                                    else
                                        ob["p"] = (params.qstring.sSortDir_0 == "asc") ? 1 : -1;
                                }
                                else
                                    ob[columns[params.qstring.iSortCol_0]] = (params.qstring.sSortDir_0 == "asc") ? 1 : -1;
								cursor.sort(ob);
							}
							if(count > 0){
								cursor.toArray(function(err, items) {
									var item;
									for(var i = items.length-1; i >= 0; i--){
										item = items[i];
										if(item._id == "uid-sequence"){
											items.splice(i,1);
										}
										else{
											if(!item["picture"] || item["picture"] == ""){
												if(item["email"] && item["email"] != "")
													item["picture"] = "https://www.gravatar.com/avatar/" + common.crypto.createHash('md5').update((item["email"]+"").toLowerCase().trim()).digest("hex") + "?d=identicon&s=150";
												else
													item["picture"] = common.config.path+"/users/images/users/default_user.png";
											}
										}
									}
									common.returnOutput(params, {sEcho:params.qstring.sEcho, iTotalRecords:total, iTotalDisplayRecords:count, aaData:items});
								});
							}
							else{
								common.returnOutput(params, {sEcho:params.qstring.sEcho, iTotalRecords:total, iTotalDisplayRecords:count, aaData:[]});
							}
						});
					});
				}
				else{
					common.db.collection('app_users' + params.app_id).findOne({'_id':params.qstring.uid}, function (err, result) {
						if (result) {
							//picture
							if(!result["picture"] || result["picture"] == ""){
								if(result["email"] && result["email"] != "")
									result["picture"] = "https://www.gravatar.com/avatar/" + common.crypto.createHash('md5').update(result["email"].toLowerCase().trim()).digest("hex") + "?d=identicon&s=150";
								else
									result["picture"] = common.config.path+"/users/images/users/default_user.png";
							}

                            var historyList = ["cc", "d", "c", "av", "r", "la", "brw", "name", "username", "email", "organization", "phone", "gender", "byear"];
                            result.history = {};
							result.sessions = [];
							result.events = [];
							result.funnels = [];
							//check if drill available
							if(common.drillDb){
                                var periodObj = getPeriodObj(params);
								var collection = common.drillDb.collection("drill_events" + common.crypto.createHash('sha1').update("[CLY]_session" + params.app_id).digest('hex'));
								collection.find({uid:result["uid"], ts:countlyCommon.getTimestampRangeQuery(params)}).sort( { ts: -1 } ).toArray(function(err, items) {
									if(items){
										var item;
										for(var i = 0, l = items.length; i < l; i++){
											item = items[i];
											result.sessions.push({_id:item._id, ts:item.ts, sd:(item.sd ? item.sd : 0), nts:(items[i-1] ? items[i-1].ts : "")});
                                            for(var j = 0; j < historyList.length; j++){
                                                if(item.up && item.up[historyList[j]]){
                                                    if(historyList[j] == "d"){
                                                        if((result.d && result.d && item.up.d != result.d) || (result.p && item.up.p && item.up.p != result.p) || (result.pv && item.up.pv && item.up.pv != result.pv)){
                                                            if(!result.history[historyList[j]])
                                                                result.history[historyList[j]] = {};
                                                            if(!result.history[historyList[j]][item.up[historyList[j]]])
                                                                result.history[historyList[j]][item.up[historyList[j]]] = {};

                                                            if(item.up.p){
                                                                if(!result.history[historyList[j]][item.up[historyList[j]]][item.up.p])
                                                                    result.history[historyList[j]][item.up[historyList[j]]][item.up.p] = {};
                                                                if(item.up.pv)
                                                                    result.history[historyList[j]][item.up[historyList[j]]][item.up.p][item.up.pv] = true;
                                                            }
                                                        }
                                                    }
                                                    else if(historyList[j] == "r"){
                                                        if((result.r && result.r && item.up.r != result.r) || (result.dnst && item.up.dnst && item.up.dnst != result.dnst)){
                                                            if(!result.history[historyList[j]])
                                                                result.history[historyList[j]] = {};
                                                            if(!result.history[historyList[j]][item.up[historyList[j]]])
                                                                result.history[historyList[j]][item.up[historyList[j]]] = {};
                                                            result.history[historyList[j]][item.up[historyList[j]]][item.up.dnst] = true;
                                                        }
                                                    }
                                                    else if(item.up[historyList[j]] != result[historyList[j]]){
                                                        if(!result.history[historyList[j]])
                                                            result.history[historyList[j]] = {};
                                                        result.history[historyList[j]][item.up[historyList[j]]] =  true;
                                                    }
                                                }
                                            }
										}
									}
									getUserEvents();
								});
								function getUserEvents(){
									common.db.collection("events").findOne({'_id':params.app_id}, {list:1, map:1}, function (err, eventData) {
										function eventIterator(key, done){
											eventKey = common.fixEventKey(key);
											if (eventKey && eventKey.indexOf('[CLY]') !== 0 || eventKey == "[CLY]_crash" || eventKey == "[CLY]_view" || eventKey == "[CLY]_star_rating") {
												var collection = common.drillDb.collection("drill_events" + common.crypto.createHash('sha1').update(eventKey + params.app_id).digest('hex'));
                                                var query = {uid:result["uid"], ts:countlyCommon.getTimestampRangeQuery(params)};
                                                if(eventKey == "[CLY]_view")
                                                    query["sg.visit"] = 1;
												collection.find(query).toArray(function(err, items) {
													if(items){
														var events = [],
															event,
															sum = 0;
														for(var i = 0, l = items.length; i < l; i++){
															event = items[i];
															if(!event.s)
																event.s = 0;
                                                            if(!event.dur)
																event.dur = 0;
															events.push({_id:event._id, key:key, ts: event.ts, cd:event.cd.getTime(), c: event.c, s:event.s, dur:event.dur, sg:event.sg});
															if(key == params.iap_event)
																sum += event.s;
														}
														if(key == params.iap_event){
															//total purchase amount
															result["tpa"] = sum;
															//total purchase count
															result["tpc"] = items.length;
															var last_purchase = items[items.length-1];
															if(last_purchase){
																if(!last_purchase.s)
																	last_purchase.s = 0;
																//last purchase amount
																result["lpa"] = last_purchase.s;
																//last purchase time
																result["lpt"] = last_purchase.ts;
															}
														}
														done(null, events);
													}
													else
														done(null, null);
												});
											}
											else
												done(null, null);
										}
                                        if(!eventData)
                                            eventData = {};
                                        if(!eventData.list)
                                            eventData.list = [];
                                        if(eventData.list.indexOf("[CLY]_crash") == -1)
                                            eventData.list.push("[CLY]_crash");
                                        if(eventData.list.indexOf("[CLY]_view") == -1)
                                            eventData.list.push("[CLY]_view");
										async.map(eventData.list, eventIterator, function(err, results) {
											//post processing
											result.events = [];
											var eventSet,
												event,
												eventTimes = {};
											for(var i = 0, l = results.length; i < l; i++){
												eventSet = results[i];
												if(eventSet){
													for(var j = 0, l2 = eventSet.length; j < l2; j++){
														event = eventSet[j];
														result.events.push(event);
														if(!eventTimes[event.ts]){
															eventTimes[event.ts] = {};
														}
														eventTimes[event.ts][event.key] = true;
													}
												}
											}
											common.db.collection("funnels").find({app_id:params.app_id.toString()},{app_id:0}).toArray(function(err,funnels){
												result.funnels = [];
												if (funnels) {
													var funnel, event, filled = {};
													//iterating through event timeline first,
													//as it will be bigger
                                                    var eventTimeline = Object.keys(eventTimes);
                                                    eventTimeline.sort(function(a, b){return a-b});
													for(var i = 0, l = eventTimeline.length; i < l; i++){
														eventTime = eventTimeline[i];
														for(var j = 0, l2 = funnels.length; j < l2; j++){
															funnel = funnels[j];
															//setting current funnel step
															if(!funnel.step){
																funnel.step = 0;
																funnel.actionTimes = [];
															}
															//if user alreay been through funnel
															if(funnel.step >= funnel.steps.length)
																continue;

                                                            var checking = true;
                                                            while(checking){
                                                                //checking if step was made at this time
                                                                if(eventTimes[eventTime][funnel.steps[funnel.step]]){
                                                                    funnel.actionTimes[funnel.step] = eventTime;
                                                                    funnel.step++;
                                                                    if(funnel.step == 1)
                                                                        result.funnels.push(funnel);
                                                                    if(funnel.step >= funnel.steps.length)
                                                                        filled[funnel._id] = true;
                                                                }
                                                                else{
                                                                    checking = false;
                                                                }
                                                            }
														}
                                                        if(Object.keys(filled).length === funnels.length)
                                                            break;
													}
												}
												common.returnOutput(params, result);
											});
										});
									});
								}
							}
							else
								common.returnOutput(params, result);
						}
						else{
							common.returnMessage(params, 400, 'User not found');
						}
					});
				}
			});
			return true;
		}
	});

	plugins.register("/i/apps/create", function(ob){
		var appId = ob.appId;
		common.db.collection('app_users' + appId).ensureIndex({"uid":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":"text", "email":"text"},function(){});
	});
    plugins.register("/i/apps/reset", function(ob){
		var appId = ob.appId;
		common.db.collection('app_users' + appId).ensureIndex({"uid":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":"text", "email":"text"},function(){});
	});
    plugins.register("/i/apps/clear_all", function(ob){
		var appId = ob.appId;
		common.db.collection('app_users' + appId).ensureIndex({"uid":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "name":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "sc":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "ls":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"hasInfo":1, "tsd":1},function(){});
		common.db.collection('app_users' + appId).ensureIndex({"name":"text", "email":"text"},function(){});
	});

    function getPeriodObj(params) {
		params.qstring.period = params.qstring.period || "month";
        if (params.qstring.period && params.qstring.period.indexOf(",") !== -1) {
            try {
                params.qstring.period = JSON.parse(params.qstring.period);
            } catch (SyntaxError) {
				console.log('Parse period JSON failed');
                return false;
            }
        }

        countlyCommon.setPeriod(params.qstring.period);
        countlyCommon.setTimezone(params.appTimezone);

        return countlyCommon.periodObj;
    }
}(plugin));

module.exports = plugin;