(function (countlyUserdata, $, undefined) {

    //Private Properties
    var _userDetails = {},
        _activeAppKey = 0,
        _initialized = false,
        _period = null,
		_periodObj = {};

    //Public Methods
    countlyUserdata.initialize = function (id, isRefresh) {
		_activeAppKey = countlyCommon.ACTIVE_APP_KEY;
		_initialized = true;

		if(id){
            _period = countlyCommon.getPeriodForAjax();
			return $.ajax({
			 type:"GET",
			 url:countlyCommon.API_PARTS.data.r,
			 data:{
				 "api_key":countlyGlobal.member.api_key,
				 "app_id":countlyCommon.ACTIVE_APP_ID,
				 "method":"user_details",
				 "uid":id,
                 "period":_period,
                 "display_loader": !isRefresh
			 },
			 dataType:"jsonp",
			 success:function (json) {
				_userDetails = json;
				//post processing
				
				//name
				if(!_userDetails["name"]) 
					_userDetails["name"] = "#"+_userDetails["_id"].substring(0, 5);
					
				_userDetails["_id"] = _userDetails["_id"].substring(0, 5);
					
				//location
				var flag = "";
				if(!_userDetails["cc"])
					_userDetails["cc"] = jQuery.i18n.map["userdata.unknown"]; 
				if(_userDetails["cc"] != jQuery.i18n.map["userdata.unknown"]) 
					flag = '&nbsp;&nbsp;<img src="'+ countlyGlobal["cdn"]+'images/flags/'+ _userDetails["cc"].toLowerCase() + '.png" class="cc_flag"/>'; 
				if(_userDetails["cty"] != jQuery.i18n.map["userdata.unknown"]) 
					_userDetails["cc"] += " ("+_userDetails["cty"]+")";
				_userDetails["cc"] += flag;
				
				//session duration
				if(!_userDetails["sd"])
					_userDetails["sd"] = 0;
				_userDetails["sd"] = countlyCommon.formatTime(_userDetails["sd"]);
				
				//device
				if(!_userDetails["d"])
					_userDetails["d"] = "";
				_userDetails["d"] = countlyDevice.getDeviceFullName(_userDetails["d"]);
				if(_userDetails["p"]){
					if(_userDetails["pv"] && _userDetails["pv"] != "")
						_userDetails["p"] += " " + countlyDeviceDetails.fixOSVersion(_userDetails["pv"]);
					if(_userDetails["d"] != "")
						_userDetails["d"] += " (" + _userDetails["p"] + ")";
					else
						_userDetails["d"] = _userDetails["p"];
				}
				if(_userDetails["d"] == "")
					_userDetails["d"] = jQuery.i18n.map["userdata.unknown"];
                
                if(!_userDetails["av"])
					_userDetails["av"] = jQuery.i18n.map["userdata.unknown"];
                
                _userDetails["av"] = _userDetails["av"].replace(new RegExp(":", 'g'),".");
                if(!_userDetails["r"])
					_userDetails["r"] = jQuery.i18n.map["userdata.unknown"];
                if(_userDetails["dnst"])
                    _userDetails["r"] += " ("+_userDetails["dnst"].replace(new RegExp(":", 'g'),".")+")";
                
                if(!_userDetails["c"])
					_userDetails["c"] = jQuery.i18n.map["userdata.unknown"];
				
				//total session duration
				if(!_userDetails["tsd"])
					_userDetails["tsd"] = 0;	
				_userDetails["tsdorig"] = parseInt(_userDetails["tsd"]);
				_userDetails["tsd"] = countlyCommon.formatTime(_userDetails["tsd"]);
				
				//first seen
				_userDetails["fs"] = countlyCommon.formatTimeAgo(_userDetails["fs"]);
				
				//last seen
				_userDetails["lsorig"] = parseInt(_userDetails["ls"]);
				_userDetails["ls"] = countlyCommon.formatTimeAgo(_userDetails["ls"]);
				
				//events
				if(!_userDetails["events"])
					_userDetails["events"] = [];
					
				//sessions
				if(!_userDetails["sessions"])
					_userDetails["sessions"] = [];
					
				//funnels
				if(!_userDetails["funnels"])
					_userDetails["funnels"] = [];
				
				var sessionData = countlyCommon.extractUserChartData(_userDetails.sessions, "Sessions");
				var eventData = countlyCommon.extractUserChartData(_userDetails.events, "Events");
				_userDetails["graphData"] = [sessionData,eventData];
				
				_userDetails.sessionTrend = countlyUserdata.getTrend(sessionData.data);
				_userDetails.eventsTrend = countlyUserdata.getTrend(eventData.data);
				
				
				//purchase info
				if(!_userDetails["tpc"])
					_userDetails["tpc"] = 0;
					
				if(!_userDetails["tpa"])
					_userDetails["tpa"] = 0;
				_userDetails["tpa"] = parseFloat(_userDetails["tpa"]).toFixed(2);
				
				if(!_userDetails["lpa"])
					_userDetails["lpa"] = 0;
				_userDetails["lpa"] = parseFloat(_userDetails["lpa"]).toFixed(2);
					
				if(!_userDetails["lpt"] || _userDetails["lpt"] == 0)
					_userDetails["lpt"] = jQuery.i18n.map["userdata.never"];
				else
					_userDetails["lpt"] = countlyCommon.formatTimeAgo(_userDetails["lpt"]/1000);
				
				//gender
				if(_userDetails["gender"] && _userDetails["gender"].toLowerCase() == "f")
					_userDetails["gender"] = jQuery.i18n.map["userdata.female"];
				else if(_userDetails["gender"] && _userDetails["gender"].toLowerCase() == "m")
					_userDetails["gender"] = jQuery.i18n.map["userdata.male"];
				else
					_userDetails["gender"] = jQuery.i18n.map["userdata.unknown"];
				
				//age
				if(!_userDetails["byear"])
					_userDetails["age"] = jQuery.i18n.map["userdata.unknown"];
				else
					_userDetails["age"] = new Date().getFullYear() - parseInt(_userDetails["byear"]);
					
				//picture
				if(_userDetails["picture"] == "users/images/users/default_user.png" && _userDetails["name"].charAt(0) != "#")
					_userDetails["picture"] = new initialAvatar(_userDetails["name"],{width:90, height:90}).getData();
					
				if(_userDetails["custom"]){
					if($.isEmptyObject(_userDetails["custom"]))
					{
						delete _userDetails["custom"];
					}
					else
					{
                        _userDetails["custom_order"] = [];
						for(var key in _userDetails["custom"]){
                            _userDetails["custom_order"].push(key);
							if(_userDetails["custom"][key] == null)
								delete _userDetails["custom"][key];
							else{
                                if($.isArray(_userDetails["custom"][key]) && _userDetails["custom"][key].length > 1){
                                    _userDetails["custom"][key].sort();
                                    _userDetails["custom"][key] = "<ul class='no-padding'><li>"+_userDetails["custom"][key].join("</li><li>")+"</li></ul>";
                                }
                                else
                                    _userDetails["custom"][key] += "";
                            }
						}
                        _userDetails["custom_order"].sort();
					}
				}
				
				if(_userDetails["cmp"]){
					if(!_userDetails["cmp"]["pl"])
						_userDetails["cmp"]["pl"] = "Unknown";
					
					if(!_userDetails["cmp"]["l"])
						_userDetails["cmp"]["l"] = "Unknown";
					
					if(!_userDetails["cmp"]["b"])
						_userDetails["cmp"]["b"] = "Unknown";
					
					if(_userDetails["cmp"]["bv"])
						_userDetails["cmp"]["b"] += " "+_userDetails["cmp"]["bv"];
                    
                    _userDetails["cmp"]["n"] = (typeof countlyAttribution !== 'undefined' && countlyAttribution.getCampaignName(_userDetails["cmp"]["c"]) != _userDetails["cmp"]["c"]) ? countlyAttribution.getCampaignName(_userDetails["cmp"]["c"]) : _userDetails["cmp"]["n"];
				}
                
                if(_userDetails["src"] && typeof countlySources !== 'undefined'){
                    _userDetails["src"] = countlySources.getSourceName(_userDetails["src"]);
                }
                
                if(_userDetails["la"] && typeof countlyLanguage !== 'undefined'){
                    _userDetails["la"] = countlyLanguage.getLanguageName(_userDetails["la"]);
                }
                
                if(_userDetails["crashes"] && typeof countlyCrashes !== 'undefined'){
                    _userDetails["crashdata"] = {};
                    for(var i = _userDetails["crashes"].length-1; i >= 0 && i > _userDetails["crashes"].length - 6; i--){
                        _userDetails["crashdata"][_userDetails["crashes"][i]] = countlyCrashes.getCrashName(_userDetails["crashes"][i]);
                    }
                    if(_userDetails["crashes"].length > 5){
                        _userDetails["more_crashes"] = true;
                    }
                }
				
				if(_userDetails["note"]){
					//check for empty line
					if(_userDetails["note"] == "\n")
						_userDetails["note"] = "";
					else
						//convert newlines to br
						_userDetails["note"] = _userDetails["note"].replace(/(?:\r\n|\r|\n)/mg, '<br />');
				}
                
                if(countlyGlobal["apps"][countlyCommon.ACTIVE_APP_ID].type == "iot"){
                    delete _userDetails["sd"];
                    delete _userDetails["tsd"];
                    delete _userDetails["sc"];
                    delete _userDetails["username"];
                    delete _userDetails["email"];
                    delete _userDetails["organization"];
                    delete _userDetails["c"];
                    delete _userDetails["phone"];
                    delete _userDetails["gender"];
                    delete _userDetails["byear"];
                    delete _userDetails["age"];
                    delete _userDetails["lpa"];
                    delete _userDetails["lpt"];
                    delete _userDetails["tpa"];
                    delete _userDetails["tpc"];
                }
			 },
             error:function(){
                CountlyHelpers.alert(jQuery.i18n.map["userdata.user-not-found"], "red");
                app.navigate("/users", true);
             }
			});
        }
        else
            if (typeof countlySegmentation != "undefined") {
                countlySegmentation.reset();
                return true;
            } else {
                return true;
            }
    };

    countlyUserdata.refresh = countlyUserdata.initialize;

    countlyUserdata.reset = function () {
		_userDetails = {};
    };
	
	countlyUserdata.getTrend = function(data){
		var prevTotal = 0,
			curTotal = 0,
			length = data.length;
		if(data[length-2] && data[length-2][1])
			prevTotal = data[length-2][1];
		if(data[length-1] && data[length-1][1])
			curTotal = data[length-1][1];
		return countlyCommon.getPercentChange(prevTotal, curTotal);
	};
	
	countlyUserdata.getUserdetails = function () {
		return _userDetails;
    };
	
}(window.countlyUserdata = window.countlyUserdata || {}, jQuery));