window.UserdataView = countlyView.extend({
	initialize:function () {
		this.filter = (store.get("countly_userfilter")) ? store.get("countly_userfilter") : "user-all";
        this.loaded = false;
    },
    beforeRender: function() {
		if(this.template)
			return $.when(countlyUserdata.initialize()).then(function () {});
		else{
			var self = this;
			return $.when($.get(countlyGlobal["path"]+'/users/templates/userdata.html', function(src){
				self.template = Handlebars.compile(src);
			}), countlyUserdata.initialize()).then(function () {});
		}
    },
    processData:function(){
        var self = this;
        this.dtable = $('.d-table').dataTable($.extend({}, $.fn.dataTable.defaults, {
			"bServerSide": true,
			"sAjaxSource": countlyCommon.API_PARTS.data.r + "?api_key="+countlyGlobal.member.api_key+"&app_id="+countlyCommon.ACTIVE_APP_ID+"&method=user_details",
            "fnServerData": function ( sSource, aoData, fnCallback ) {
                    self.request = $.ajax({
                      "dataType": 'jsonp',
                      "type": "POST",
                      "url": sSource,
                      "data": aoData,
                      "success": function(data){
                            fnCallback(data);
                            $("#view-users .bar-values").text(jQuery.i18n.prop('userdata.of-users', data.iTotalDisplayRecords, data.iTotalRecords));
                            $("#view-users .bar span").text(Math.floor((data.iTotalDisplayRecords/data.iTotalRecords)*100)+"%");
                            $("#view-users .bar .bar-inner").animate({width: Math.floor((data.iTotalDisplayRecords/data.iTotalRecords)*100)+"%"}, 1000);
                            self.loaded = true;
                            self.request = null;
                       }
                    });
            },
			"fnServerParams": function ( aoData ) {
				aoData.push( { "name": "filter", "value": self.filter } );
                if(self._query){
                    aoData.push({ "name": "query", "value": JSON.stringify(self._query) });
                }
			},
			"oLanguage": {
				"sZeroRecords": jQuery.i18n.map["userdata.no-users"],
				"sEmptyTable": jQuery.i18n.map["userdata.no-users"],
                "sSearch ": jQuery.i18n.map["userdata.search"]
			},
			"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
				$(nRow).attr("id", aData._id);
			},
            "aoColumns": [
                { "mData": function(row){var name; 
					if(!row["name"])
						name = "#"+row["_id"].substring(0, 5); 
					else
						name = row["name"]; 
				
					if(name.charAt(0) != "#" && row["picture"] == "users/images/users/default_user.png")
						row["picture"] = new initialAvatar(name, {width:20, height:20}).getData();
					return "<img src='"+row["picture"]+"' class='small_pic'/> " + "<span style='vertical-align: middle;'>" + name + "</span>";
				}, "sType":"string", "sTitle": jQuery.i18n.map["userdata.name"] },
                { "mData": function(row){var c = (!row["cc"]) ? jQuery.i18n.map["common.unknown"] : row["cc"]; if(c != jQuery.i18n.map["common.unknown"]) c = '<div class="flag" style="background-image: url(images/flags/'+ c.toLowerCase() + '.png);"></div>'+c; if(row["cty"] != "Unknown") c += " ("+row["cty"]+")"; return c;}, "sType":"string", "sTitle": jQuery.i18n.map["userdata.country"], "bSortable":false },
                { "mData": function(row){if(countlyGlobal["apps"][countlyCommon.ACTIVE_APP_ID].type === "web"){
                    if(typeof countlyBrowser !== "undefined"){
                        return (typeof row["brw"] === "undefined") ? jQuery.i18n.map["common.unknown"] : row["brw"];
                    }
                    else{
                        return (typeof row["p"] === "undefined") ? jQuery.i18n.map["common.unknown"] : row["p"];
                    }
                }else{
                    return (!row["d"]) ? jQuery.i18n.map["common.unknown"] : countlyDevice.getDeviceFullName(row["d"]);
                }}, "sType":"string", "sTitle": (countlyGlobal["apps"][countlyCommon.ACTIVE_APP_ID].type === "web") ? ((typeof countlyBrowser !== "undefined") ? jQuery.i18n.map["browser.title"] : jQuery.i18n.map["sidebar.analytics.platforms"]) : jQuery.i18n.map["userdata.device"], "bSortable":false },
				{ "mData": function(row){return (!row["sc"]) ? 0 : row["sc"]}, "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.total-sessions"] },
				{ "mData": function(row, type){if(type == "display") return (row["ls"]) ? countlyCommon.formatTimeAgo(row["ls"]) : jQuery.i18n.map["userdata.never"]; else return (row["ls"]) ? row["ls"] : 0;}, "sType":"format-ago", "sTitle": jQuery.i18n.map["userdata.lastseen"] },
				{ "mData": function(row){return countlyCommon.formatTime((row["tsd"]) ? parseInt(row["tsd"]) : 0);}, "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.time-spent"]}
            ]
        }));
		//dataTables_filter
		$('.dataTables_filter input').unbind();
		var timeout = null,
			that = this;
		$('.dataTables_filter input').bind('keyup', function(e) {
			$this = this;
			if(timeout)
			{
				clearTimeout(timeout);
				timeout = null;
			}
			timeout = setTimeout(function(){
				that.dtable.fnFilter($this.value);   
			}, 1000);
		});

        this.dtable.stickyTableHeaders();
		this.dtable.fnSort( [ [4,'desc'] ] );
        setTimeout(function(){$(".dataTables_filter input").attr("placeholder",jQuery.i18n.map["userdata.search"]);},1000);
		$('.userdata tbody').on("click", "tr", function (){
			var id = $(this).attr("id");
			if(id)
				window.location.hash = "/users/"+id;
		});
        
        $("#users-back").click(function(){
            window.history.back();
        });
    },
    renderCommon:function (isRefresh) {
        this.templateData = {
            "page-title":jQuery.i18n.map["userdata.title"],
            "logo-class":"users"
        };

        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));
            $("#"+this.filter).addClass("selected").addClass("active");
            var self = this;
            if(this._back){
                $("#users-back").show();
                $("#view-users").hide();
            }
     
            $.when(countlySegmentation.initialize("[CLY]_session")).then(function () {
                self.initDrill();
                setTimeout(function() {
                    self.filterBlockClone = $("#filter-view").clone(true);
                    if(self._filter){
                        $("#filter-view").show();
                        $(".filter-view-container").show();
                        self.adjustFilters();
                        var filter = self._query;
                        var inputs = [];
                        var subs = {};
                        for(var i in filter){
                            inputs.push(i);
                            subs[i] = [];
                            for(var j in filter[i]){
                                if(filter[i][j].length){
                                    for(var k = 0; k < filter[i][j].length; k++){
                                        subs[i].push([j, filter[i][j][k]]);
                                    }
                                }
                                else{
                                    subs[i].push([j, filter[i][j]]);
                                }
                            }
                        }
                        function setInput(cur, sub, total){
                            sub = sub || 0;
                            if(inputs[cur]){
                                var filterType = subs[inputs[cur]][sub][0];
                                if(filterType == "$in")
                                    filterType = "=";
                                else if(filterType == "$nin")
                                    filterType = "!=";
            
                                var val = subs[inputs[cur]][sub][1];
                                var el = $(".query:nth-child("+(total)+")");
                                el.find(".filter-name").trigger("click");
                                el.find(".filter-type").trigger("click");
                                if(inputs[cur].indexOf(".") > -1)
                                    el.find(".filter-name").find(".select-items .item[data-value='" + inputs[cur] + "']").trigger("click");
                                else
                                    el.find(".filter-name").find(".select-items .item[data-value='up." + inputs[cur] + "']").trigger("click");
                                el.find(".filter-type").find(".select-items .item[data-value='" + filterType + "']").trigger("click");
                                setTimeout(function() {
                                    el.find(".filter-value").not(".hidden").trigger("click");
                                    if(el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").length)
                                        el.find(".filter-value").not(".hidden").find(".select-items .item[data-value='" + val + "']").trigger("click");
                                    else if(_.isNumber(val) && (val + "").length == 10){
                                        el.find(".filter-value.date").find("input").val(countlyCommon.formatDate(moment(val*1000),"DD MMMM, YYYY"));
                                        el.find(".filter-value.date").find("input").data("timestamp", val);
                                    }
                                    else
                                        el.find(".filter-value").not(".hidden").find("input").val(val);
                                    
                                    if(subs[inputs[cur]].length == sub+1){
                                        cur++;
                                        sub = 0;
                                    }
                                    else
                                        sub++;
                                    total++;
                                    if(inputs[cur]){
                                        $("#filter-add-container").trigger("click");
                                        if(sub > 0)
                                            setTimeout(function() {
                                                var el = $(".query:nth-child("+(total)+")");
                                                el.find(".and-or").find(".select-items .item[data-value='OR']").trigger("click");
                                                setInput(cur, sub, total);
                                            }, 500);
                                        else
                                            setInput(cur, sub, total);
                                    }
                                    else{
                                        setTimeout(function(){
                                            $("#apply-filter").removeClass("disabled");
                                            $("#no-filter").hide();
                                            var filterData = self.getFilterObjAndByVal();
                                            $("#current-filter").show().find(".text").text(filterData.bookmarkText);
                                            $("#connector-container").show();
                                        }, 500);
                                    }
                                }, 500);
                        }
                        }
                        setInput(0, 0, 1);
                    }
                }, 0);
                
                if(self._request){
                    $.ajax({
                        type:"GET",
                        url:countlyCommon.API_PARTS.data.r,
                        data:self._request,
                        success:function(uids){
                            if(!self._query)
                                self._query = {};
                            self._query["uid"] = {"$in":uids};
                            self.processData();
                            app.localize();
                        },
                        error:function(){
                            self.processData();
                            app.localize();
                        }
                    });
                }
                else
                    self.processData();
            });
        }
    },
	filterUsers: function(filter){
		this.filter = filter;
		store.set("countly_userfilter", filter);
		$("#"+this.filter).addClass("selected").addClass("active");
		this.dtable.fnDraw();
	},
    refresh:function (force) {
        if(this.loaded || force){
            this.loaded = false;
            if(this.request)
                this.request.abort();
            this.request = null;
            this.dtable.fnDraw(false);
        }
    },
    resetFilter: function() {
        this.filterObj = {};
        $("#filter-view").replaceWith(this.filterBlockClone.clone(true));
        $("#current-filter").hide();
        $("#no-filter").show();
    },
    initDrill: function() {
        var self = this;
        this.filterObj = {};
        $("#view-users").on("click", "#toggle-filter", function() {
            if ($(".filter-view-container").is(":visible")) {
                $("#filter-view").hide();
                $(".filter-view-container").hide();
            } else {
                $("#filter-view").show();
                $(".filter-view-container").show();
                self.adjustFilters();
            }
        });

        var usedFilters = {},
            currEvent = "";

        function getFilters() {
            usedFilters = {};

            $(".query:visible").each(function (index) {
                var filterType = $(this).find(".filter-name .text").data("type");

                // number and date types can be used multiple times for range queries
                if (filterType != "n" && filterType != "d") {
                    usedFilters[$(this).find(".filter-name .text").data("value")] = true;
                }
            });

            var filters = countlySegmentation.getFilters(currEvent),
                allFilters = "";

            if (filters.length == 0) {
                CountlyHelpers.alert(jQuery.i18n.map["drill.no-filters"], "black");
            }

            for (var i = 0; i < filters.length; i++) {
                if(typeof filters[i].id != "undefined"){
                    if (usedFilters[filters[i].id] == true) {
                        continue;
                    }
    
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", filters[i].type);
                    tmpItem.attr("data-value", filters[i].id);
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
                else{
                    var tmpItem = $("<div>");
    
                    tmpItem.addClass("group");
                    tmpItem.text(filters[i].name);
    
                    allFilters += tmpItem.prop('outerHTML');
                }
            }

            return allFilters;
        }

        function getFilterObjAndByVal() {
            return self.getFilterObjAndByVal();
        }

        function initApply() {
            var filterData = getFilterObjAndByVal();
            if (_.isEmpty(filterData.dbFilter) && filterData.byVal == "") {
                $("#apply-filter").addClass("disabled");
            } else {
                $("#apply-filter").removeClass("disabled");
            }
        }

        $("#segmentation").on("click", ".filter-connector", function() {
            var byUsed = false;
            $(".query:visible").each(function (index) {
                byUsed = byUsed || ($(this).find(".filter-connector .text").data("value") == "BY");
            });

            if (byUsed) {
                $(this).find(".item.by").hide();
            } else {
                $(this).find(".item.by").show();
            }
        });

        $("#segmentation").on("click", ".filter-name", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") == "OR") {
                var existingFilters = [],
                    orFilters = [],
                    orFilterStr = "";

                $(".query:visible:not(.by)").each(function (index) {
                    if ($(this).find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                        return false;
                    }

                    if (existingFilters.indexOf($(this).find(".filter-name .text").data("value")) == -1) {
                        orFilters.push({
                            type: $(this).find(".filter-name .text").data("type"),
                            id: $(this).find(".filter-name .text").data("value"),
                            name: $(this).find(".filter-name .text").text()
                        });

                        existingFilters.push($(this).find(".filter-name .text").data("value"));
                    }
                });

                for (var i = 0; i < orFilters.length; i++) {
                    var tmpItem = $("<div>");

                    tmpItem.addClass("item");
                    tmpItem.attr("data-type", orFilters[i].type);
                    tmpItem.attr("data-value", orFilters[i].id);
                    tmpItem.text(orFilters[i].name);

                    orFilterStr += tmpItem.prop('outerHTML');
                }

                $(this).find(".select-items>div").html(orFilterStr);
            } else {
                $(this).find(".select-items>div").html(getFilters());
            }

            initApply();
        });

        $("#segmentation").on("click", ".filter-name .item", function() {
            if ($(this).parents(".query").find(".filter-connector .text").data("value") != "BY") {
                $(this).parents(".filter-name").siblings(".filter-type").replaceWith($("#defalt-filter-block").clone(true).find(".filter-type"));
                $(this).parents(".filter-name").siblings(".filter-type").removeClass("disabled");

                $(this).parents(".filter-name").siblings(".filter-value").addClass("hidden");

                if ($(this).data("type") == "l") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "bl") {
                    $(this).parents(".filter-name").siblings(".filter-value.list").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-value.list").addClass("big-list");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").text("");
                    $(this).parents(".filter-name").siblings(".filter-value").find(".text").data("value","");
                    $(this).parents(".filter-name").siblings(".filter-value").removeClass("disabled");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                } else if ($(this).data("type") == "n") {
                    $(this).parents(".filter-name").siblings(".filter-value.num").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").show();
                }  else if ($(this).data("type") == "s") {
                    $(this).parents(".filter-name").siblings(".filter-value.string").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                }  else if ($(this).data("type") == "d") {
                    $(this).parents(".filter-name").siblings(".filter-value.date").removeClass("hidden");
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.eq").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.num").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lt").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.lte").hide();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").show();
                    $(this).parents(".filter-name").siblings(".filter-type").find(".item.gte").trigger("click");
                    $(this).parents(".filter-name").siblings(".filter-value.date").find(".open-date-picker").trigger("click");
                }
            }
            
            $(this).parents(".query").find(".filter-value.num input").val("");
            $(this).parents(".query").find(".filter-value.date input").val("");
            $(this).parents(".query").find(".filter-value.date input").data("timestamp", null)
            $(this).parents(".query").find(".filter-value.string input").val("");
            
            var self = $(this).parents(".query").find(".filter-value .select-items>div");
            self.html("<div></div>");
            function setUpFilterValues(filterValues, filterNames, biglist){
                var filterValStr = "";
                
                if(biglist){
                    var tmpItem = $("<div>");
                    tmpItem.addClass("warning");
                    tmpItem.text(jQuery.i18n.map["drill.big-list-warning"]);       
                    filterValStr += tmpItem.prop('outerHTML');
                }
    
                if (jQuery.isArray(filterValues)) {
                    for (var i = 0; i < filterValues.length; i++) {
                        var tmpItem = $("<div>");
        
                        tmpItem.addClass("item");
                        tmpItem.attr("data-value", filterValues[i]);
                        tmpItem.text(filterNames[i]);
        
                        filterValStr += tmpItem.prop('outerHTML');
                    }
                } else {
                    for (var p in filterValues) {
                        var tmpItem = $("<div>");
                        tmpItem.addClass("group");
                        tmpItem.text(p);
            
                        filterValStr += tmpItem.prop('outerHTML');
                        for (var i = 0; i < filterValues[p].length; i++) {
                            var tmpItem = $("<div>");
            
                            tmpItem.addClass("item");
                            tmpItem.attr("data-value", filterValues[p][i]);
                            tmpItem.text(countlyCommon.decode(filterValues[p][i]));
            
                            filterValStr += tmpItem.prop('outerHTML');
                        }
                    }
                }
    
                self.html(filterValStr);
            }
            
            if($(this).data("type") == "bl"){
                var prop = $(this).data("value");
                $(this).parents(".query").find(".filter-value").addClass("loading");

                countlySegmentation.getBigListMetaData(prop, null, function(values, names){
                    self.parents(".query").find(".filter-value").removeClass("loading");
                    setUpFilterValues(values, names,  names.length >= countlyGlobal["list_limit"]);
                    var timeout = null;
                    self.parents(".query").find(".filter-value").on("keyup", ".search input", function(e) {
                        e.stopPropagation();
                        var search = $(this).val();
                        var parent = $(this).parents(".filter-value").find(".select-items");
                        if(!parent.find(".table-loader").length)
                            parent.prepend("<div class='table-loader'></div>");
                        if(timeout)
                        {
                            clearTimeout(timeout);
                            timeout = null;
                        }
                        timeout = setTimeout(function(){
                            countlySegmentation.getBigListMetaData(prop, search, function(values, names){
                                parent.find(".table-loader").remove();
                                setUpFilterValues(values, names, names.length >= countlyGlobal["list_limit"]);
                            });                                    
                        }, 1000);
                    });
                });
            }
            else{
                setUpFilterValues(countlySegmentation.getFilterValues($(this).data("value")), countlySegmentation.getFilterNames($(this).data("value")));
            }

            var selectedItem = $(this).parents(".cly-select").find(".text");
            selectedItem.text($(this).text());
            selectedItem.data("value", $(this).data("value"));
            selectedItem.data("type", $(this).data("type"));
        });

        $("#segmentation").on("click", ".filter-value .item", function() {
            setTimeout(function() { initApply(); }, 0);
        });

        $("#segmentation").on("keyup", ".filter-value input",function(event) {
            initApply();
        });

        $("#segmentation").on("keydown", ".filter-value.num input",function(event) {
            // Allow: backspace, delete, tab, escape, and enter
            if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
                // Allow: Ctrl+A
                (event.keyCode == 65 && event.ctrlKey === true) ||
                // Allow: home, end, left, right
                (event.keyCode >= 35 && event.keyCode <= 39)) {
                // let it happen, don't do anything
                return;
            }
            else {
                // Ensure that it is a number and stop the keypress
                if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                    event.preventDefault();
                }
            }
        });

        $("#segmentation").on("keydown", ".filter-value.date input",function(event) {
            event.preventDefault();
        });

        $("#segmentation").on("click", ".filter-connector .item", function() {
            $(this).parents(".query").find(".filters").replaceWith($("#defalt-filter-block").clone(true).find(".filters"));

            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");
            self.adjustFilters();

            $(this).parents(".query").removeClass("by");

            if ($(this).data("value") == "BY") {
                $(this).parents(".query").addClass("by");
                $(this).parents(".query").find(".filter-type").hide();
                $(this).parents(".query").find(".filter-value").hide();
                $(this).parents(".query").find(".filter-connector").addClass("disabled");
            } else if ($(this).data("value") == "AND") {

            } else if ($(this).data("value") == "OR") {

            }

            initApply();
        });

        $("#segmentation").on("click", ".query .delete", function() {
            $(this).parent(".query").remove();
            $(".query:visible:last-child").find(".filter-name").removeClass("disabled");
            $(".query:visible:last-child").find(".filter-type").removeClass("disabled");
            self.adjustFilters();
            initApply();

            var filterData = getFilterObjAndByVal();
            self.filterObj = filterData.dbFilter;

            if (_.isEmpty(filterData.dbFilter)) {
                $("#no-filter").show();
                $("#current-filter").hide().find(".text").text("");
            } else {
                $("#no-filter").hide();
                $("#current-filter").show().find(".text").text(filterData.bookmarkText);
            }

            self.loadAndRefresh();
        });

        $("#segmentation").on("click", ".open-date-picker", function(e) {
            $(this).next(".date-picker").show();
            $(this).next(".date-picker").find(".calendar").datepicker({
                numberOfMonths:1,
                showOtherMonths:true,
                maxDate:moment().subtract('days', 1).toDate(),
                onSelect:function (selectedDate) {
                    var instance = $(this).data("datepicker"),
                        date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings),
                        currMoment = moment(date);

                    $(this).parents(".date-picker").prev(".open-date-picker").val(countlyCommon.formatDate(moment(date),"DD MMMM, YYYY"));
                    $(this).parents(".date-picker").prev(".open-date-picker").data("timestamp", moment(currMoment.format("DD MMMM, YYYY"), "DD MMMM, YYYY").unix());
                    $(".date-picker").hide();
                    initApply();
                }
            });

            $.datepicker.setDefaults($.datepicker.regional[""]);
            $(this).next(".date-picker").find(".calendar").datepicker("option", $.datepicker.regional[countlyCommon.BROWSER_LANG]);

            $(this).next(".date-picker").click(function(e) {
                e.stopPropagation();
            });

            e.stopPropagation();
        });

        $("#filter-add-container").on("click", function() {
            if ($(".query:visible:not(.by):last").find(".filter-name .text").text() == jQuery.i18n.map["drill.select-filter"]) {
                $(".query:visible:not(.by):last").find(".filter-name").addClass("req");
                return false;
            }

            var filterBlocks = $("#filter-blocks"),
                defaultFilters = $("#defalt-filter-block").html();

            filterBlocks.append(defaultFilters);
            $(".query:visible:not(:last)").find(".filter-name").addClass("disabled");
            $(".query:visible:not(:last)").find(".filter-type").addClass("disabled");

            var byFilter = $("#filter-blocks").find(".query.by").clone(true);
            $("#filter-blocks").find(".query.by").remove();
            $("#filter-blocks").append(byFilter);

            self.adjustFilters();
        });

        $("#apply-filter").on("click", function() {
            if ($(this).hasClass("disabled")) {
                return true;
            }
            var filterData = getFilterObjAndByVal();
            var needData = false;
            if (!_.isEqual(self.filterObj, filterData.dbFilter)) {
                // If the query is not changed we don't need to get data
                needData = true;
            }

            self.filterObj = filterData.dbFilter;

            /*
            self.byVal = filterData.byVal;
            self.activeSegmentForTable = "";
            self.draw(needData, false);
            */

            if (needData) {
                //countlyFunnel.setFilter(self.filterObj);
                self.loadAndRefresh();
            }

            $("#no-filter").hide();
            $("#current-filter").show().find(".text").text(filterData.bookmarkText);
        });

        $("#remove-filter").on("click", function(e) {
            self.filterObj = {};
            var wasFilterVisible = $("#filter-view").is(":visible");

            $("#filter-view").replaceWith(self.filterBlockClone.clone(true));
            if (wasFilterVisible) {
                $("#filter-view").show();
                self.adjustFilters();
            }

            $("#current-filter").hide();
            $("#no-filter").show();

            //countlyFunnel.setFilter(self.filterObj);
            self.loadAndRefresh();

            e.stopPropagation();
        });

        $(window).click(function() {
            $(".date-picker").hide();
        });
    },
    getFilterObjAndByVal: function(){
        var filterObj = {},
            filterObjTypes = {},
            byVal = "",
            byValText = "",
            bookmarkText = "";

        $(".query:visible").each(function (index) {
            var tmpConnector = $(this).find(".filter-connector .text").data("value"),
            tmpText = $(this).find(".filter-name .text").text(),
            tmpTypeText = $(this).find(".filter-type .text").text(),
            tmpValText = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").val() ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").text(),
            tmpName = $(this).find(".filter-name .text").data("value"),
            tmpType = $(this).find(".filter-type .text").data("value"),
            tmpVal = $(this).find(".filter-value.num input").val() ||
                $(this).find(".filter-value.date input").data("timestamp") ||
                $(this).find(".filter-value.string input").val() ||
                $(this).find(".filter-value .text").data("value"),
            tmpDataType = $(this).find(".filter-name .text").data("type");

            if(typeof tmpVal == "boolean")
                tmpVal = tmpVal+"";

            if (tmpConnector != "BY") {
                if (!tmpVal) {
                    return true;
                }

                if (tmpConnector && index != 0) {
                    bookmarkText += " [" + tmpConnector + "] ";
                }

                bookmarkText += tmpText + " " + tmpTypeText + " " + tmpValText;

                if (!filterObj[tmpName]) {
                    filterObj[tmpName] = [];
                }

                if (!filterObjTypes[tmpName]) {
                    filterObjTypes[tmpName] = [];
                }

                if (tmpDataType == "d" || tmpDataType == "n") {
                    tmpVal = parseInt(tmpVal, 10);
                }

                var exp = {};

                if (tmpType == "=" || tmpType == "!=") {
                    exp = tmpVal;
                } else {
                    exp[tmpType] = tmpVal;
                }

                filterObj[tmpName].push(exp);
                filterObjTypes[tmpName].push(tmpType);
            } else {
                byVal = tmpName;
                byValText = tmpText;
            }
        });

        var dbFilter = {};

        for (var filter in filterObj) {
            dbFilter[filter] = {};
            for (var i = 0; i < filterObj[filter].length; i++) {
                if(_.isObject(filterObj[filter][i])) {
                    for (var tmpFilter in filterObj[filter][i]) {
                        dbFilter[filter][tmpFilter] = filterObj[filter][i][tmpFilter];
                    }
                } else if (filterObjTypes[filter][i] == "!=") {
                    if (!dbFilter[filter]["$nin"]) {
                        dbFilter[filter]["$nin"] = [];
                    }

                    dbFilter[filter]["$nin"].push(filterObj[filter][i]);
                } else {
                    if (!dbFilter[filter]["$in"]) {
                        dbFilter[filter]["$in"] = [];
                    }

                    dbFilter[filter]["$in"].push(filterObj[filter][i]);
                }
            }
        }

        return {
            bookmarkText: bookmarkText,
            dbFilter: dbFilter,
            byVal: byVal,
            byValText: byValText
        };
    },
    adjustFilters: function() {
        if (!$("#filter-view").is(":visible")) {
            return;
        }
    
        var queryCount = $("#filter-blocks").find(".query:visible").length;
    
        if (queryCount == 0) {
            $("#filter-add-container").trigger("click");
        }
    
        $(".query:visible").each(function (index) {
            $(this).find(".connector div").hide();
    
            if (queryCount > 1) {
                $(this).find(".and-or").show();
    
                if (index == 0) {
                    $(this).find(".and-or").hide();
                    $(this).find(".connector .middle-bottom").show();
                } else if (index == (queryCount - 1)) {
                    $(this).find(".connector .middle-top").show();
                } else {
                    $(this).find(".connector .top").show();
                    $(this).find(".connector .middle-bottom").show();
                }
    
                if (index == (queryCount - 1)) {
                    $(this).find(".filter-connector").removeClass("disabled");
                } else {
                    $(this).find(".filter-connector").addClass("disabled");
                }
            } else {
                $(this).find(".and-or").hide();
            }
    
            if ($(this).find(".filter-connector .text").data("value") == "BY") {
                $(this).find(".cly-select").removeClass("disabled");
                $(this).find(".filter-connector").addClass("disabled");
                $(this).prev(".query").find(".filter-connector").removeClass("disabled");
                $(this).prev(".query").find(".filter-name").removeClass("disabled");
    
                if ($(this).prev(".query").find(".filter-name .text").text() != "Select a Filter") {
                    $(this).prev(".query").find(".filter-type").removeClass("disabled");
                }
            }
        });
    
        setTimeout(function() { $("#filter-blocks").removeClass("empty"); }, 1000);
    },
    loadAndRefresh: function() {
        var filter = {};
        for(var i in this.filterObj){
            filter[i.replace("up.", "")] = this.filterObj[i];
        }
        this._query = filter;
        app.navigate("/users/filter/"+JSON.stringify(filter), false);
        this.refresh(true);
    }
});

window.UserdetailsView = countlyView.extend({
	initialize:function () {
        this.loaded = true;
        this.old_uid = null;
    },
    beforeRender: function() {
        var self = this;
        if(this.old_uid != this.user_id){
            this.old_uid = this.user_id;
            this.loaded = true;
        }
        if(this.loaded){
            this.loaded = false;
            if(this.template)
                return $.when(countlyUserdata.initialize(this.user_id)).then(function () {self.loaded = true;});
            else{
                var self = this;
                return $.when($.get(countlyGlobal["path"]+'/users/templates/userdetails.html', function(src){
                    self.template = Handlebars.compile(src);
                }), countlyUserdata.initialize(this.user_id)).then(function () {self.loaded = true;});
            }
        }
    },
    renderCommon:function (isRefresh) {
        var userDetails = countlyUserdata.getUserdetails();
        this.templateData = {
            "page-title":jQuery.i18n.map["userdata.title"],
            "logo-class":"users",
			"note-placeholder": jQuery.i18n.map["userdata.editnote"],
			"user":userDetails,
			"big-numbers":{
                "count":2,
                "items":[
                    {
                        "title":jQuery.i18n.map["userdata.total-sessions"],
                        "total":userDetails.sessions.length,
                        "trend":userDetails.sessionTrend.trend,
                        "help":"userdata.total-sessions"
                    },
                    {
                        "title":jQuery.i18n.map["userdata.total-events"],
                        "total":userDetails.events.length,
                        "trend":userDetails.eventsTrend.trend,
                        "help":"userdata.total-events"
                    }
                ]
            }
        };

        if (!isRefresh) {
            $(this.el).html(this.template(this.templateData));
			if(userDetails.custom){
				$("#userdata-custom").css("display", "table");
			}
            
			countlyCommon.drawTimeGraph(userDetails.graphData, "#dashboard-graph");
			
			var self = this;
			self.iMin = "";
			self.iMax = "";
			if(!self.setFiltering){
				self.setFiltering = true;
				$.fn.dataTableExt.afnFiltering.push(function( oSettings, aData, iDataIndex ) {
					if(oSettings.sTableId != "d-table-events")
						return true;
					var iMin = self.iMin;
					var iMax = self.iMax;
					var iTime = parseInt(aData[1]);
					if ( iMin == "" && iMax == "" )
						return true;
					else if ( iMin == "" && iTime < iMax )
						return true;
					else if ( iMin <= iTime && "" == iMax )
						return true;
					else if ( iMin <= iTime && iTime < iMax )
						return true;
					return false;
				});
				$.fn.dataTableExt.afnFiltering.push(function( oSettings, aData, iDataIndex ) {
					if(!$(oSettings.nTable).hasClass("userdetail-filter"))
						return true;
					var dateob, iTime;
					if(oSettings.sTableId == "d-table-funnels"){
						iTime = parseInt(aData[2])*1000;
					}
					else
						iTime = parseInt(aData[1]);
					if(countlyCommon.periodObj.isSpecialPeriod){
						var dateob1 = countlyCommon.processPeriod(countlyCommon.periodObj.currentPeriodArr[0].toString());
						var dateob2 = countlyCommon.processPeriod(countlyCommon.periodObj.currentPeriodArr[countlyCommon.periodObj.currentPeriodArr.length-1].toString());
						dateob = {timestart:dateob1.timestart, timeend:dateob2.timeend, range:"d"};
					}
					else{
						dateob = countlyCommon.processPeriod(countlyCommon.periodObj.activePeriod.toString());
					}
					if ( dateob.timestart < iTime && iTime <= dateob.timeend )
						return true;
					return false;
				});
			}
			
            this.dtablesessions = $('#d-table-sessions').dataTable($.extend({}, $.fn.dataTable.defaults, {
				"iDisplayLength": 10,
                "aaData": userDetails.sessions,
				"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
					$(nRow).attr("id", aData._id);
				},
				"oLanguage": {
					"sZeroRecords": jQuery.i18n.map["userdata.no-sessions-period"],
					"sEmptyTable": jQuery.i18n.map["userdata.no-sessions"]
				},
                "aoColumns": [
                    {"mData": function(row, type){if(type == "display") return countlyCommon.getDate(row["ts"]/1000); else return row["ts"];}, "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.session"] },
                    {"mData": function(row, type){if(type == "display") return countlyCommon.getTime(row["ts"]/1000); else return row["ts"];}, "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.time"] },
                    {"mData": function(row, type){if(type == "display") return countlyCommon.formatTime(row["sd"]); else return row["sd"];}, "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.duration"] }
                ]
            }));
			
			this.dtableevents = $('#d-table-events').dataTable($.extend({}, $.fn.dataTable.defaults, {
				"iDisplayLength": 10,
                "aaData": userDetails.events,
				"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
					$(nRow).attr("id", aData._id);

                    if (aData.key == "[CLY]_crash") {
                        $(nRow).addClass("crash");
                    } else if(aData.key == "[CLY]_view") {
                        $(nRow).addClass("view");
                    } else if(aData.key == "[CLY]_star_rating") {
                        $(nRow).addClass("star");
                    }
				},
				"oLanguage": {
					"sZeroRecords": jQuery.i18n.map["userdata.no-events-session"],
					"sEmptyTable": jQuery.i18n.map["userdata.no-events"]
				},
                "aoColumns": [
                    {
                        "mData": function(row, type) {
                            if(row.sg){
                                delete row.sg.platform_version_rate;
                            }
                            if(row.key == "[CLY]_crash") {
                                return jQuery.i18n.map["userdata.crash"] + "<i class='row-icon'></i>";
                            } else if(row.key == "[CLY]_view" && row.sg && row.sg.name) {
                                return jQuery.i18n.map["userdata.view"]+": "+row.sg.name + '<i class="row-icon"></i>';
                            } else if(row.key == "[CLY]_star_rating" && row.sg && row.sg.rating) {
                                var str = jQuery.i18n.map["userdata.star-rating"]+": ";
                                for(var i = 0; i < parseInt(row.sg.rating); i++){
                                    str += '<i class="fa fa-star" aria-hidden="true" title="'+row.sg.rating+'"></i>';
                                }
                                return str;
                            } else {
                                return countlyEvent.getEventLongName(row.key);
                            }
                        },
                        "sType":"string",
                        "sTitle": jQuery.i18n.map["userdata.events"],
                        "sClass": "break web-50"
                    },
                    {"mData": function(row, type){if(type == "display") return countlyCommon.formatTimeAgo(row["ts"]/1000); else if(type == "sort") return row; else return row.ts;}, "sType":"event-timeline", "sTitle": jQuery.i18n.map["userdata.time"] },
                    {"mData": "c", "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.count"] },
                    {"mData": "s", "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.sum"] },
                    {"mData": "dur", "sType":"numeric", "sTitle": jQuery.i18n.map["userdata.duration"] }
                ]
            }));
			
			this.dtablefunnels = $('#d-table-funnels').dataTable($.extend({}, $.fn.dataTable.defaults, {
				"iDisplayLength": 10,
                "aaData": userDetails.funnels,
				"fnRowCallback": function( nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
					$(nRow).attr("id", aData._id);
                    if ( aData.step == aData.steps.length )
                    {
                        $('td', nRow).css('color', '#45b849');
					}
				},
				"oLanguage": {
					"sZeroRecords": jQuery.i18n.map["userdata.no-funnels"],
					"sEmptyTable": jQuery.i18n.map["userdata.no-funnels"]
				},
                "aoColumns": [
                    {"mData":"name", "sType":"string", "sTitle": jQuery.i18n.map["userdata.name"] },
                    {"mData": function(row, type){if(type == "display") return ((row.step/row.steps.length)*100).toFixed(2)+"%"; else return ((row.step/row.steps.length)*100);}, "sType":"percent", "sTitle": jQuery.i18n.map["userdata.progress"] },
					{"mData": function(row, type){if(type == "display") return countlyCommon.formatTimeAgo(row.actionTimes[0]/1000); else return row.actionTimes[0]/1000;}, "sType":"format-ago", "sTitle": jQuery.i18n.map["userdata.started"] },
                    {"mData": function(row, type){return row.steps[row.step-1];}, "sType":"string", "sTitle": jQuery.i18n.map["userdata.lastevent"] },
                    {"mData": function(row, type){if(type == "display") return countlyCommon.formatTimeAgo(row.actionTimes[row.step-1]/1000); else return row.actionTimes[row.step-1]/1000;}, "sType":"format-ago", "sTitle": jQuery.i18n.map["userdata.lastaction"] }
                ]
            }));
			
			this.dtablesessions.fnSort( [ [1,'desc'] ] );
			this.dtableevents.fnSort( [ [1,'desc'] ] );
			this.dtablefunnels.fnSort( [ [1,'desc'] ] );
			this.dtablesessions.stickyTableHeaders();
			this.dtableevents.stickyTableHeaders();
			this.dtablefunnels.stickyTableHeaders();
			this.updateEngagement(userDetails);
	
			this.dtablesessions.on("click", "tr", function (e){
				var nTr = this;
				var data = self.dtablesessions.fnGetData( nTr );
				if(data && data.ts){
					if($(nTr).hasClass("selected")){
						self.iMin = "";
						self.iMax = "";
						$(nTr).removeClass("selected");
						self.dtablesessions.selectedId = null;
						$("#events-timeline-description").html(jQuery.i18n.map["userdata.select-session"]);
					}
					else{
						self.iMin = data.ts;
						self.iMax = data.nts;
						$("tr", self.dtablesessions).removeClass("selected");
						$(nTr).addClass("selected");
						self.dtablesessions.selectedId = nTr.id;
						$("#events-timeline-description").html(jQuery.i18n.map["userdata.session"] + ": " + countlyCommon.getDate(data.ts/1000) +" " + countlyCommon.getTime(data.ts/1000));
					}
					self.dtableevents.fnDraw();
				}
			});

			CountlyHelpers.expandRows(this.dtablefunnels, this.formatFunnel);
			CountlyHelpers.expandRows(this.dtableevents, this.formatEvents);
			var self = this;
			self.origNote = $("#usernote-edit [contenteditable='true']").html();
			$("#userdata-note").on("keyup", "[contenteditable='true']", function (e){
				
				if(self.origNote != $(this).html()){
					var text = "";
					self.origNote = $(this).html();
					$("#usernote-edit").removeClass("fa-check").removeClass("fa-times").addClass("fa-pencil");
					if($(this).html() == "<br>"){
						$(this).html("");
					}
					else{
						//replace divs for shit+ented with br
						text = $(this).html().replace(/<div>/img, "<br>").replace(/<\/div>/img, "");
						text = text.replace(/<p>/img, "<br>").replace(/<\/p>/img, "");
						//replace br to new lines
						text = text.replace(/<br\s*\/?>/img,"\n");
					}
					if(self.timeoutNote){
						clearTimeout(self.timeoutNote);
						self.timeoutNote = null;
					}
					if(self.timeoutEditNote){
						clearTimeout(self.timeoutEditNote);
						self.timeoutEditNote = null;
					}
					self.timeoutNote = setTimeout(function(){
						$.ajax({
							type:"POST",
							url:countlyGlobal["path"]+'/usernote/edit',
							data:{
								"app_id":countlyCommon.ACTIVE_APP_ID,
								"user_id":self.user_id,
								"note":text,
								_csrf:countlyGlobal['csrf_token']
							},
							success:function (result){
								$("#usernote-edit").addClass("fa-check").removeClass("fa-pencil").removeClass("fa-times");
								self.timeoutEditNote = setTimeout(function(){$("#usernote-edit").removeClass("fa-check");}, 5000);
							},
							error:function(){
								$("#usernote-edit").addClass("fa-times").removeClass("fa-pencil").removeClass("fa-check");
							}
						});
					}, 1000);
				}
			});
			
            $(".back").click(function(){
                window.history.back();
            });
        
            self.processHistory();
        }
    },
    openedHistory: {},
    processHistory: function(){
        var self = this;
        var userDetails = countlyUserdata.getUserdetails();
        if(userDetails.history){
            for(var i in userDetails.history){
                var list = "<i class='trigger fa fa-chevron-circle-down'></i><div class='list' data-property='"+i+"'>";
                for(var j in userDetails.history[i]){
                    switch(i){
                        case "av":
                            list += "<div>"+j.replace(new RegExp(":", 'g'),".")+"</div>";
                            break;
                        case "gender":
                            if(j.toLowerCase() == "f")
                                list += "<div>"+jQuery.i18n.map["userdata.female"]+"</div>";
                            else if(j.toLowerCase() == "m")
                                list += "<div>"+jQuery.i18n.map["userdata.male"]+"</div>";
                            else
                                list += "<div>"+j+"</div>";
                            break;
                        case "byear":
                            list += "<div>"+(new Date().getFullYear() - parseInt(j))+"</div>";
                            break;
                        case "la":
                            list += "<div>"+((typeof countlyLanguage !== 'undefined') ? countlyLanguage.getLanguageName(j) : j)+"</div>";
                            break;
                        case "r":
                            if(userDetails.history[i][j] && typeof userDetails.history[i][j] == "object"){
                                for(var k in userDetails.history[i][j]){
                                    list += "<div>"+j+" ("+k+")</div>";
                                }
                            }
                            else
                                list += "<div>"+j+"</div>";
                            break;
                        case "d":
                            if(userDetails.history[i][j] && typeof userDetails.history[i][j] == "object"){
                                for(var k in userDetails.history[i][j]){
                                    if(userDetails.history[i][j][k] && typeof userDetails.history[i][j][k] == "object"){
                                        for(var m in userDetails.history[i][j][k]){
                                            list += "<div>"+countlyDevice.getDeviceFullName(j)+" ("+countlyDeviceDetails.fixOSVersion(m)+")</div>";
                                        }
                                    }
                                    else
                                        list += "<div>"+countlyDevice.getDeviceFullName(j)+" ("+k+")</div>";
                                }
                            }
                            else
                                list += "<div>"+countlyDevice.getDeviceFullName(j)+"</div>";
                            break;
                        default:
                            list += "<div>"+j+"</div>";
                    }
                }
                $("#userdata-info .user-property-"+i+" .text-right").append(list+"</div>");
            }
        }
        
        for(var i in self.openedHistory){
            if(self.openedHistory[i]){
                $("#userdata-info .user-property-"+i+" .list").show();
                $("#userdata-info .user-property-"+i+" .trigger").removeClass("fa-chevron-circle-down").addClass("fa-chevron-circle-up");
            }
        }
        
        $("#userdata-info .trigger").click(function(){
            if($(this).hasClass("fa-chevron-circle-down")){
                $(this).removeClass("fa-chevron-circle-down").addClass("fa-chevron-circle-up");
                $(this).parent().find(".list").addClass("opened").slideDown();
                self.openedHistory[$(this).parent().find(".list").data("property")] = true;
            }
            else{
                $(this).removeClass("fa-chevron-circle-up").addClass("fa-chevron-circle-down");
                $(this).parent().find(".list").removeClass("opened").slideUp();
                self.openedHistory[$(this).parent().find(".list").data("property")] = false;
            }
        });
    },
	formatFunnel: function( d ) {
		// `d` is the original data object for the row
		var str = '';
		if(d && d.steps){
			str += '<div class="datatablesubrow">'+
				'<table cellpadding="5" cellspacing="0" border="0" class="subtable">'+
				'<tr><th>Event name</th><th>Completed</th></tr>';
					for(var i = 0, l = d.steps.length; i < l; i++){
						str += '<tr>'+
							'<td>' + d.steps[i] + '</td>';
							if(d.actionTimes[i]){
								str += '<td style="color:#45b849;">' + countlyCommon.formatTimeAgo(d.actionTimes[i]/1000) + '</td>';
							}
							else{
								str += '<td>'+jQuery.i18n.map["userdata.not-completed"]+'</td>';
							}
						str += '</tr>';
					}
				str += '</table>'+
			'</div>';
		}
		return str;
	},
	formatEvents: function( d ) {
		// `d` is the original data object for the row
		var str = '';
		if(d && d.sg){
			str += '<div class="datatablesubrow">'+
			'<table cellpadding="5" cellspacing="0" border="0" style="width: 100%;">';
			if(_.isEmpty(d.sg)){
				str += '<tr><td>'+jQuery.i18n.map["userdata.no-segments"]+'</td></tr>';
			}
			else
			{
				str += '<tr><th>'+jQuery.i18n.map["userdata.segment"]+'</th><th>'+jQuery.i18n.map["userdata.value"]+'</th></tr>';
					var sg;
					for(var i in d.sg){
						str += '<tr>'+
							'<td>' + i + '</td>';
                        if(d.key == "[CLY]_crash" && i == "crash" && typeof countlyCrashes !== 'undefined')
                            str += '<td>' + countlyCrashes.getCrashName(d.sg[i]) + '</td>';
                        else
                            str += '<td>' + d.sg[i] + '</td>';
						str += '</tr>';
					}
			}
			str += '</table>';
			str += '</div>';
		}
		return str;
	},
    refresh:function () {
        var self = this;
        if(this.loaded){
            this.loaded = false;
            $.when(countlyUserdata.initialize(this.user_id, true)).then(function () {
                self.loaded = true;
                if (app.activeView != self) {
                    return false;
                }
                self.renderCommon(true);
                var userDetails = countlyUserdata.getUserdetails();
                self.templateData = {
                    "page-title":jQuery.i18n.map["userdata.title"],
                    "logo-class":"users",
                    "user":userDetails,
                    "big-numbers":{
                        "count":2,
                        "items":[
                            {
                                "title":jQuery.i18n.map["userdata.total-sessions"],
                                "total":userDetails.sessions.length,
                                "trend":userDetails.sessionTrend.trend,
                                "help":"userdata.total-sessions"
                            },
                            {
                                "title":jQuery.i18n.map["userdata.total-events"],
                                "total":userDetails.events.length,
                                "trend":userDetails.eventsTrend.trend,
                                "help":"userdata.total-events"
                            }
                        ]
                    }
                };
                newPage = $("<div>" + self.template(self.templateData) + "</div>");
                $("#userdata-main").replaceWith(newPage.find("#userdata-main"));
                $("#userdata-info").replaceWith(newPage.find("#userdata-info"));
                $("#userdata-history").replaceWith(newPage.find("#userdata-history"));
                $("#userdata-custom").replaceWith(newPage.find("#userdata-custom"));
                $("#big-numbers-container").replaceWith(newPage.find("#big-numbers-container"));
                if(userDetails.custom){
                    $("#userdata-custom").css("display", "table");
                }
                else{
                    $("#userdata-custom").css("display", "none");
                }
                countlyCommon.drawTimeGraph(userDetails.graphData, "#dashboard-graph");
    
                CountlyHelpers.refreshTable(self.dtablesessions, userDetails.sessions);
                CountlyHelpers.refreshTable(self.dtableevents, userDetails.events);
                CountlyHelpers.refreshTable(self.dtablefunnels, userDetails.funnels);
                
                CountlyHelpers.reopenRows(self.dtableevents, self.formatEvents);
                CountlyHelpers.reopenRows(self.dtablefunnels, self.formatFunnel);

                self.updateEngagement(userDetails);
                self.processHistory();
                app.localize();
                app.runRefreshScripts();

                if (self.dtablesessions.selectedId) {
                    var $selectedSessionRow = $("#"+self.dtablesessions.selectedId);
                    $selectedSessionRow.addClass("selected");

                    var data = self.dtablesessions.fnGetData($selectedSessionRow[0]);

                    if (data && data.ts) {
                        $("#events-timeline-description").html(jQuery.i18n.map["userdata.session"] + ": " + countlyCommon.getDate(data.ts/1000) +" " + countlyCommon.getTime(data.ts/1000));
                    }
                }
            });
        }
    },
	updateEngagement: function(userDetails){
		var now = new Date().getTime(),
			day = 1000*60*60*24,
			weekAgo = now-day*7,
			score1 = 0,
			score2 = 0,
			score3 = 0,
			totalScore;
		
		//medium session duration
		if(userDetails["sc"] > 0)
			score1 = Math.min(userDetails["tsdorig"]/userDetails["sc"]/60, 2);
		
		//session count in last week
		var session,
			sessionCount = 0;
		for(var i = 0, l = userDetails.sessions.length; i < l; i++){
			session = userDetails.sessions[i];
			if(session.ts >= weekAgo)
				sessionCount++;
		}
		score2 = Math.min(sessionCount, 20);
		
		//retention in last 7 days
		var timeAgo, lastTime = now;
		for(var i = 1; i <= 7; i++){
			timeAgo = now-day*i;
			for(var j = 0, l = userDetails.sessions.length; j < l; j++){
				session = userDetails.sessions[j];
				if(session.ts >= timeAgo && session.ts <= lastTime){
					lastTime = timeAgo;
					score3++;
					break;
				}
			}
		}
		
		scoreTotal = score1*score2*score3;
		
		var maxScore = 280;
		var maxEngagement = 250;
		var engagement = maxEngagement - scoreTotal/maxScore*maxEngagement;
		var text = $("#engagement-text");
        var engagementMeter = $("#engagement-meter");
        var engagementLevel = "very-low";

        engagementMeter.find(".level").removeClass("active");

        if (engagement < 50) {
            engagementLevel = "very-high";
        } else if(engagement < 100) {
            engagementLevel = "high";
        } else if(engagement < 150) {
            engagementLevel = "medium";
        } else if(engagement < 200) {
            engagementLevel = "low";
        } else if(engagement <= 250) {
            engagementLevel = "very-low";
        }

        text.text(jQuery.i18n.map["userdata." + engagementLevel]);
        text.addClass(engagementLevel);
        engagementMeter.find(".level." + engagementLevel).addClass("active");
	}
});

//register views
app.userdataView = new UserdataView();
app.userdetailsView = new UserdetailsView();

app.route('/users', 'userdata', function () {
    this.userdataView._query = null;
    this.userdataView._request = null;
    this.userdataView._filter = null;
    this.userdataView._back = null;
	this.renderWhenReady(this.userdataView);
});

app.route('/users/query/*query', 'userdata', function (query) {
    try{
        query = JSON.parse(query);
    }
    catch(ex){
        query = null;
    }
    this.userdataView._query = query;
    this.userdataView._back = true;
    this.userdataView._filter = null;
    this.userdataView._request = null;
	this.renderWhenReady(this.userdataView);
});

app.route('/users/request/*data', 'userdata', function (data) {
    try{
        data = JSON.parse(data);
    }
    catch(ex){
        data = null;
    }
    this.userdataView._query = null;
    this.userdataView._request = data;
    this.userdataView._filter = null;
    this.userdataView._back = true;
	this.renderWhenReady(this.userdataView);
});

app.route('/users/filter/*query', 'userdata', function (query) {
    try{
        query = JSON.parse(query);
    }
    catch(ex){
        query = null;
    }
    this.userdataView._query = query;
    this.userdataView._back = false;
    this.userdataView._filter = true;
    this.userdataView._request = null;
	this.renderWhenReady(this.userdataView);
});

app.route('/users/:details', 'userdetails', function (user_id) {
	this.userdetailsView.user_id = user_id;
	this.renderWhenReady(this.userdetailsView);
});

app.addPageScript("/users#", function(){
   $("#user-selector > .button").click(function () {
        if ($(this).hasClass("selected")) {
            return true;
        }

        $(".user-selector").removeClass("selected").removeClass("active");
		var filter = $(this).attr("id");
		app.activeView.filterUsers(filter);
    });
});

app.addPageScript("/drill#", function(){
    $("#drill-actions").append('<a class="link icon-button light btn-user-list"><i class="ion-person-stalker"></i><span data-localize="userdata.list"></span></a>');

    app.localize();
    $('.btn-user-list').off('click').on('click', function(){
        window.location.hash = "/users/request/"+JSON.stringify(countlySegmentation.getRequestData());
    });
});

app.addPageScript("/attribution/#", function(){
    $("#campaign-buttons").prepend('<a class="icon-button light btn-user-list" data-localize="userdata.list">User List</a>');
    app.localize();
    $('.btn-user-list').off('click').on('click', function(){
        window.location.hash = "/users/query/{\"cmp.c\":\""+countlyAttribution.getId()+"\"}";
    });
});

app.addPageScript("/crashes/#", function(){
    $("#crash-group-buttons").prepend('<a class="icon-button light btn-user-list" data-localize="userdata.list">User List</a>');
    app.localize();
    $('.btn-user-list').off('click').on('click', function(){
        window.location.hash = "/users/query/"+JSON.stringify({"crashes":countlyCrashes.getId()});
    });
});

$( document ).ready(function() {
	var menu = '<a href="#/users" class="item" id="users-menu">'+
        '<div class="logo ion-person-stalker"></div>'+
        '<div class="text" data-localize="userdata.users"></div>'+
    '</a>';
	
	if($('.sidebar-menu #management-menu').length)
		$('.sidebar-menu #management-menu').before(menu);
	else
		$('.sidebar-menu').append(menu);
    
    //check if configuration view exists
    if(app.configurationsView){
        app.configurationsView.registerLabel("users", "userdata.users");
        app.configurationsView.registerLabel("users-custom_set_limit", "userdata.custom_set_limit");
        app.configurationsView.registerLabel("users-custom_prop_limit", "userdata.custom_prop_limit");
    }
    
    jQuery.fn.dataTableExt.oSort['event-timeline-asc']  = function(x, y) {
        if(x.ts == y.ts){
            return x.cd - y.cd;
        }
        return x.ts - y.ts;
    };
    
    jQuery.fn.dataTableExt.oSort['event-timeline-desc']  = function(x, y) {
        if(x.ts == y.ts){
            return y.cd - x.cd;
        }
        return y.ts - x.ts;
    };
});