var pluginManager = require('../pluginManager.js'),
	async = require('async'),
	fs = require('fs'),
	path = require("path"),
	countlyDb = pluginManager.dbConnection();

console.log("Installing users plugin");
console.log("Creating userimages directory");
var dir = path.resolve(__dirname, '');
fs.mkdir(dir+'/../../frontend/express/public/userimages', function(){});

countlyDb.collection('apps').find({}).toArray(function (err, apps) {

    if (!apps || err) {
		console.log("No apps to upgrade");
        countlyDb.close();
        return;
    }
	function upgrade(app, done){
		console.log("Adding users indexes to " + app.name);
		var cnt = 0;
		function cb(){
			cnt++;
			if(cnt == 10)
				done();
		}
        countlyDb.collection('app_users' + app._id).ensureIndex({"uid":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"name":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"hasInfo":1, "name":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"sc":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"hasInfo":1, "sc":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"ls":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"hasInfo":1, "ls":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"tsd":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"hasInfo":1, "tsd":1},cb);
		countlyDb.collection('app_users' + app._id).ensureIndex({"name":"text", "email":"text"},cb);
	}
	async.forEach(apps, upgrade, function(){
		console.log("Users plugin installation finished");
		countlyDb.close();
	});
});